C     CORRELATOR MODULE FINDTR
C
C***********************************************************************
C
C                  FINDS STARTING COLUMN FOR TRACING
C                  IN CORRELATION MATRIX.
C
C***********************************************************************
C
      SUBROUTINE FINDTR(LINE,SNSW,CTT,*)
C
      CHARACTER*64 TXTMES
      INTEGER*4 SNSW,CTT
C
      COMMON /WIDENT/ IDENT1,IDENT2
             INTEGER*4 IDENT1(20),IDENT2(20)
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
C
      DO 100 I = 1,NPAIRS
      IF ( IDENT1(I) .EQ. SNSW ) THEN
         CTT = I
         GO TO 900
      END IF
  100 CONTINUE
      WRITE (TXTMES,2001) SNSW
 2001 FORMAT ('***** WELL ',I5,' IS NOT A REFERENCE WELL.')
      CALL GTEXTS(15,LINE+1,TXTMES)
      CALL SCHOLD
      RETURN 1
  900 RETURN
      END
C***********************************************************************
C
C                  CORRELATION TRACING TO THE LEFT
C                  OF THE STARTING REFERENCE WELL.
C
C***********************************************************************
C
      SUBROUTINE LTRACN(I)
C
      INCLUDE 'log.inc'
C
C          FLAG TO DENOTE THE PERSISTENCE OF A CORRELATION ACROSS.
      INTEGER*2 FPERS
C
      COMMON /CODINC/ DINC
      COMMON /RELETA/ ETRA
             REAL*4 ETRA(201)
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
             INTEGER*4 SNSW,CTT,NSTT
      COMMON /NCO/ NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
      COMMON /SLENTH/ SEALEN
             REAL*4 SEALEN(LOG_LENGTH,20)
      COMMON /PERCOR/ PERCO
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /IPERC/ IPER
             INTEGER*4 IPER
      COMMON /START/ STARTP
             INTEGER*4 STARTP(20)
      COMMON /WCCOEF/ WCCOE
             REAL*4 WCCOE(LOG_LENGTH,20)
      COMMON /WCCOEP/ WCCOEP
             REAL*4 WCCOEP(LOG_LENGTH,20)
      COMMON /MATCH/ MATCH
             REAL*4 MATCH(21)
      COMMON /CSTARP/ CSTARP
             INTEGER*4 CSTARP(20)
      COMMON /TWCCOE/ TWCCOE
             REAL*4 TWCCOE(20)
C
C          DEFINE STARTING ELEVATION.
C
      MATCH(CTT) = ETRA(I)
      CSTARP(CTT) = I
      LOLD = I
C
C          FIND THE MATCHING ELEVATION FOR THE CURRENT PAIR OF WELLS
C          AS A REFERENCE ELEVATION IN THE NEXT PAIR OF WELLS.
C
      DO 300 K = CTT-1,1,-1
C          EXTERNAL CORRELATIONS
      CALL NEWTRACL(I,K,*300)
      KK = K
      k20 = k + 20
      FPERS = 0
C
C          MAKE THE SEARCH FROM TOP TO BOTTOM
C          STARTING FROM THE LAST PERSISTENT CORRELATION.
C
      DO 200 L = STARTP(K),NCORRL(K)
      DELTA = COMAT(L,K20) - MATCH(K+1)
      IF ( ABS(DELTA) .LE. 0.5*COLENG(L,K) ) THEN
C
C
C          KEEP SEARCHING WHEN THE CENTER FOR THE NEXT CORRELATION
C          IS CLOSER TO THE POINTER THAN THE CURRENT CENTER.
C
         IF ( L .NE. NCORRL(K) ) THEN
            DTNEXT = COMAT(L+1,K20) - MATCH(K+1)
C
C          SEE WHETHER THE CLOSEST CORRELATION TO THE POINTER
C          LAYS WITHIN THE CURRENT CORRELATION INTERVAL OR BEYOND.
C
           IF ( ABS(DTNEXT) .LE. 0.5*COLENG(L+1,K) ) THEN
               ZHALFR = (COMAT(L,  K20)*COLENG(L+1,K) +
     1                   COMAT(L+1,K20)*COLENG(L,K))/
     2                  (COLENG(L,K) + COLENG(L+1,K))
               IF ( MATCH(K+1) .GT. ZHALFR ) GO TO 200
           END IF
C
C          FIND THE CORRELATION WINDOW FOR THE CENTER OF
C          THE CORRELATION INTERVAL IN THE MATCHING WELL.
C
            IF ( L .GT. 1) THEN
               ZHALFA = (COMAT(L,  K)*COLENG(L-1,K) +
     1                   COMAT(L-1,K)*COLENG(L,K))/
     2                  (COLENG(L,K) + COLENG(L-1,K))
            ELSE
               ZHALFA = COMAT(1,K) - COLENG(1,K)
            END IF
            ZHALFB = (COMAT(L,  K)*COLENG(L+1,K) +
     1                COMAT(L+1,K)*COLENG(L,K))/
     2               (COLENG(L,K) + COLENG(L+1,K))
            IF ( (COMAT(L,K) - DELTA) .LT. ZHALFA ) THEN
               MATCH(K) = DINC*ANINT(ZHALFA/DINC)
               GO TO 190
            END IF
            IF ( (COMAT(L,K) - DELTA) .GT. ZHALFB ) THEN
               MATCH(K) = DINC*ANINT(ZHALFB/DINC)
               GO TO 190
            END IF
         END IF
C
C          THE CORRELATION KEEPS PERSISTING.
C
         MATCH(K) = COMAT(L,K) - DELTA
  190    TWCCOE(K) = WCCOE(L,K)
         CSTARP(K) = L
         LOLD = L
         FPERS = 1
         GO TO 300
      ELSE
C
C          STOP SEARCHING WHEN CORRELATIONS ARE
C          BEYOND THE SEARCH INTERVAL.
C
         IF (DELTA .GT. SEALEN(LOLD,K) ) THEN
             CALL MISSEL(I,KK)
             GO TO 300
         END IF
      END IF
  200 CONTINUE
      IF ( FPERS .EQ. 0 ) CALL MISSEL(I,KK)
  300 CONTINUE
C
C          STORE THE PERSISTENT CORRELATION IN MATRIX.
C
         DO 350 K = CTT-1,1,-1
         PERCO(IPER,K) = MATCH(K)
         STARTP(K) = CSTARP(K)
         WCCOEP(IPER,K) = TWCCOE(K)
  350    CONTINUE
      RETURN
      END
C***********************************************************************
C
C                  INTERPOLATES AND EXTRAPOLATES NON-PERSISTENT
C                  CORRELATIONS WHILE TRACING TO THE RIGHT.
C
C***********************************************************************
C
      SUBROUTINE MISSER(II,K)
C
      INCLUDE 'log.inc'
C
      LOGICAL FAUINT
C               LAST KNOWN ELEVATION IN THE  TRACING SEQUENCE.
      REAL*4 ZMATCHK
      LOGICAL MSOFW
      LOGICAL DIFAULT(LOG_LENGTH)
C
      COMMON /CODINC/ DINC
C
      COMMON /MATCH/ MATCH
             REAL*4 MATCH(21)
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /NCO/ NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CSTARP/ CSTARP
             INTEGER*4 CSTARP(20)
      COMMON /TWCCOE/ TWCCOE
             REAL*4 TWCCOE(20)
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /MARTMS/MARTMSR, MARTMSL
C        TWO TYPES OF DEPTHS FOR MISSING MARKERS DUE TO FAULTING
C        USED BY SUBROUTINE INTERF JOINTLY WITH VARIABLE MSFLAG.
C        PROJECTION OF LEFTMOST PIECE OF MARKER INTO RIGHT WELL.
             REAL*4 MARTMSR(LOG_LENGTH,20)
C        DEPTH TO START THE TRACING AT THE NEXT PAIR OF WELLS.
             REAL*4 MARTMSL(LOG_LENGTH,20)
      COMMON /MSFLAG/MSFLAG
             LOGICAL MSFLAG(LOG_LENGTH,21)
      COMMON /SECFAUL/ SECFAUL
      COMMON /IFACO/ IFA
      COMMON /IINTA/ IINTA
      COMMON /IINTB/ IINTB
C
      K20=K+20
      ZMATCHK = MATCH(K)
C
C          FIND CLOSEST CORRELATED INTERVAL NOT LARGER THAN
C          ELEVATION TO INTERPOLATE.
C
      CALL CLOSEA(0,K,ZMATCHK,IINTA)
      IF ( IINTA .LT. 1  ) THEN
            DELTA = COMAT(1,K) - ZMATCHK
            MATCH(K+1) = COMAT(1,K20) - DELTA
            CSTARP(K) = 1
            GO TO 900
      END IF
C
C          FIND CLOSEST CORRELATED INTERVAL LARGER THAN
C          ELEVATION TO INTERPOLATE.
C
      CALL CLOSEB(0,K,ZMATCHK,IINTB)
      IF ( IINTB .GT. NCORRL(K) ) THEN
            DELTA = ZMATCHK - COMAT(NCORRL(K),K)
            MATCH(K+1) = COMAT(NCORRL(K),K20) + DELTA
            CSTARP(K) = NCORRL(K)
            GO TO 900
      END IF
C
C              CHECK FOR ONE FAULT INTERSECTING (BREACHING) BETWEEN
C              THE UPPER AND THE LOWER CORRELATIONS ON THE MATCHING 
C              WELL.  INTERPOLATE BY ADDING THE MISSING SECTION.
C
      DO 100 I = NFAULT,1,-1
      IF ( .NOT. MSFLAG(II,K)  .AND.
     1      COMAT(IINTA,K20) .LT. FINTZ(I,K+1)  .AND.
     2      COMAT(IINTB,K20) .GT. FINTZ(I,K+1)  .AND.
     3      TZU(I,1) .LE.  FINTZ(I,K+1)  .AND. 
     4      TZU(I,1) .LE.  FINTZ(I,K) 
     5       ) THEN
            IFA = I
C
C                 BREACHING FAULT DIPPING LEFT
C
         IF ( FINTZ(I,K) .GT. FINTZ(I,K+1)  .AND.
C                 LOWER CORRELATION INTERSECTED BY THE FAULT
     1        FAUINT(I,K,K+1,IINTB) ) THEN
            CB = GGROWTH(.TRUE.,I,K,COMAT(IINTB,K))
            CA = 0.0
            CZMATCH = 0.0
            DO 79 J = 1,NFAULT
C              CHECK FOR INTERSECTION OF A SECOND FAULT
C              WITH THE LOWER CORRELATION
            IF (J .NE. IFA  .AND.  FAUINT(J,K,K+1,IINTB)) THEN
                CB = CB + GGROWTH(.TRUE.,J,K,COMAT(IINTB,K))
            END IF
C              AND THE UPPER CORRELATION,
            IF (FAUINT(J,K,K+1,IINTA)) THEN
                CA = CA + GGROWTH(.TRUE.,J,K,COMAT(IINTA,K))
            END IF
C              AND THE CORRELATION TO TRACE.
            IF (J .NE. IFA  .AND.  ZMATCHK .LE. FINTZ(J,K)  .AND.
     1      COMAT(IINTB,K20)  .GT. FINTZ(J,K+1) ) THEN
                CZMATCH = CZMATCH + GGROWTH(.TRUE.,J,K,ZMATCHK)
            END IF
   79       CONTINUE  
C              FIND MATCHING
            CALL INCORR(K,IINTA,CA,IINTB,CB,ZMATCHK,MARTMSR(II,K+1)) 
            AUX =  GGROWTH(.TRUE.,I,K,ZMATCHK)
            MARTMSL(II,K+1) = MARTMSR(II,K+1) - AUX
     1               - CZMATCH
C               THREE POSSIBILITIES
C           1.  MATCHING BETWEEN BREACHING FAULT AND UPPER CORRELATION
            IF (MARTMSR(II,K+1) .LT.  FINTZ(I,K+1)  .AND.
     1          MARTMSR(II,K+1) .GE.  COMAT(IINTA,K20)) THEN
               MATCH(K+1) = MARTMSR(II,K+1)
               GO TO 800
             ELSE
C           2.  MATCHING BELOW BREACHING FAULT
               IF (MARTMSL(II,K+1) .GT.  FINTZ(I,K+1)) THEN
                     MATCH(K+1) = MARTMSL(II,K+1)
                     GO TO 800     ! 11/2002
                ELSE
C           3.  MATCHING NOT POSSIBLE--FAULTED/OUT
                  GO TO 95
               END IF
            END IF
         END IF
C
C                 BREACHING FAULT DIPPING RIGHT
C
         IF ( FINTZ(I,K) .LT. FINTZ(I,K+1)  .AND.
C                 UPPER CORRELATION INTERSECTED BY THE FAULT
     1        FAUINT(I,K,K,IINTA) ) THEN
C            aux = ggrowth(.true.,I,K, COMAT(IINTA,K))
            CA = GGROWTH(.TRUE.,I,K,COMAT(IINTA,K))
            CB = 0.0
            CZMATCH = 0.0
            DO 89 J = 1,NFAULT
C              CHEK FOR FAULTS ADDITIONALLY INTERSECTING
C              THE UPPER CORRELATION,
            IF (J .NE. IFA  .AND.  FAUINT(J,K,K,IINTA)) THEN
                CA = CA + GGROWTH(.TRUE.,J,K,COMAT(IINTA,K))
            END IF
C              AND THE LOWER CORRELATION,
            IF (FAUINT(J,K,K,IINTB)) THEN
                CB = CB + GGROWTH(.TRUE.,J,K,COMAT(IINTB,K))
            END IF
C              AND THE CORRELATION TO TRACE.
            IF (J .NE. IFA  .AND.  ZMATCHK .GE. FINTZ(J,K)  .AND.
     1          COMAT(IINTB,K20)  .LT. FINTZ(J,K+1) ) THEN
                CZMATCH = CZMATCH + GGROWTH(.TRUE.,J,K,ZMATCHK)
            END IF
   89       CONTINUE  
C              FIND MATCHING
            CALL INCORR(K,IINTA,-CA,IINTB,-CB,ZMATCHK,MARTMSR(II,K+1))
            AUX =  GGROWTH(.TRUE.,I,K,ZMATCHK)
            MARTMSL(II,K+1) = MARTMSR(II,K+1) + AUX
     1               + CZMATCH
C               THREE POSSIBILITIES
C           1.  MATCHING BETWEEN BREACHING FAULT AND LOWER CORRELATION
            IF (MARTMSR(II,K+1) .GT.  FINTZ(I,K+1)  .AND.
     1         MARTMSR(II,K+1) .LE.  COMAT(IINTB,K20)) THEN
               MATCH(K+1) = MARTMSR(II,K+1)
               GO TO 800
             ELSE
C           2.  MATCHING ABOVE BREACHING FAULT
               IF (MARTMSL(II,K+1) .LT.  FINTZ(I,K+1)) THEN
                  MATCH(K+1) = MARTMSL(II,K+1)
                  GO TO 800     ! 11/2002
                ELSE
C           3.  MATCHING NOT POSSIBLE--FAULTED/OUT
                  GO TO 95
               END IF
            END IF
         END IF
C
   95    MATCH(K+1) = FINTZ(I,K+1)
   96    MSFLAG(II,K+1) = .TRUE.
         GO TO 800
      END IF
  100 CONTINUE
C
C                FIND MATCHING DEPTH WHEN THE ELEVATION IN THE
C                REFERENCE WELL IS IN THE MISSING SECTION
C                OR BREACHING FAULT IN LEFTMOST WELL IN THE CROSS-
C                SECTION NOT INTERSECTING THE SURROUNDING  
C                CORRELATIONS.  RESTORE THE MISSING SECTION.
C
       MSOFW = .FALSE.
       DO 250 I = NFAULT,1,-1
       IF ( ( .NOT. MSFLAG(II,K)  .AND.   ! faulting in reference well
     1      COMAT(IINTA,K) .LT. FINTZ(I,K)  .AND.
     2      COMAT(IINTB,K) .GT. FINTZ(I,K)  .AND.
     3      TZU(I,1) .LE.  FINTZ(I,K+1)  .AND. 
     4      TZU(I,1) .LE.  FINTZ(I,K) )  
     x                  .OR.    ! or corrs. not intersected by fault
     1       (.NOT.( (COMAT(IINTB,K20) .GT. FINTZ(I,K+1)  .AND.
     1            COMAT(IINTB,K) .LT. FINTZ(I,K))  .OR.
     1            (COMAT(IINTB,K20) .LT. FINTZ(I,K+1)  .AND.
     1            COMAT(IINTB,K) .GT. FINTZ(I,K))  .AND.
     2            TZU(I,1) .LE.  FINTZ(I,K+1)
     3            )  .AND.
     1           .NOT.((COMAT(IINTA,K20) .GT. FINTZ(I,K+1)  .AND.
     1             COMAT(IINTA,K) .LT. FINTZ(I,K))  .OR.
     1             (COMAT(IINTA,K20) .LT. FINTZ(I,K+1)  .AND.
     1             COMAT(IINTA,K) .GT. FINTZ(I,K))  .AND.
     2             TZU(I,1) .LE.  FINTZ(I,K)
     3              )  .AND.       ! fault between correlations
     1             (COMAT(IINTA,K) .LT. FINTZ(I,K)  .AND.
     2             COMAT(IINTB,K) .GT. FINTZ(I,K))  .AND.
     1                K .EQ. 1 )
     2              ) THEN
         MSOFW = .TRUE.
         IFA = I
         GO TO 260
      END IF
  250 CONTINUE
  260 IF( MSFLAG(II,K)  .OR. MSOFW ) THEN
         I = IFA
C                 FIND POSSIBLE INTERSECTIONS BETWEEEN
C                 THE CORRELATIONS AND THE FAULTS.
         IF (.NOT. MSFLAG(II,K)) THEN
            STARTZ = ZMATCHK
          ELSE
            STARTZ = MARTMSL(II,K)
         END IF
         CALL FMISSA(K, IFA, STARTZ, ZMLOLDA, CLA, CRA)   
         CALL FMISSB(K, IFA, STARTZ, ZMLOLDB, CLB, CRB)
         IF ( FINTZ(IFA,K) .LT. FINTZ(IFA,K+1) ) THEN
            ZMLOLD = ZMLOLDB
            IF (.NOT. MSFLAG(II,K)  .AND.  ZMLOLD .GE. FINTZ(IFA,K)
     1       .AND.  COMAT(IINTB,K20)  .LT. FINTZ(IFA,K+1) )
     2         ZMLOLD = ZMLOLD + GGROWTH(.TRUE.,IFA,K,ZMLOLD)
          ELSE
            ZMLOLD = ZMLOLDA
            IF (.NOT. MSFLAG(II,K)  .AND.  ZMLOLD .LE. FINTZ(IFA,K)
     1          .AND. COMAT(IINTB,K20)  .GT. FINTZ(IFA,K+1) )
     2         ZMLOLD = ZMLOLD - GGROWTH(.TRUE.,IFA,K,ZMLOLD)
         END IF
         IF ( IFA .GT. 0) THEN  
C                 BACK TO THE LOWER BLOCK
            IF ( FINTZ(I,K-1) .GT. FINTZ(I,K)  .AND. 
     1           FINTZ(I,K+1) .GT. FINTZ(I,K)) THEN
                 MARTMSL(II,K) = MARTMSR(II,K)
                 ZMLOLD = MARTMSL(II,K)
            END IF
C                 BACK TO THE UPPER BLOCK
            IF ( FINTZ(I,K-1) .LT. FINTZ(I,K)  .AND. 
     1           FINTZ(I,K+1) .LT. FINTZ(I,K)) THEN
                 MARTMSL(II,K) = MARTMSR(II,K)
                 ZMLOLD = MARTMSL(II,K)
            END IF
         END IF
C                 MATCHING
         IF (MSOFW) MARTMSL(II,K) = MATCH(1)
         CALL INCFRW(K, IINTA, CLA, CRA, IINTB, CLB, CRB,
     1               ZMLOLD,MATCH(K+1))
C                 SEARCH FOR THE EXISTENCE OF A NEW BREACHING
C                 FAULT IN THE NEXT WELL ALSO.
         CORRMS = GGROWTH(.TRUE.,IFA,K,FINTZ(IFA,K+1))
         DIFAULT(K+1) = .FALSE.
         DO 500 I = NFAULT,1,-1
         IF ( COMAT(IINTA,K20) .LT. FINTZ(I,K+1)  .AND.
     1      COMAT(IINTB,K20) .GT. FINTZ(I,K+1)  .AND.
     2      TZU(I,1) .LE.  FINTZ(I,K)  .AND.
     2      TZU(I,1) .LE.  FINTZ(I,K+1)   .AND.
     3      I .NE. IFA) THEN
C
            IF ( (FINTZ(IFA,K) .LT. FINTZ(IFA,K+1)  .AND.
     1           (FINTZ(I,K) .LT. FINTZ(I,K+1) ))  .OR.
     2           (FINTZ(IFA,K) .LT. FINTZ(IFA,K+1)  .AND.
     3           (FINTZ(I,K) .LT. FINTZ(I,K+1) )) ) THEN
                     CORRMS = GGROWTH(.TRUE.,I,K,MARTMSL(II,K))
                     GO TO 491
            END IF
C
            IF ( FINTZ(IFA,K) .LT. FINTZ(IFA,K+1)  .AND.
     1          (FINTZ(I,K) .GT. FINTZ(I,K+1) ) ) THEN
               IF (MATCH(K+1) .LT. FINTZ(I,K+1) ) THEN 
                  GO TO 500
                ELSE IF ( FINTZ(IFA,K) .LT. FINTZ(IFA,K+1)  .AND.
     1            (FINTZ(I,K) .GT. FINTZ(I,K+1) ) ) THEN
                  CORRMS = CORRMS + GGROWTH(.TRUE.,I,K,FINTZ(I,K+1))
                  GO TO 490
               END IF
             ELSE
                  CORRMS = GGROWTH(.TRUE.,I,K,FINTZ(I,K+1))
            END IF
C
            IF ( FINTZ(IFA,K) .GT. FINTZ(IFA,K+1)  .AND.
     1          (FINTZ(I,K) .LT. FINTZ(I,K+1)  ) ) THEN
               IF (MATCH(K+1) .GT. FINTZ(I,K+1) ) THEN 
                  GO TO 500
                ELSE IF ( FINTZ(IFA,K) .GT. FINTZ(IFA,K+1)  .AND.
     1            (FINTZ(I,K) .LT. FINTZ(I,K+1)  ) ) THEN
                  CORRMS = CORRMS + GGROWTH(.TRUE.,I,K,FINTZ(I,K+1))
               END IF
             ELSE
               CORRMS = GGROWTH(.TRUE.,I,K,FINTZ(I,K+1))
            END IF
C               THERE IS INDEED ANOTHER BREACHING FAULT
  490       DIFAULT(K+1) = .TRUE.
  491       IFA = I
            GO TO 510
         END IF
  500       CONTINUE
C              NO BREACHING FAULT IN NEXT WELL
         IFA = -1
         IF ( DIFAULT(K+1) ) GO TO 510
         GO TO 550
  510    MSFLAG(II,K+1) = .TRUE.
C              TWO POSSIBILITIES:
C              1.  NO MISSING-SECTION CORRECTION REQUIRED
         MARTMSL(II,K+1) =  MATCH(K+1)
         MARTMSR(II,K+1) = MARTMSL(II,K+1)
C              2.  MISSING-SECTION CORRECTION NECESSARY
         IF ( FINTZ(I,K+1) .GT. FINTZ(I,K+2)  ) THEN
            MARTMSL(II,K+1) = MARTMSL(II,K+1) - CORRMS
            IF (DIFAULT(K+1)) THEN
               MATCH(K+1) = FINTZ(I,K+1)
             ELSE
               MATCH(K+1) = MARTMSL(II,K+1)
               IF(MATCH(K+1) .GT. FINTZ(I,K+1)) 
     1                                MSFLAG(II,K+1) = .FALSE.
            END IF
          ELSE IF ( FINTZ(I,K+1) .LT. FINTZ(I,K+2) ) THEN
            MARTMSL(II,K+1) = MARTMSL(II,K+1) + CORRMS
            IF (DIFAULT(K+1)) THEN
               MATCH(K+1) = FINTZ(I,K+1)
             ELSE
               MATCH(K+1) = MARTMSL(II,K+1)
               IF(MATCH(K+1) .LT. FINTZ(I,K+1)) 
     1                                MSFLAG(II,K+1) = .FALSE.
            END IF
         END IF
  550 GO TO 800
      END IF
C
C                 SIMPLE CASE--NO MISSING SECTION.
C
      CALL INCORR(K, IINTA, 0.0,IINTB,0.0,ZMATCHK,MATCH(K+1))           
  800 CSTARP(K) = IINTA
  900 TWCCOE(K) = -2.0
      MATCH(K+1) = ANINT(MATCH(K+1)/DINC)*DINC
      RETURN
      END
C***********************************************************************
C
C                  INTERPOLATES AND EXTRAPOLATES NON-PERSISTENT
C                  CORRELATIONS WHILE TRACING TO THE RIGHT.
C
C***********************************************************************
C
      SUBROUTINE INCORR(K,IINTA,CA,IINTB,CB,ZMATCHK, ZINT)
C
C      INTERPOLATION OF CORRELATION TO THE RIGHT OF THE CROSS-SECTION.
C      FAULT--THUS MISSING SECTION--AT MATCHING WELL.
C
C***********************************************************************
C
C
      INCLUDE 'log.inc'
C
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
      COMMON /SECFAUL/ SECFAUL
C
      K20=K+20
      ZLA = COMAT(IINTA,K)
      ZA = COMAT(IINTA,K20) + CA
      ZLB = COMAT(IINTB,K)
      ZB = COMAT(IINTB,K20) + CB
      IF ( (ZB - ZA) .GT.
     1     (0.5*(COLENG(IINTA,K) + COLENG(IINTB,K))) ) THEN
         DELTAA = ZMATCHK - ZLA - 0.5*COLENG(IINTA,K)
         DELTAB = ZLB - ZMATCHK - 0.5*COLENG(IINTB,K)
         FACTR1 = (ZB - 0.5*COLENG(IINTB,K)) -
     1            (ZA + 0.5*COLENG(IINTA,K))
         FACTR2 = DELTAA/(DELTAA + DELTAB)
         ZINT=ZA + 0.5*COLENG(IINTA,K) + (FACTR1*FACTR2)
  
       ELSE
         ZINT = (ZA*COLENG(IINTB,K) + ZB*COLENG(IINTA,K))/
     1                (COLENG(IINTA,K) + COLENG(IINTB,K))
       END IF
       RETURN
       END
      SUBROUTINE INCORL(K, IINTA, IINTB, CA, CB, ZMATCHK, ZINT)
C
C       INTERPOLATION OF CORRELATION TO THE LEFT OF THE CROSS-SECTION.
C       FAULT--THUS MISSING SECTION--AT REFERENCE WELL.
C
C***********************************************************************
C
C
      INCLUDE 'log.inc'
C
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
      COMMON /SECFAUL/ SECFAUL
      K20=K+20
      ZA = COMAT(IINTA,K) + CA
      ZAR = COMAT(IINTA,K20)
      ZB = COMAT(IINTB,K) + CB
      ZBR = COMAT(IINTB,K20)
      IF ( (COMAT(IINTB,K) - COMAT(IINTA,K)) .GT.
     1     (0.5*(COLENG(IINTA,K) + COLENG(IINTB,K))) ) THEN
            DELTAA = ZMATCHK - ZAR - 0.5*COLENG(IINTA,K)
            DELTAB = ZBR - ZMATCHK - 0.5*COLENG(IINTB,K)
         FACTR1 = ZB - ZA -
     1            0.5*(COLENG(IINTA,K) + COLENG(IINTB,K))
         FACTR2 = DELTAA/(DELTAA + DELTAB)
         ZINT = ZA + 0.5*COLENG(IINTA,K) + (FACTR1*FACTR2)
       ELSE
         ZINT = (ZA*COLENG(IINTB,K) + ZB*COLENG(IINTA,K))/
     1                (COLENG(IINTA,K) + COLENG(IINTB,K))
       END IF
       RETURN
       END
      SUBROUTINE INCFRW(K, IINTA, CLA, CRA, 
     1                     IINTB, CLB, CRB, ZMATCHK, ZINT)
C
C       INTERPOLATION OF CORRELATION TO THE RIGHT OF THE CROSS-SECTION.
C       FAULT--THUS MISSING SECTION--AT REFERENCE WELL.
C
C***********************************************************************
C
C
      INCLUDE 'log.inc'
C
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
C
      K20=K+20
      ZAL = COMAT(IINTA,K) + CLA
      ZBL = COMAT(IINTB,K) + CLB
      ZAR = COMAT(IINTA,K20) + CRA
      ZBR = COMAT(IINTB,K20) + CRB
      IF ( (COMAT(IINTB,K20) - COMAT(IINTA,K20)) .GT.
     1     (0.5*(COLENG(IINTA,K) + COLENG(IINTB,K))) ) THEN
         DELTAA = ZMATCHK - ZAL - 0.5*COLENG(IINTA,K)
         DELTAB = ZBL - ZMATCHK - 0.5*COLENG(IINTB,K)
         FACTR1 = (ZBR - 0.5*COLENG(IINTB,K)) -
     1            (ZAR + 0.5*COLENG(IINTA,K))
         FACTR2 = DELTAA/(DELTAA + DELTAB)
         ZINT=ZAR + 0.5*COLENG(IINTA,K) + (FACTR1*FACTR2)
       ELSE
         ZINT = (ZAR*COLENG(IINTB,K) +
     1                ZBR*COLENG(IINTA,K))/
     1                (COLENG(IINTA,K) + COLENG(IINTB,K))
       END IF
   
       RETURN
       END
      SUBROUTINE INCFLW(K, IINTA, IINTB, CA, CB, ZMATCHK, ZINT)
C
C      INTERPOLATION OF CORRELATION TO THE LEFT OF THE CROSS-SECTION.
C      FAULT--THUS MISSING SECTION--AT MATCHING WELL.
C
C***********************************************************************
C
C
      INCLUDE 'log.inc'
C
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
C
      K20=K+20
      ZA = COMAT(IINTA,K20) + CA
      ZB = COMAT(IINTB,K20) + CB
      IF ( (COMAT(IINTB,K20) - COMAT(IINTA,K20)) .GT.
     1     (0.5*(COLENG(IINTA,K) + COLENG(IINTB,K))) ) THEN
         DELTAA = ZMATCHK - ZA - 0.5*COLENG(IINTA,K)
         DELTAB = ZB - ZMATCHK - 0.5*COLENG(IINTB,K)
         FACTR1 = (COMAT(IINTB,K) - 0.5*COLENG(IINTB,K)) -
     1            (COMAT(IINTA,K) + 0.5*COLENG(IINTA,K))
         FACTR2 = DELTAA/(DELTAA + DELTAB)
         ZINT=COMAT(IINTA,K) + 0.5*COLENG(IINTA,K) + (FACTR1*FACTR2)
       ELSE
         ZINT = (COMAT(IINTA,K)*COLENG(IINTB,K) +
     1                COMAT(IINTB,K)*COLENG(IINTA,K))/
     1                (COLENG(IINTA,K) + COLENG(IINTB,K))
       END IF
       RETURN
       END
C***********************************************************************
C
C                  INTERPOLATES AND EXTRAPOLATES NON-PERSISTENT
C                  CORRELATIONS WHILE TRACING TO THE LEFT.
C
C***********************************************************************
C
      SUBROUTINE MISSEL(II,K)
C
      INCLUDE 'log.inc'
C
      LOGICAL FAUINT
C
      LOGICAL MSOFW
C               LAST KNOWN ELEVATION IN THE  TRACING SEQUENCE.
      REAL*4 ZMATCHK
C
      COMMON /CODINC/ DINC
C
      COMMON /MATCH/ MATCH
             REAL*4 MATCH(21)
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /NCO/ NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CSTARP/ CSTARP
             INTEGER*4 CSTARP(20)
      COMMON /TWCCOE/ TWCCOE
             REAL*4 TWCCOE(20)
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /MARTMS/MARTMSR, MARTMSL
C        TWO TYPES OF DEPTHS FOR MISSING MARKERS DUE TO FAULTING
C        USED BY SUBROUTINE INTERF JOINTLY WITH VARIABLE MSFLAG.
C        PROJECTION OF RIGHTMOST PIECE OF MARKER INTO LEFT WELL.
             REAL*4 MARTMSR(LOG_LENGTH,20)
C        DEPTH TO START THE TRACING AT THE NEXT PAIR OF WELLS.
             REAL*4 MARTMSL(LOG_LENGTH,20)
      COMMON /MSFLAG/MSFLAG
             LOGICAL MSFLAG(LOG_LENGTH,21)
      COMMON /SECFAUL/ SECFAUL
      COMMON /IFACO/ IFA
      COMMON /IINTA/ IINTA
      COMMON /IINTB/ IINTB
      COMMON /TIELF/ TIELF
             LOGICAL TIELF(MAX_NO_FAULTS)
C            SPECIAL CORRECTION TO TAKE INTO ACCOUNT INTERSECTION
C            OF MARKER BY A FAULT NOT INTERSECTING THE MARKER
C            AT WELL PAIR TO THE RIGHT WHEN TRACING LEFT AND 
C            "MSFLAG(II,K+1)" IS TRUE.  USED ALSO AT ROUTINE INTERF.
      COMMON /TLCOMP/ TLCOMP
             REAL*4 TLCOMP(LOG_LENGTH,20)
C
      K20=K+20
      ZMATCHK = MATCH(K+1)
C
C          FIND CLOSEST CORRELATED INTERVAL NOT LARGER THAN
C          ELEVATION TO INTERPOLATE.
C
      CALL CLOSEA(1,K,ZMATCHK,IINTA)
      IF ( IINTA .LT. 1) THEN
         DELTA = COMAT(1,K20) - ZMATCHK
         MATCH(K) = COMAT(1,K) - DELTA
         CSTARP(K) = 1
         GO TO 900
      END IF
C
C          FIND CLOSEST CORRELATED INTERVAL LARGER THAN
C          ELEVATION TO INTERPOLATE.
C
      CALL CLOSEB(1,K,ZMATCHK,IINTB)
      IF ( IINTB .GT. NCORRL(K) ) THEN
         DELTA = ZMATCHK - COMAT(NCORRL(K),K20)
         MATCH(K) = COMAT(NCORRL(K),K) + DELTA
         CSTARP(K) = NCORRL(K)
         GO TO 900
      END IF
C
C                 CHECK FOR A FAULT INTERSECTION BETWEEN THE
C                 UPPER AND THE LOWER CORRELATIONS ON THE REFERENCE 
C                 WELL.  INTERPOLATE BY ADDING THE MISSING SECTION.
C
C      DO 100 I = 1,NFAULT     !11/2002
      DO 100 I = 1,NFAULT     !11/2002
      IF ( .NOT. MSFLAG(II,K+1)  .AND.
     1       COMAT(IINTA,K) .LT. FINTZ(I,K)  .AND.
     1       COMAT(IINTB,K) .GT. FINTZ(I,K)  .AND.
     3       TZU(I,1) .LE.  FINTZ(I,K+1)  .AND.    !  added 11/2002
     2       TZU(I,1) .LE.  FINTZ(I,K)) THEN
         IFA = I
C
C                 BREACHING FAULT DIPPING LEFT
C
         IF ( (FINTZ(I,K) .GT. FINTZ(I,K+1))  .AND.
C                 UPPER CORRELATION INTERSECTED BY THE FAULT
     1        FAUINT(I,K,K+1,IINTA) ) THEN
            CA = GGROWTH(.FALSE.,I,K,COMAT(IINTA,K))
C              CHECK FOR ADDITIONAL FAULTS INTERSECTING
C              THE LOWER CORRELATION.
            CB = 0.0
            CZMATCH = 0.0
            DO 79 J = 1,NFAULT
            IF ( J .NE. IFA  .AND.
     1         FAUINT(J,K,K+1,IINTB) ) THEN
               CB = CB + GGROWTH(.FALSE.,J,K,COMAT(IINTB,K))
C           ADDITIONAL INTERSECTIONS WITH TRACING,
C           APPROXIMATE SOLUTION SINCE CORR. OF ZMATCHK IN K UNKNOWN.
            IF (J .NE. IFA  .AND.  COMAT(IINTB,K) .LT. FINTZ(J,K)
     1          .AND.  ZMATCHK  .GT. FINTZ(J,K+1) )
     2         CZMATCH = CZMATCH + GGROWTH(.FALSE.,J,K,COMAT(IINTA,K)
     3            - ZMATCHK + COMAT(IINTA,K20))
            END IF
   79       CONTINUE
C              CHECK FOR INTERSECTION OF ADDITIONAL FAULTS
C              WITH THE UPPER CORRELATION
            CALL CHKIFLT(K,K+1,IINTA,CLA)
C              INTERPOLATE
            CALL INCORL(K, IINTA, IINTB,  
     1          -CA-CLA, -CB,ZMATCHK,MARTMSL(II,K)) 
            MARTMSR(II,K) = MARTMSL(II,K) + CA + CZMATCH
C               THREE POSSIBILITIES
C           1.  MATCHING BETWEEN BREACHING FAULT AND LOWER CORRELATION
            IF (MARTMSL(II,K) .GT.  FINTZ(I,K)  .AND.
     1          MARTMSL(II,K) .LT.  COMAT(IINTB,K)) THEN
               MATCH(K) = MARTMSL(II,K)
               GO TO 800
C           2.  MATCHING BETWEEN BREACHING FAULT AND UPPER CORRELATION
             ELSE IF (MARTMSR(II,K) .LT.  FINTZ(I,K)) THEN
               MATCH(K) = MARTMSR(II,K)
               GO TO 800
             ELSE
C           3.  MATCHING NOT POSSIBLE--FAULTED/OUT
               MATCH(K) = FINTZ(I,K)
               MSFLAG(II,K) = .TRUE.
               GO TO 800
            END IF
         END IF
C
C                 BREACHING FAULT DIPPING RIGHT
C
         IF ( (FINTZ(I,K) .LT. FINTZ(I,K+1))  .AND.
C                 LOWER CORRELATION INTERSECTED BY THE FAULT
     1        FAUINT(I,K,K,IINTB) ) THEN
            CB = GGROWTH(.FALSE.,I,K,COMAT(IINTB,K))
C              CHEK FOR ADDITIONAL FAULTS INTERSECTING
C              THE UPPER CORRELATION.
            CA = 0.0
            CZMATCH = 0.0
            DO 89 J = 1,NFAULT
            TIELF(J) = .FALSE.
            IF ( J .NE. IFA  .AND.
     1         FAUINT(J,K,K,IINTA) ) THEN
               CA = CA + GGROWTH(.FALSE.,J,K,COMAT(IINTA,K))
C           ADDITIONAL INTERSECTIONS WITH TRACING,
C           APPROXIMATE SOLUTION SINCE CORR. OF ZMATCHK IN K UNKNOWN.
               IF (J .NE. IFA  .AND.  COMAT(IINTA,K) .GT. FINTZ(J,K)
     1            .AND.  ZMATCHK  .LT. FINTZ(J,K+1) ) THEN
                  TIELF(J) = .TRUE.
                  CZMATCH = CZMATCH + GGROWTH(.FALSE.,J,K,
     3                    COMAT(IINTA,K) + ZMATCHK - COMAT(IINTA,K20))
               END IF
            END IF
   89       CONTINUE
C              CHECK FOR INTERSECTION OF A SECOND FAULT
C              WITH THE LOWER CORRELATION
            CALL CHKIFLT(K,K,IINTB,CLB)
C              INTERPOLATE
            CALL INCORL(K, IINTA, IINTB, 
     1          CA,CB+CLB,ZMATCHK,MARTMSL(II,K))
            MARTMSR(II,K) = MARTMSL(II,K) - CB - CZMATCH
C               THREE POSSIBILITIES
C           1.  MATCHING BETWEEN BREACHING FAULT AND UPPER CORRELATION
            IF (MARTMSL(II,K) .LT.  FINTZ(I,K)  .AND.
     1          MARTMSL(II,K) .GT.  COMAT(IINTA,K)) THEN
               MATCH(K) = MARTMSL(II,K)
               GO TO 800
C           2.  MATCHING BETWEEN BREACHING FAULT AND UPPER CORRELATION
             ELSE IF (MARTMSR(II,K) .GT.  FINTZ(I,K)) THEN
               MATCH(K) = MARTMSR(II,K)
               GO TO 800
             ELSE
C           3.  MATCHING NOT POSSIBLE--FAULTED/OUT
               MATCH(K) = FINTZ(I,K)
               MSFLAG(II,K) = .TRUE.
               IF (MARTMSL(II,K) .GT. FINTZ(I,K)  .AND.
     1             MARTMSR(II,K) .LT. FINTZ(I,K) )  TIELF(I) = .TRUE.
               GO TO 800
            END IF
         END IF
      END IF
  100 CONTINUE
C
C                FIND MATCHING DEPTH WHEN THE ELEVATION IN THE
C                MATCHING WELL IS IN THE MISSING SECTION
C                OR BREACHING FAULT IN RIGHTMOST WELL IN THE CROSS-
C                SECTION NOT INTERSECTING THE SURROUNDING  
C                CORRELATIONS.  RESTORE THE MISSING SECTION.
C
       MSOFW = .FALSE.
       DO 250 I = NFAULT,1,-1
       IF ( ( .NOT. MSFLAG(II,K+1)  .AND.
     1      COMAT(IINTA,K20) .LT. FINTZ(I,K+1)  .AND.
     2      COMAT(IINTB,K20) .GT. FINTZ(I,K+1)  .AND.
     3      TZU(I,1) .LE.  FINTZ(I,K+1)  .AND. 
     4      TZU(I,1) .LE.  FINTZ(I,K) )  
     2              ) THEN
         MSOFW = .TRUE.
         IFA = I
         GO TO 260
      END IF
  250 CONTINUE
  260 IF( MSFLAG(II,K+1)  .OR. MSOFW ) THEN
         I = IFA
         IF (.NOT. MSFLAG(II,K+1)) THEN
            STARTZ = ZMATCHK
          ELSE
            STARTZ = MARTMSR(II,K+1)
         END IF
C                 FIND POSSIBLE INTERSECTIONS BETWEEEN
C                 THE CORRELATIONS AND THE FAULTS.
         CALL FMISSAML(K, IFA, STARTZ, CLA, CRA, CZM)   
         CALL FMISSBML(K, IFA, STARTZ, CLB, CRB)
         IF (.NOT. MSFLAG(II,K+1)) THEN
            SHIFT = CZM
          ELSE
            TLCOMP(II,K+1) = CORTIEL(K,STARTZ-SHIFT)
            SHIFT = 0.0
         END IF
C
C                 MATCHING
C
         IF ( FINTZ(I,K) .LT. FINTZ(I,K+1) ) THEN
            CALL INCFLW(K, IINTA, IINTB, -CRA, -CRB,
     1               STARTZ-SHIFT-TLCOMP(II,K+1),MARTMSL(II,K))
            CORREC = CRB + CZM
          ELSE
            CALL INCFLW(K, IINTA, IINTB, CLA, CLB,
     1               STARTZ+SHIFT,MARTMSL(II,K))
            CORREC = -CRA - CZM
         END IF
         IF (.NOT. MSFLAG(II,K+1)) THEN
            MARTMSR(II,K) = MARTMSL(II,K) + CORREC
          ELSE
            MARTMSR(II,K) = MARTMSL(II,K)
         END IF
         IF ( FINTZ(I,K) .LT. FINTZ(I,K1) ) THEN   !dipping right
C               THREE POSSIBILITIES
C           1.  MATCHING BETWEEN BREACHING FAULT AND UPPER CORRELATION
            IF (STARTZ .LT.  FINTZ(I,K20)  .AND.
     1          STARTZ .GT.  COMAT(IINTA,K20)) THEN
               MATCH(K) = MARTMSL(II,K)
               GO TO 800
C           2.  MATCHING BETWEEN BREACHING FAULT AND UPPER CORRELATION
             ELSE IF (STARTZ .GT.  FINTZ(I,K20)) THEN
               MATCH(K) = MARTMSR(II,K)
               GO TO 800
C           3.  MATCHING FOR MARKER IN MISSING SECTION
             ELSE IF (MSFLAG(II,K+1)) THEN
               MATCH(K) = MARTMSL(II,K)
               GO TO 800
             ELSE
C           4.  MATCHING NOT POSSIBLE--FAULTED/OUT
               MATCH(K) = FINTZ(I,K)
               MSFLAG(II,K) = .TRUE.
               GO TO 800
            END IF
          ELSE          ! dipping left
C               FOUR POSSIBILITIES
C           1.  START BETWEEN BREACHING FAULT AND LOWER CORRELATION
            IF (STARTZ .GT.  FINTZ(I,K20)  .AND.
     1          STARTZ .LT.  COMAT(IINTB,K20)) THEN
               MATCH(K) = MARTMSL(II,K)
               GO TO 800
C           2.  MATCHING BETWEEN BREACHING FAULT AND UPPER CORRELATION
             ELSE IF (STARTZ .LT.  FINTZ(I,K20)) THEN
               MATCH(K) = MARTMSR(II,K)
               GO TO 800
C           3.  MATCHING FOR MARKER IN MISSING SECTION
             ELSE IF (MSFLAG(II,K+1)) THEN
               MATCH(K) = MARTMSR(II,K)
               GO TO 800
             ELSE 
C           4.  MATCHING NOT POSSIBLE--FAULTED/OUT
               MATCH(K) = FINTZ(I,K)
               MSFLAG(II,K) = .TRUE.
               GO TO 800
            END IF
         END IF
      END IF
C
C                 NORMAL CASE--NO FAULT INTERFERENCE.
C
      CALL INCORL(K, IINTA, IINTB, 0.0, 0.0,ZMATCHK,MATCH(K))
  800 CSTARP(K) = IINTA
  900 TWCCOE(K) = -2.0
      MATCH(K) = ANINT(MATCH(K)/DINC)*DINC
      RETURN
      END                                           !     MISSEL
C***********************************************************************
C
C                 FINDS CLOSEST CORRELATED INTERVAL NOT LARGER
C                 THAN THE ELEVATIONS TO INTERPOLATE.
C
C***********************************************************************
C
      SUBROUTINE CLOSEA(LR,K,Z,IINT)
C
      INCLUDE 'log.inc'
C
C          FLAG TO SHOW DIRECTION OF TRACING.
      INTEGER*4 LR
C
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /NCO/ NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
C
      IINT = -1
      DELTAZ = 1.0E31
      DO 100 I = 1,NCORRL(K)
      IF (LR .EQ. 0) THEN
         J = K
        ELSE
         J = K + 20
        END IF
      IF ( COMAT(I,J) .LE. Z ) THEN
         CLOEST = COMAT(I,J) + 0.5*COLENG(I,K)
         DIFER = Z - CLOEST
         IF ( DIFER .LE. DELTAZ ) THEN
            DELTAZ = DIFER
            IINT = I
           END IF
        ELSE
         GO TO 900
        END IF
  100 CONTINUE
  900 RETURN
      END
C***********************************************************************
C
C                 FINDS CLOSEST CORRELATED INTERVAL BUT LARGER
C                 THAN THE ELEVATIONS TO INTERPOLATE.
C
C***********************************************************************
C
      SUBROUTINE CLOSEB(LR,K,Z,IINT)
C
      INCLUDE 'log.inc'
C
C          FLAG TO SHOW DIRECTION OF TRACING.
      INTEGER*4 LR
C
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /NCO/ NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
C
      IINT = 1 + NCORRL(K)
      DELTAZ = 1.0E31
      DO 100 I = NCORRL(K),1,-1
      IF (LR .EQ. 0) THEN
         J = K
      ELSE
         J = K + 20
      END IF
      IF ( COMAT(I,J) .GE. Z ) THEN
         CLOEST = COMAT(I,J) - 0.5*COLENG(I,K)
         DIFER = CLOEST - Z
         IF ( DIFER .LE. DELTAZ ) THEN
            DELTAZ = DIFER
            IINT = I
         END IF
      ELSE
         GO TO 900
      END IF
  100 CONTINUE
  900 RETURN
      END
      SUBROUTINE FMISSA(K, IFA, ZMARTMSL, ZMLOLD, CLA, CRA)
C
C         FINDS MISING SECTION CORRECTION FOR THE UPPER
C         SURROUNDING CORRELATION AROUND A MISSING SECTION
C         IN THE REFERENCE WELL.
C
C*********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /IINTA/ IINTA
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /MATCH/ MATCH
             REAL*4 MATCH(21)
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
C
      K1 = K + 1
      K20 = K + 20
      CLA = 0.0
      CRA = 0.0
      ZMLOLD = ZMARTMSL
      DO 100 I = 1,NFAULT
C
C        FAULT DIPPING TO THE RIGHT.
C
      IF ( FINTZ(I,K) .LT. FINTZ(I,K1) ) THEN
C        INTERSECTION
         IF ( COMAT(IINTA,K20) .LT. FINTZ(I,K+1)  .AND.
     1        COMAT(IINTA,K) .GT. FINTZ(I,K)  .AND.
     2        TZU(I,1) .LE.  FINTZ(I,K)) THEN
            CRA = -GGROWTH(.TRUE.,I,K,COMAT(IINTA,K))
            GO TO 200
         END IF
       ELSE
C
C        FAULT DIPPING TO THE LEFT
C
         IF ( COMAT(IINTA,K20) .GT. FINTZ(I,K+1)  .AND.
     1        COMAT(IINTA,K) .LT. FINTZ(I,K)  .AND.
     2        TZU(I,1) .LE.  FINTZ(I,K+1)) THEN
            IF ( I .EQ. IFA ) THEN
               CLA = CLA - GGROWTH(.TRUE.,I,K,COMAT(IINTA,K))
             ELSE
               CLA = CLA - GGROWTH(.TRUE.,I,K,ZMARTMSL)
               IF (TZU(IFA,1) .LE.  FINTZ(IFA,K+1))
     1            ZMLOLD = ZMLOLD - GGROWTH(.TRUE.,I,K,ZMARTMSL)
            END IF
            GO TO 100
         END IF
      END IF
  100 CONTINUE
  200 CONTINUE
      RETURN
      END
      SUBROUTINE FMISSB(K, IFA, ZMARTMSL, ZMLOLD, CLB, CRB)
C
C         FINDS MISING SECTION CORRECTION FOR THE LOWER
C         SURROUNDING CORRELATION AROUND A MISSING SECTION
C         IN THE REFERENCE WELL.
C
C*********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /IINTB/ IINTB
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /MATCH/ MATCH
             REAL*4 MATCH(21)
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
C
      K1 = K + 1
      K20 = K + 20
      CLB = 0.0
      CRB = 0.0
      ZMLOLD = ZMARTMSL
      DO 100 I = 1,NFAULT
C
C        FAULT DIPPING TO THE RIGHT.
C
      IF ( FINTZ(I,K) .LT. FINTZ(I,K1) ) THEN
C        INTERSECTION
         IF ( COMAT(IINTB,K20) .LT. FINTZ(I,K+1)  .AND.
     1        COMAT(IINTB,K) .GT. FINTZ(I,K)  .AND.
     2        TZU(I,1) .LE.  FINTZ(I,K)) THEN
            IF ( I .EQ. IFA ) THEN
               CLB = CLB + GGROWTH(.TRUE.,I,K,COMAT(IINTB,K))
             ELSE
               CLB = CLB + GGROWTH(.TRUE.,I,K,ZMARTMSL)
               ZMLOLD = ZMLOLD + GGROWTH(.TRUE.,I,K,ZMARTMSL)
            END IF
            GO TO 100
         END IF
       ELSE
C
C        FAULT DIPPING TO THE LEFT
C
         IF ( COMAT(IINTB,K20) .GT. FINTZ(I,K+1)  .AND.
     1        COMAT(IINTB,K) .LT. FINTZ(I,K)  .AND.
     2        TZU(I,1) .LE.  FINTZ(I,K+1)) THEN
            CRB = GGROWTH(.TRUE.,I,K,COMAT(IINTB,K))
            GO TO 200
         END IF
      END IF
  100 CONTINUE
  200 CONTINUE
      RETURN
      END
      SUBROUTINE NEWTRACL(I,K,*)
C
C           MARKER VALUES PROVIDED BY THE USER.  THE NEW VALUES
C           ARE EQUIVALENT TO PROVIDE A NEW STARTING ELEVATION FOR
C           THE TRACING IN WELLS TO THE RIGHT OF THE STARTING
C           TRACING WELL.
C
C              I:  MARKER SEQUENTIAL NUMBER
C              K:  SEQUENTIAL NUMBER FOR PAIR OF CORRELATED WELLS
C
C********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /MATCH/  MATCH
C            ELEVATION OF A PERSISTANT CORRELATION AT EACH WELL.
             REAL*4 MATCH(21)
      COMMON /TWCCOE/ TWCCOE
C            TEMPORARY STORAGE FOR WEIGHTED CORRELATION COEFFICIENTS.
             REAL*4 TWCCOE(20)
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /STEPOUT/ SODEPTH,SOPAIR,SOMARKER
             REAL*4 SODEPTH(LOG_LENGTH)
             INTEGER*4 SOPAIR(LOG_LENGTH)
             INTEGER*4 SOMARKER(LOG_LENGTH)
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            NUMBER OF ELEVATION TO TRACE ACROSS.
             INTEGER*4 NETRA
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            CORRELATION MATRIX COLUMN FOR TRACE STARTING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
C
      IF ( .NOT.(MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'LIT2')) GO TO 900
C
      IF (NSTT .EQ. 0) GO TO 900
      DO 100 J = 1, NSTT
      IF ( K  .EQ. SOPAIR(J)  .AND. I  .EQ. SOMARKER(J) ) THEN
          MATCH(K) = SODEPTH(J)
          TWCCOE(K) = 2.0
          RETURN 1
      END IF
  100 CONTINUE
  900 RETURN
      END
      SUBROUTINE CHKIFLT(K,KF,IINT,CLB)
C
C********************************************************************
C
C          ACCOUNT FOR INTERSECTION OF TIE LINE OF
C          CORRELATION AND THE TRACE OF A FAULT.
C
C********************************************************************
C
      INCLUDE 'log.inc'
C
      LOGICAL FAUINT
C
      COMMON /SECFAUL/ SECFAUL
C
      COMMON /IFACO/ IFA
C
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
C
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
C
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
C
      SECFAUL = 0.0
      CLB = 0.0
      K20 = K + 20
      DO 100 J = 1,NFAULT
      IF ( J .NE. IFA  .AND.
     1       FAUINT(J,K,KF,IINT) ) THEN
         CLB = GGROWTH(.FALSE.,J,K,COMAT(IINT,K))
         SECFAUL = FINTZ(J,K)
         GO TO 200
      END IF
  100 CONTINUE
  200 RETURN
      END
      LOGICAL FUNCTION FAUINT(I,K,KF,IINT)
C
C********************************************************************
C
C          CHECK FOR INTERSECTION OF TIE LINE OF
C          CORRELATION AND THE TRACE OF A FAULT.
C
C********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
C
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
C
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
C
      K20 = K + 20
      IF( ((COMAT(IINT,K20) .GT. FINTZ(I,K+1)  .AND.  ! Corr. steepest
     1      COMAT(IINT,K) .LT. FINTZ(I,K))  .OR.
     2     (COMAT(IINT,K20) .LT. FINTZ(I,K+1)  .AND.  ! Fault steepest
     3      COMAT(IINT,K) .GT. FINTZ(I,K)))  .AND.
     4      TZU(I,1) .LE.  FINTZ(I,KF) )  THEN
          FAUINT = .TRUE.
        ELSE
          FAUINT = .FALSE.
       END IF
       RETURN
       END
      SUBROUTINE FMISSAML(K, IFA, ZMATCH, CLA, CRA, CZM)
C
C         FINDS MISING SECTION CORRECTION FOR THE UPPER
C         SURROUNDING CORRELATION AROUND A MISSING SECTION
C         IN THE MATCHING WELL.
C
C*********************************************************************
C
      INCLUDE 'log.inc'
C
      LOGICAL FAUINT
C
      COMMON /IINTA/ IINTA
      COMMON /IINTB/ IINTB
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /MATCH/ MATCH
             REAL*4 MATCH(21)
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
C
      K1 = K + 1
      K20 = K + 20
      CLA = 0.0
      CRA = 0.0
      CZM = 0.0
      DO 100 I = 1,NFAULT
C
C        FAULT DIPPING TO THE RIGHT.
C
      IF ( FINTZ(I,K) .LT. FINTZ(I,K1) ) THEN
C        INTERSECTION FAULT-CORRELATION
         IF ( FAUINT(I,K,K,IINTA) ) THEN
            CRA = CRA + GGROWTH(.FALSE.,I,K,COMAT(IINTA,K))
         END IF
C        INTERSECTION FAULT-TIE LINE
C        APPROXIMATE SOLUTION SINCE CORR. OF ZMATCH AT K IS UNKNOWN.
         IF (COMAT(IINTA,K) .GT. FINTZ(I,K)  .AND.
     1      ZMATCH  .LT. FINTZ(I,K+1) ) THEN
              CZM = CZM + GGROWTH(.FALSE.,I,K,
     1         COMAT(IINTA,K) + (ZMATCH - COMAT(IINTA,K20)))
         END IF
       ELSE
C
C        FAULT DIPPING TO THE LEFT
C
         IF ( FAUINT(I,K,K+1,IINTA)) THEN
C        INTERSECTION FAULT-CORRELATION
               CLA = CLA + GGROWTH(.FALSE.,I,K,COMAT(IINTA,K))
         END IF
C        INTERSECTION FAULT-TIE LINE
C        APPROXIMATE SOLUTION SINCE CORR. OF ZMATCH AT K IS UNKNOWN.
         IF (COMAT(IINTB,K) .LT. FINTZ(I,K)  .AND.
     1      ZMATCH  .GT. FINTZ(I,K+1) ) THEN
              CZM = CZM + GGROWTH(.FALSE.,I,K,
     1         COMAT(IINTB,K) - (ZMATCH - COMAT(IINTB,K20)))
         END IF
      END IF
  100 CONTINUE
      RETURN
      END
      SUBROUTINE FMISSBML(K, IFA, ZMATCH, CLB, CRB)
C
C         FINDS MISING SECTION CORRECTION FOR THE LOWER
C         SURROUNDING CORRELATION AROUND A MISSING SECTION
C         IN THE MATCHING WELL.
C
C*********************************************************************
C
      INCLUDE 'log.inc'
C
      LOGICAL FAUINT
C
      COMMON /IINTB/ IINTB
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /MATCH/ MATCH
             REAL*4 MATCH(21)
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
C
      K1 = K + 1
      K20 = K + 20
      CLB = 0.0
      CRB = 0.0
      ZMLOLD = ZMARTMSL
      DO 100 I = 1,NFAULT
C
C        FAULT DIPPING TO THE RIGHT.
C
      IF ( FINTZ(I,K) .LT. FINTZ(I,K1) ) THEN
C        INTERSECTION FAULT-CORRELATION
         IF ( FAUINT(I,K,K,IINTB) ) THEN
               CRB = CRB + GGROWTH(.FALSE.,I,K,COMAT(IINTB,K))
         END IF
       ELSE
C
C        FAULT DIPPING TO THE LEFT
C
C        INTERSECTION FAULT-CORRELATION
         IF ( FAUINT(I,K,K+1,IINTB)) THEN
            CLB = CLB + GGROWTH(.FALSE.,I,K,COMAT(IINTB,K))
         END IF
      END IF
  100 CONTINUE
      RETURN
      END
