C     CORRELATOR MODULE PLTCOR
C 
C***********************************************************************
C
C                    PLOTTING OF CORRELATION TABLE
C
C***********************************************************************
C
      SUBROUTINE PLTCOR(RLOG1,IL1,RLOG2,IL2,RLOG3,IL3,RLOG4,IL4,DIGS1,
     1     DIGS2,TOPZR,BBOTZR,TOPZM,BBOTZM,YSP1,NPS,NPAIRS)
C
      INCLUDE 'log.inc'
C
C          VARIABLE DEFINITION.
C          FLAG TO DENOTE FIRST CORRELATION LINE INTERSECTED BY FAULT
      LOGICAL FSTTIME
C          ELEVATION FOR THE CENTER OF THE PLOT FOR THE MATCHING WELL.
      REAL*4 CENTEM
C          ELEVATION FOR THE CENTER OF THE PLOT FOR THE REFERENCE WELL.
      REAL*4 CENTER
C          CORRELATION LENGTH, FEET.
      REAL*4 CORLEN
C          ELEVATION FOR THE BOTTOM OF THE DEEPEST LOG.
      REAL*4 DEND
C          STARTING ELEVATION FOR DIGITIZATION ON REFERENCE WELL, FEET.
      REAL*4 DIGS1
C          STARTING ELEVATION FOR DIGITIZATION ON MATCHING WELL, FEET.
      REAL*4 DIGS2
C          HALF THE LENGTH OF THE INTERVAL TO PLOT.
      REAL*4 HPLTLGR, HPLTLGM
C          TOP OF SHADED INTERVAL.
      INTEGER*4 IC1
C          BOTTOM OF SHADED.
      INTEGER*4 IC2
C          NUMBER OF POINTS FOR CORRELATION LOG AT REFERENCE WELL.
      INTEGER*4 IL1
C          NUMBER OF POINTS FOR CORRELATION LOG AT THE MATCHING WELL.
      INTEGER*4 IL2
C          NUMBER OF POINTS FOR SHALE LOG AT THE REFERENCE WELL.
      INTEGER*4 IL3
C          NUMBER OF POINTS FOR SHALE LOG AT THE MATCHING WELL.
      INTEGER*4 IL4
C          DIGITIZED VALUES FOR CORRELATION LOG AT REFERENCE WELL.
      REAL*4 RLOG1(LOG_LENGTH)
C          DIGITIZED VALUES FOR CORRELATION LOG AT THE MATCHING WELL.
      REAL*4 RLOG2(LOG_LENGTH)
C          DIGITIZED VALUES FOR SHALE LOG AT THE REFERENCE WELL.
      REAL*4 RLOG3(LOG_LENGTH)
C          DIGITIZED VALUES FOR SHALE LOG AT THE MATCHING WELL.
      REAL*4 RLOG4(LOG_LENGTH)
C          WEIGHTED CORRELATION COEFFICIENT
      REAL*4 WCCOE
C          REFERENCE DEPTH, FEET.
      REAL*4 Z1L
C          MATCHING DEPTH, FEET.
      REAL*4 Z2L
C
      LOGICAL PETROPHYSICS
C
      COMMON /POLIN/ POLIN
C            OPTION TO EITHER DRAW LINE OR PAINT
             CHARACTER*1 POLIN(LOG_LENGTH)
C
      COMMON /MARPEN/ MARPEN
C            PEN NUMBER.
             INTEGER*4 MARPEN(201)
C
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
      COMMON /SLENTH/ SEALEN
             REAL*4 SEALEN(LOG_LENGTH,20)
      COMMON /WCCOEF/ WCCOEX
             REAL*4 WCCOEX(LOG_LENGTH,20)
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /SHADE/ KSHADR,KSHADM
             INTEGER*2 KSHADR(LOG_LENGTH),KSHADM(LOG_LENGTH)
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /PERCOR/ PERCO
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /IPERC/ IPER
             INTEGER*4 IPER
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /WCCOEP/ WCCOEP
             REAL*4 WCCOEP(LOG_LENGTH,20)
      COMMON /DATMZZ/ DATUMZ
             REAL*4 DATUMZ(21)
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
C
      COMMON /CODINC/ DINC
      COMMON /SHADOP/ SHADOP
             INTEGER*2 SHADOP
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTZ/ FINTZL,FINTZR
             REAL*4 FINTZL(MAX_NO_FAULTS)
             REAL*4 FINTZR(MAX_NO_FAULTS)
      COMMON /BBOTM/ BBOTM
      COMMON /TEQCOR/ TEQCOR(LOG_LENGTH,40)
      COMMON /DCI/ DCI
             CHARACTER*1 DCI
      COMMON /IPERCO/ IPERCO
             INTEGER*4 IPERCO(20)
      COMMON /DSLDEE/ DSHAL(21),DDEEP(21)
      COMMON /DDEEPM/ DDEEPM(21)
      COMMON /MSFLAG/MSFLAG
             LOGICAL MSFLAG(LOG_LENGTH,21)
      COMMON /RBOTZ/ RBOTZ
      COMMON /SCALI/ SCALI
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
C
      COMMON /SWITCH/ SWITCH
C            INDICATOR OF MARKER (.TRUE.) OR CORRELATION (.FALSE.).
      LOGICAL SWITCH
      COMMON /IOLD/ IOLD
      COMMON /PENSH/ PENSH
              INTEGER*4 PENSH
      COMMON /L/ L
      COMMON /LITHF/ LITHF
      COMMON /NCO/    NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CTRMODE/ TRMODE
      LOGICAL TRMODE
C
      include 'corrdb.inc'
C
      PETROPHYSICS = MENU .EQ. 'LITH'  .OR.  MENU .EQ. 'PORO'  .OR.
     1               MENU .EQ. 'LIT2'
C
C
C         FAULT INTERSECTIONS.
C
      FSTTIME = .TRUE.
      IF( IFAULT .EQ. 1 ) THEN
         TZUMIN = TZU(1,1)
         DO 90 I = 1,NFAULT
         IF (TZU(I,1) .LT. TZUMIN) TZUMIN = TZU(I,1)
         FINTZL(I) = XTOP + ((FINTZ(I,NPS) - TOPZR)/VSCALE)
         FINTZR(I) = XTOP + ((FINTZ(I,NPS+1) - TOPZM)/VSCALE)
   90    CONTINUE
      END IF
      L = 0
      NUPEN = 0 !BGR
C
C         EXTREMES
C
      CALL CENWID(TOPZR,BBOTZR,CENTER,HPLTLGR)
      CALL CENWID(TOPZM,BBOTZM,CENTEM,HPLTLGM)
      IF (DATUMF .EQ. 1 ) THEN
         BOTZR = RBOTZ
         BOTZM = RBOTZ
       ELSE
         BOTZR = BBOTZR
         BOTZM = BBOTZM
       END IF
      IF (AELG .EQ. 1  .OR.
     1   ((AELG .EQ. 0)  .AND.  (NPS .EQ. 1)  .AND.  
     2    (LITHF .EQ. 1  .OR.  LITHF .EQ. 3))) 
     3       YLEFT=0.05+YSP1+(2.0*TKWD)+DSWH
      HWDIST= HDISTC(NPS)
      YRIGHT=YLEFT+(HWDIST/HSCALE)
      CALL SHADBL(KSHADR,IL1,KSHADM,IL2)
      LSTPEN=-1
C
C          RETRIEVE.
C
  200 IF( MENU .EQ. 'PERS'  .OR.  MENU .EQ. 'TRAC') THEN
         L = L + 1
         IF ( L .GT. IPER ) GO TO 300
         Z1L = PERCO(L,NPS)
         Z2L = PERCO(L,NPS+1)
         WCCOE = WCCOEP(L,NPS)
         TRMODE = POLIN(L) .EQ. 'P'  .OR.  POLIN(L) .EQ. 'B'
         CORLEN = 0.0
         IF(MENU .EQ. 'TRAC'  .AND.  TRMODE) THEN
C            IF (WCCOE .GT. 1.0) GO TO 270
            IF (L .LT. IPER) THEN
               IF (((PERCO(L+1,NPS)-PERCO(L,NPS)) .LT. DINC)  .AND.
     1             ((PERCO(L+1,NPS+1)-PERCO(L,NPS+1)) .LT. DINC) ) THEN
                  PERCO(L,NPS) = 1.0E20
                  GO TO 200
               END IF
            END IF
            SWITCH = .TRUE.
         END IF
      ELSE
         IF ( MENU .EQ. 'SECT'  .AND.  DCI .EQ. 'C' ) THEN    !
            L=L+1
            IF (L .GT. NCORRL(NPS)) GO TO 300
            Z1L=COMAT(L,NPS)
            Z2L=COMAT(L,NPS+20)
            CORLEN=COLENG(L,NPS)
            WCCOE =WCCOEX(L,NPS)
            TRMODE = POLIN(L) .EQ. 'P'  .OR.  POLIN(L) .EQ. 'B'
          ELSE
            L = L + 1
            IF ( L .GT. IPERCO(NPS) ) GO TO 300
            Z1L = TEQCOR(L,2*NPS-1)
            Z2L = TEQCOR(L,2*NPS)
            WCCOE = WCCOEP(L,NPS)
            CORLEN = 0.0
            TRMODE = POLIN(L) .EQ. 'P'  .OR.  POLIN(L) .EQ. 'B'
         END IF
      END IF
C
C          SHADE CORRELATED INTERVALS ON REFERENCE WELL.
C
      HFCORL=0.5*CORLEN
      ICORLN=ANINT(HFCORL/DINC)
  202 continue
      IF ( (MSFLAG(L,NPS)  .AND.  SHADOP .EQ. 2  .AND.
     1      MENU .EQ. 'TRAC'  .AND.  TRMODE  .AND. SWITCH)
     3                     .OR.
     4         (MSFLAG(L,NPS)  .AND.  SHADOP .EQ. 2  .AND.
     5          MENU .EQ. 'TRAC'  .AND. POLIN(L) .EQ. 'L'))  GO TO 210
      IF ( MENU .EQ. 'TRAC'  .AND.  SHADOP .EQ. 1)  THEN
         IF ( L .LT. IPER  .AND.  MARPEN(L) .EQ. MARPEN(L+1)) THEN
            IC1=ANINT(((Z1L-DIGS1)/DINC + 1.0))
            IC2=ANINT(((PERCO(L+1,NPS)-DIGS1)/DINC + 1.0))
          ELSE
         IF((Z1L+HFCORL).LT.TOPZR .OR. (Z1L-HFCORL).GT.BOTZR) GO TO 210
            IC1=ANINT(((Z1L-DIGS1)/DINC + 1.0)) - ICORLN
            IC2=ANINT(((Z1L-DIGS1)/DINC + 1.0)) + ICORLN
         END IF
       ELSE
         IF((Z1L+HFCORL).LT.TOPZR .OR. (Z1L-HFCORL).GT.BOTZR) GO TO 210
         IC1=ANINT(((Z1L-DIGS1)/DINC + 1.0)) - ICORLN
         IC2=ANINT(((Z1L-DIGS1)/DINC + 1.0)) + ICORLN
      END IF
      IF (IC1 .LT.   1) IC1=1
      IF (IC2 .GT. IL1) IC2=IL1
      IF(NPS.NE.1 .AND. AELG.EQ.0) GO TO 205
      IF (MENU .EQ. 'TRAC') THEN
         nupen=marpen(l)
        ELSE
         nupen=5
        ENDIF
      IF ( MENU .EQ. 'PERS' .OR. MENU .EQ. 'SECT')
     1                        CALL PENSET(WCCOE,NUPEN)
      IF ( MENU .EQ. 'LITH' ) 
     1      CALL LITYPE(Z1L, DIGS1, 'R', SH1, ILINE, NUPEN)
      IF ( MENU .EQ. 'PORO') 
     1      CALL POROSCALE(Z1L, DIGS1, 'R', SH1, ILINE, NUPEN)
      IF ( MENU .EQ. 'LIT2') CALL FCLITH(Z1L,DIGS1,'R',NPS,SH,NUPEN)
      DO 204 I=IC1,IC2
      IF (KSHADR(I) .EQ. 0) KSHADR(I)=NUPEN
  204 CONTINUE
      GO TO 210
C          DO NOT SHADOW BUT SET COUNTERS FOR INDICES COMPUTATION.
  205 DO 207 I=IC1,IC2
      KSHADR(I)=0
  207 CONTINUE
C
C          DRAW A LINE BETWEEN THE CENTER OF THE CORRELATIONS.
C
  210 IF ( MENU .EQ. 'SECT'  .OR.  MENU .EQ. 'PERS' )
     1    CALL PENSET(WCCOE,NUPEN)
      IF ( MENU .EQ. 'TRAC') NUPEN=MARPEN(L)
      IF (NUPEN .NE. LSTPEN) THEN
         CALL GMPLCR(NUPEN)
         LSTPEN=NUPEN
        ENDIF
      IF(Z1L.LE.TOPZR .AND. Z2L.LE. TOPZM) GO TO 260
      IF(MENU .EQ. 'TRAC') THEN
         IF(Z1L.GE.BOTZR .AND. Z2L.GE.BOTZM  .AND.
     1                             NPS .NE. NPAIRS) GO TO 260
         IF(Z1L .LT. DIGS1  .OR.  Z2L .LT. DIGS2) GO TO 260
       ELSE
         IF(Z1L.GE.BOTZR .AND. Z2L.GE.BOTZM) GO TO 260
      END IF
      XZ1=XTOP+((Z1L-TOPZR)/VSCALE)
      YZ1=YLEFT
      XZ2=XTOP+((Z2L-TOPZM)/VSCALE)
      YZ2=YRIGHT
C
C               CONSIDER THE EFFECT OF FAULTING.
C
      IF( IFAULT .EQ. 2 
     1       .OR. (IFAULT .EQ. 1  .AND.  Z1L .LT. TZUMIN)
     2                 ) THEN
C
C               NO FAULTS.
C
          IF ( MENU .EQ. 'LITH') THEN
            CALL LITYPE(Z1L, DIGS1, 'R', SH1, ILINE1, NUPEN)
            CALL LITYPE(Z2L, DIGS2, 'M', SH2, ILINE2, NUPEN)
            CALL MCLINE(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFT,WCCOE,
     1           XZ1,YZ1,XZ2,YZ2, SH1, ILINE1, SH2, ILINE2,0.2)
          ELSE IF ( MENU .EQ. 'PORO') THEN
            CALL POROSCALE(Z1L, DIGS1, 'R', SH1, ILINE1, NUPEN)
            CALL POROSCALE(Z2L, DIGS2, 'M', SH2, ILINE2, NUPEN)
            CALL MCLINE(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFT,WCCOE,
     1           XZ1,YZ1,XZ2,YZ2, SH1, ILINE1, SH2, ILINE2,SCALI)
          ELSE IF ( MENU .EQ. 'LIT2') THEN
            CALL FCLITH(Z1L,DIGS1,'R',NPS,SH1,NUPEN1)
            CALL FCLITH(Z2L,DIGS2,'M',NPS,SH2,NUPEN2)
            IF (NUPEN1 .NE. PENSH  .AND.  NUPEN2 .NE. PENSH  .AND.
     1          NUPEN1 .NE. NUPEN2) WRITE(91,"('*** WARNING: ',
     2          'AT PAIR ',I2, ' LITHOLOGY ',I2,' AT DEPTH ',F10.2,
     3          ' CHANGED TO LITHOLOGY ',I2,' AT DEPTH ',F10.2)")
     4          NPS, NUPEN1,Z1L,NUPEN2,Z2L
            CALL MCLINE2(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFT,
     1           XZ1,YZ1,XZ2,YZ2, SH1, NUPEN1, SH2, NUPEN2)
         ELSE
            CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFT,
     1               -999, WCCOE,XZ1,YZ1,XZ2,YZ2)
         END IF
         SMS = 0.0
       ELSE IF( .NOT.(MENU .EQ. 'TRAC'  .AND.  POLIN(L) .EQ. 'P'
     1                 .AND.  WCCOE .LT. -1.0)) THEN
C                   DRAW THE MARKERS CONSIDERING THE FAULTING.
         CALL DRAWFS(NPS,L,WCCOE,XZ1,YZ1,XZ2,YZ2,NCLOFL,SMS,NIF,
     1               TOPZR,BOTZR,TOPZM,BOTZM,Z1L,DIGS1,Z2L,DIGS2,
     2               FSTTIME)                   ! RAO 2/2002
C     1               TOPZR,BOTZR,TOPZM,BOTZM) ! RAO 2/2000
      END IF
C
C          SHADE CORRELATED INTERVALS ON MATCHING WELL.
C
  260 IF(NPS.NE.NPAIRS .AND. AELG.EQ.0) GO TO 270
      IF ( (MSFLAG(L,NPS+1)   .AND.  SHADOP .EQ. 2  .AND.
     1      MENU .EQ. 'TRAC'  .AND.  TRMODE  .AND. SWITCH)
     3                      .OR.
     4     (MSFLAG(L,NPS+1)   .AND.  SHADOP .EQ. 2  .AND.
     5      MENU .EQ. 'TRAC'  .AND.  POLIN(L) .EQ. 'L') )  GO TO 270
      IF ( MENU .EQ. 'TRAC'  .AND.  SHADOP .EQ. 1) THEN
      IF (  L .LT. IPER  .AND.  MARPEN(L) .EQ. MARPEN(L+1)) THEN
         IC1=ANINT(((Z2L-DIGS2)/DINC + 1.0))
         IC2=ANINT(((PERCO(L+1,NPS+1)-DIGS2)/DINC + 1.0))
       ELSE
      IF((Z2L+HFCORL).LT.TOPZM .OR. (Z2L-HFCORL).GT.BOTZM) GO TO 270
         IC1=ANINT(((Z2L-DIGS2)/DINC + 1.0)) - ICORLN
         IC2=ANINT(((Z2L-DIGS2)/DINC + 1.0)) + ICORLN
      END IF
       ELSE
         IF((Z2L+HFCORL).LT.TOPZM .OR. (Z2L-HFCORL).GT.BOTZM) GO TO 270
         IC1=ANINT(((Z2L-DIGS2)/DINC + 1.0)) - ICORLN
         IC2=ANINT(((Z2L-DIGS2)/DINC + 1.0)) + ICORLN
      END IF
      IF (IC1 .LT.   1) IC1=1
      IF (IC2 .GT. IL2) IC2=IL2
      IF ( MENU .EQ. 'TRAC') THEN                      !jlc 7/25/90
         nupen=marpen(l)                               !jlc 7/25/90
      else                                             !jlc 7/25/90
         nupen=5                                       !jlc 7/25/90
      endif                                            !jlc 7/25/90
      IF ( MENU .EQ. 'PERS' .OR. MENU .EQ. 'SECT')
     1                        CALL PENSET(WCCOE,NUPEN)
      IF ( MENU .EQ. 'LITH' ) 
     1        CALL LITYPE(Z2L, DIGS2, 'M', SH, ILINE, NUPEN)
      IF ( MENU .EQ. 'PORO') 
     1        CALL POROSCALE(Z2L, DIGS2, 'M', SH, ILINE, NUPEN)
      IF ( MENU .EQ. 'LIT2') CALL FCLITH(Z2L,DIGS2,'M',NPS,SH,NUPEN)
      DO 264 I=IC1,IC2
      IF (KSHADM(I) .EQ. 0) KSHADM(I)=NUPEN
  264 CONTINUE
  270 IF (MENU .EQ. 'TRAC'  .AND.  TRMODE)
     1      CALL PAINT(Z1L,Z2L,L,IPERCO(NPS),IPER,NPS,WCCOE,*202,*200)
      GO TO 200
C
C...  SHADE LOGS
C
  300 continue
c      if(nps .gt. 1 ) return
      CALL PSHADW(RLOG3,IL3,RLOG1,IL1,DIGS1, BOTZM,
     1            CENTER,HPLTLGR,NPS,NPAIRS,YSP1,KSHADR,'R')
c     it is wrong here
      IF( AELG .EQ. 0 ) THEN
         YSP2=0.05+YLEFT+(HWDIST/HSCALE)
      ELSE
         YSP2=0.1+YSP1+(2.0*TKWD)+DSWH+(HWDIST/HSCALE)
      END IF
      CALL PSHADW(RLOG4,IL4,RLOG2,IL2,DIGS2, BOTZM,
     1            CENTEM,HPLTLGM,NPS,NPAIRS,YSP2,KSHADM,'M')
C
C          DRAW BOX.
C
      DEND1=DIGS1+(AMAX0(IL1,IL3)*DINC)-DINC
      DEND2=DIGS2+(AMAX0(IL2,IL4)*DINC)-DINC
      BBOT = XBOT
      IF ( DATUMF .EQ. 2) THEN
         DEND = AMAX1(DEND1-DATUMZ(NPS),DEND2-DATUMZ(NPS+1))
         IF ( DEND1 .LT. BOTZR .AND. DEND2 .LT. BOTZM
     1                         .AND. AELG .EQ. 1) THEN
            IF ( (DEND1-DATUMZ(NPS)) .GT. (DEND2-DATUMZ(NPS+1))) THEN
               BBOT = XTOP + ((DEND1 - TOPZR)/VSCALE)
            ELSE
               BBOT = XTOP + ((DEND2 - TOPZM)/VSCALE)
            END IF
        END IF
      ELSE
      BBOT = AMIN1(XBOT,XTOP + ((BOTZR - TOPZR)/VSCALE))
      END IF
      BBOT = AMIN1(XBOT,XTOP + ((BOTZR - TOPZR)/VSCALE))
      IF ( XTOP .GE. BBOT ) GO TO 900
      CALL GMPLCR(5)
      IF ( DATUMF .EQ. 1 ) THEN
         CALL PLTBSUR(NPS,NPAIRS,1,BBOT,YRIGHT,YLEFT)
       ELSE
         CALL PLTBOX(NPS,NPAIRS,1,XTOP,BBOT,YRIGHT,YLEFT)
      END IF
      IF (BBOT. GT. BBOTM) BBOTM = BBOT
 900  RETURN
      END
C***********************************************************************
C
C               PLOTS A BOX IN WHICH THE TOP MAY BE AN 
C               INCLINED LINE REPRESENTING THE SURFACE
C
C***********************************************************************
C
      SUBROUTINE PLTBSUR(NPS,NPAIRS,AELG,BBOT,YRIGHT,YLEFT)
C
      INTEGER AELG
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C        LOCATION OF TOP OF WELLS, INCHES, WHICH ARE THE KELLY
C        BUSHINGS IN CASE THE DISPLAY STARTS ABOVE THE LAND SURFACE.
      COMMON /KBINCH/XLEFT,YDOWN, XRIGHT, YUP
C
      YDOWN = YLEFT
      YUP = YRIGHT
      DLEFT = CSTART + DATUM1
      DRIGHT = CSTART + DATUM2
      STEP = ABS(DLEFT)*(YRIGHT - YLEFT)/(ABS(DLEFT) + ABS(DRIGHT))   
C        A.  KELLY BUSHINGS ABOVE DISPLAY
      IF (DLEFT*DRIGHT .GE. 0.0) THEN
         XLEFT = XTOP
         XRIGHT = XTOP
C        B.  SURFACE 100% INSIDE DISPLAY
         IF ( DLEFT .LE. 0  .AND.  DRIGHT .LE. 0) THEN
            XLEFT = XTOP - DLEFT/VSCALE
            XRIGHT = XTOP - DRIGHT/VSCALE
         END IF
C        DRAW BOX FOR CASES A AND B.
         CALL GMPMOV(XRIGHT,YRIGHT)
         CALL GMPDRW(XLEFT,YLEFT)
         CALL GMPDRW(BBOT,YLEFT)
         CALL GMPDRW(BBOT,YRIGHT)
         IF ((NPS .EQ. NPAIRS  .AND.  AELG .EQ. 0) .OR. AELG .EQ. 1)
     1      CALL GMPDRW(XRIGHT,YRIGHT)
C        C.  LEFT KELLY BUSHING ABOVE DISPLAY
       ELSE IF (DLEFT .GT. 0) THEN
         XLEFT = XTOP
         XRIGHT = XTOP-DRIGHT/VSCALE
         YDOWN = YLEFT+STEP
         CALL GMPMOV(XRIGHT,YRIGHT)
         CALL GMPDRW(XLEFT,YDOWN)
         CALL GMPDRW(XLEFT,YLEFT)
         CALL GMPDRW(BBOT,YLEFT)
         CALL GMPDRW(BBOT,YRIGHT)
         IF ((NPS .EQ. NPAIRS  .AND.  AELG .EQ. 0) .OR. AELG .EQ. 1)
     1      CALL GMPDRW(XRIGHT,YRIGHT)
       ELSE
C        D.  RIGHT KELLY BUSHING ABOVE DISPLAY
         XLEFT = XTOP-DLEFT/VSCALE
         XRIGHT = XTOP
         YUP = YLEFT+STEP
         CALL GMPMOV(XRIGHT,YRIGHT)
         CALL GMPDRW(XRIGHT,YUP)
         CALL GMPDRW(XLEFT,YLEFT)
         CALL GMPDRW(BBOT,YLEFT)
         CALL GMPDRW(BBOT,YRIGHT)
         IF ((NPS .EQ. NPAIRS  .AND.  AELG .EQ. 0) .OR. AELG .EQ. 1)
     1      CALL GMPDRW(XTOP,YRIGHT)
      END IF
      RETURN
      END
C***********************************************************************
C
C               PLOTS A BOX.
C
C***********************************************************************
C
      SUBROUTINE PLTBOX(NPS,NPAIRS,AELG,XTOP,BBOT,YRIGHT,YLEFT)
C
      INTEGER AELG
C
      CALL GMPMOV(XTOP,YRIGHT)
      CALL GMPDRW(XTOP,YLEFT)
      CALL GMPDRW(BBOT,YLEFT)
      CALL GMPDRW(BBOT,YRIGHT)
      IF ((NPS .EQ. NPAIRS  .AND.  AELG .EQ. 0) .OR. AELG .EQ. 1)
     1 CALL GMPDRW(XTOP,YRIGHT)
      RETURN
      END
C***********************************************************************
C
C                    SHADE CORRELATED INTERVALS.
C
C***********************************************************************
C
      SUBROUTINE PSHADW(RLOG1,IL1,RLOG2,IL2,DSTART, BOTZM,
     X                  CDEPTH,DWIND,NPS,NPAIRS,YL1,ISHADE,ROM)
C
C          VARIABLE DEFINITION
C
      INCLUDE 'log.inc'
C
      CHARACTER*1 ROM
      REAL RLOG1(IL1),RLOG2(IL2)
      INTEGER*2 ISHADE(LOG_LENGTH)
      LOGICAL SSHADE
      INTEGER DEPSEQ
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /LOGMAX/ SHLLMX,CORLMX
      COMMON /USCAL / BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /CODINC/ DINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      Y20=YL1+TKWD
      Y27=Y20+DSWH
      Y47=Y27+TKWD
      ICPTH1=ANINT((CDEPTH-DSTART)/DINC+1.0)
      IDINT=DWIND/DINC+0.55
      IDS=MAX0(  1,ICPTH1-IDINT)
      IDE=MIN0(IL1,ICPTH1+IDINT)
      IDADJ=ICPTH1-IDINT
      SCALE=DINC/VSCALE
      XEND=XTOP+(SCALE*FLOAT(IDE-IDADJ))
C
C          SHADOW SHALE LOG.
C
      SSHADE = AELG.EQ.1 .AND. NPS.NE.NPAIRS .AND. ROM.EQ.'M'
      IF(AELG.EQ.1 .AND. NPS.GT.1 .AND. ROM.EQ.'R') GO TO 1215
C
C          SHALE LOG EXTREMES.
C
      RMIN1=+1.0E 30
      RMAX1=-RMIN1
      DO 121 I=IDS,IDE
      R=RLOG1(I)
      RMIN1=AMIN1(R,RMIN1)
      RMAX1=AMAX1(R,RMAX1)
  121 CONTINUE
      IF ( SHLLMX .LT. 0.0) THEN
         RRR = RMAX1
        ELSE
         RRR = SHLLMX
        ENDIF
      YSCALC=TKWD/(RRR-RMIN1)
      LSTPEN=-1
      IF ( MENU .EQ. 'TRAC'  .AND.  
     1           NPS .EQ. NPAIRS  .AND.  ROM .EQ. 'M' ) THEN 
         IFINAL = DEPSEQ(BOTZM, DSTART, DINC)
       ELSE
         IFINAL = IDE
      END IF
      DO 122 I=IDS,IFINAL
      MARPEN=ISHADE(I)
      IF (MARPEN .EQ. 0) GO TO 122
      IF (MARPEN .NE. LSTPEN) THEN
         CALL GMPLCR(MARPEN)
         LSTPEN=MARPEN
        ENDIF
      X=XTOP+FLOAT(I-IDADJ)*SCALE
      IF ((X .LT. XTOP) .OR. (X .GT. XEND)) GO TO 122
      IF (RLOG1(I) .GT. RRR) THEN
          CALL MOVPEN(RRR,     RMIN1,YSCALC,YL1,Y20,SCLSHL,Y)
         ELSE
          CALL MOVPEN(RLOG1(I),RMIN1,YSCALC,YL1,Y20,SCLSHL,Y)
         ENDIF
      CALL GMPMOV(X,Y)
      CALL GMPDRW(X,Y20)
  122 CONTINUE
C
C          SHADOW CORRELATION LOG.
C
 1215 IF (SSHADE) GO TO 1216
C
C          CORRELATION LOG EXTREMES.
C
      RMIN2=+1.0E 30
      RMAX2=-RMIN2
      DO 123 I=IDS,IDE
      R=RLOG2(I)
      RMIN2=AMIN1(R,RMIN2)
      RMAX2=AMAX1(R,RMAX2)
  123 CONTINUE
      IF ( CORLMX .LT. 0.0 ) THEN
         RRR=RMAX2
        ELSE
         RRR=CORLMX
        ENDIF
      YSCALC=TKWD/(RRR-RMIN2)
      LSTPEN=-1
C      DO 124 I=IDS,IFINAL   !BGR
      DO 124 I=IDS,IDE    !BGR
      MARPEN=ISHADE(I)
      IF (MARPEN .EQ. 0) GO TO 124
      IF (MARPEN .NE. LSTPEN) THEN
         CALL GMPLCR(MARPEN)
         LSTPEN=MARPEN
        ENDIF
      X=XTOP+FLOAT(I-IDADJ)*SCALE
      IF (RLOG2(I) .GT. RRR) THEN
         CALL MOVPEN(RRR     ,RMIN2,YSCALC,Y27,Y47,SCLCOL,Y)
        ELSE
         CALL MOVPEN(RLOG2(I),RMIN2,YSCALC,Y27,Y47,SCLCOL,Y)
        END IF
      CALL GMPMOV(X,Y27)
      CALL GMPDRW(X,Y)
  124 CONTINUE
 1216  RETURN
      END
C***********************************************************************
C
C                  LOG TYPES.
C
C***********************************************************************
C
      SUBROUTINE LGSLAB(YMID,ROM)
C
      CHARACTER*1 ROM
C
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LOGSZ/LOGSZ
      REAL*4 LOGSZ
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
C
      IF(ROM.EQ.'R') THEN
         FDELEV = DATUM1
       ELSE
         FDELEV = DATUM2
      END IF
      DELTA = CSTART + FDELEV   ! CSTART & FDELEV have different signs
      IF (DATUMF .EQ. 1  .AND.  DELTA .LT. 0.0) THEN
         XLL = XTOP - 0.1 - DELTA/VSCALE    
       ELSE
         XLL = XTOP - 0.1    
      END IF
      CALL GMPLCR(1)
C     
      FFSET = 0.5*(DSWH + TKWD)
      IF ( ROM .EQ. 'R') THEN
C          Publication
C         CALL GMPTXT('Shale, percentage',XLL-0.15,YMID-FFSET,0.8*LOGSZ,90.0,JUSTIF)
C         CALL GMPTXT('0              100',XLL+0.05,YMID-FFSET,0.8*LOGSZ,90.0,JUSTIF)
C         CALL GMPTXT('GR, API units',XLL-0.15,YMID+FFSET,0.8*LOGSZ,90.0,JUSTIF)
C         CALL GMPTXT('240              9',XLL+0.05,YMID+FFSET,0.8*LOGSZ,90.0,JUSTIF)
         CALL GMPTXT(IDSHAR,XLL,YMID-FFSET,LOGSZ,90.0,JUSTIF)
         CALL GMPTXT(IDCORR,XLL,YMID+FFSET,LOGSZ,90.0,JUSTIF)
       ELSE
C          Publication
C         CALL GMPTXT('Shale, percentage',XLL-0.15,YMID-FFSET,0.8*LOGSZ,90.0,JUSTIF)
C         CALL GMPTXT('0              100',XLL+0.05,YMID-FFSET,0.8*LOGSZ,90.0,JUSTIF)
C         CALL GMPTXT('GR, API units',XLL-0.15,YMID+FFSET,0.8*LOGSZ,90.0,JUSTIF)
C         CALL GMPTXT('210             14',XLL+0.05,YMID+FFSET,0.8*LOGSZ,90.0,JUSTIF)
         CALL GMPTXT(IDSHAM,XLL,YMID-FFSET,LOGSZ,90.0,JUSTIF)
         CALL GMPTXT(IDCORM,XLL,YMID+FFSET,LOGSZ,90.0,JUSTIF)
      CALL GMPLCR(1)
      END IF
      RETURN
      END
      SUBROUTINE EQLINE(WCCOE,XZ1,YZ1,XZ2,YZ2)
C
C                DRAWS AN EQUIVALENCE LINE.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /POLIN/ POLIN
C            OPTION TO EITHER DRAW LINE OR PAINT
             CHARACTER*1 POLIN(LOG_LENGTH)
      COMMON /L/ L
C
      DASH = 0.15
      GAP = 0.09
C
      IF ( MENU .EQ. 'TRAC'  .AND .  WCCOE .LT. -1.0 ) THEN
        IF (POLIN(L) .EQ. 'L'  .OR.  POLIN(L) .EQ. 'B')  
     1        CALL GMPDSH(XZ1,YZ1,XZ2,YZ2,DASH,GAP)
        ELSE
         CALL GMPMOV(XZ1,YZ1)
         CALL GMPDRW(XZ2,YZ2)
      END IF
      RETURN
      END
      SUBROUTINE LINPAR(X1,Y1,X2,Y2,A,B)
C
C                PROVIDES STRAIGHT LINE INTERSECT AND SLOPE
C                WHEN THE LINE IS DETERMINED BY TWO POINTS.
C
C***********************************************************************
C
      IF ( X1 .EQ. X2 ) THEN
         A = 1.0E30
         B = 1.0E30
       ELSE
         A = (Y1 - Y2) / (X1 - X2)
         B = (X1*Y2 - X2*Y1)/(X1 - X2)
      END IF
      RETURN
      END
      SUBROUTINE LINTSP(X1,Y1,A,B)
C
C                PROVIDES INTERSECT FOR A LINE WITH
C                KNOWN SLOPE PASSING THROUGH A GIVEN POINT.
C
C***********************************************************************
C
      B = Y1 - A*X1
      RETURN
      END
      SUBROUTINE INTERF(NPS,L,XZ1,XZ2, TOPZR, NCLOFL,SMS,NIF)
C
C                INTERSECTING FAULTS.  IT IS ASSUMED THAT THE 
C                FAULTS DO NOT CROSS.  NOT COUNTING THE
C                EXTRAPOLATIONS OF FAULTS STARTING INSIDE THE
C                CROSS-SECTION, A GIVEN FAULT IS ALWAYS EITHER
C                ABOVE OR BELOW ANOTHER.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      REAL*4 DISTF(LOG_LENGTH)
      INTEGER*4 NINTF(MAX_NO_FAULTS)
      INTEGER*4 FAULNO(LOG_LENGTH)
C
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
         INTEGER*4 NWF(MAX_NO_FAULTS)
         REAL*4 ZFAULT(MAX_NO_FAULTS)
         REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTZ/ FINTZL,FINTZR
         REAL*4 FINTZL(MAX_NO_FAULTS)
         REAL*4 FINTZR(MAX_NO_FAULTS)
      COMMON /SNINTF/ SNINTF
         INTEGER*4 SNINTF(MAX_NO_FAULTS)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /MARTMS/MARTMSR, MARTMSL
C        TWO TYPES OF DEPTHS FOR MISSING MARKERS DUE TO FAULTING
C        USED BY SUBROUTINE INTERF JOINTLY WITH VARIABLE MSFLAG.
C        DEPTH OF MARKER AT RIGHT WELL OF PAIR IF FAULTING COULD
C        BE REVERSED.
             REAL*4 MARTMSR(LOG_LENGTH,20)
C        DEPTH OF MARKER AT LEFT WELL OR PAIR IF FAULTING COULD
C        BE REVERSED.
             REAL*4 MARTMSL(LOG_LENGTH,20)
C        FLAG TO INDICATE TRACING FALLING IN MISSING SECTION
      COMMON /MSFLAG/MSFLAG
             LOGICAL MSFLAG(LOG_LENGTH,21)
      COMMON /TZUL/ TZUL(MAX_NO_FAULTS)
      COMMON /SWITCH/ SWITCH
C            INDICATOR OF MARKER (.TRUE.) OR CORRELATION (.FALSE.).
      LOGICAL SWITCH
      COMMON /POLIN/ POLIN
C            OPTION TO EITHER DRAW LINE OR PAINT
             CHARACTER*1 POLIN(LOG_LENGTH)
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /CTRMODE/ TRMODE
      LOGICAL TRMODE
C            SPECIAL CORRECTION TO TAKE INTO ACCOUNT INTERSECTION
C            OF MARKER BY A FAULT NOT INTERSECTING THE MARKER
C            AT WELL PAIR TO THE RIGHT WHEN TRACING LEFT AND 
C            "MSFLAG(L,NPS+1)" IS TRUE.  CALCULATED AT MISSEL.
      COMMON /TLCOMP/ TLCOMP
             REAL*4 TLCOMP(LOG_LENGTH,20)
C
      CLOFL = 1.0E30
      CLOFR = 1.0E30
      NCLOFL = -1
      NIF = 0
      SMS = 0.0
C                 MARKER THROUGH MISSING SECTION.
      IF (MENU .EQ. 'TRAC') THEN
         IF ( (MSFLAG(L,NPS)  .AND.  TRMODE  .AND. SWITCH)
     2              .OR.
     3        (MSFLAG(L,NPS)  .AND.  POLIN(L) .EQ. 'L') ) THEN
                XZ1 = XTOP + (MARTMSL(L,NPS) - TOPZR)/VSCALE
         END IF
         IF ( (MSFLAG(L,NPS+1) .AND.  TRMODE  .AND. SWITCH)
     2              .OR.
     3        (MSFLAG(L,NPS+1) .AND.  POLIN(L) .EQ. 'L') ) THEN
            XZ2 = XTOP + 
     1           (MARTMSR(L,NPS+1) - TLCOMP(L,NPS+1) - TOPZR)/VSCALE
         END IF
      END IF
C                                                   !BGR begins
C           FAULT A TIE LINE ONLY WHEN INTERSETION WITH AT LEAST
C           ONE FAULT IS BETWEEN WELLS AND BELOW START OF SUCH FAULT
C
      CALL LINPAR(XZ1,YLEFT,XZ2,YRIGHT,ALI,BLI) ! line equation 
      DO 110 I = 1,NFAULT
      TZULSH = XTOP+((TZU(I,1)-TOPZR)/VSCALE) !  fault start
      CALL LINPAR(FINTZL(I),YLEFT,FINTZR(I),YRIGHT,AFL,BFL) ! f. eq.
      XCROSS = (BFL - BLI)/(ALI - AFL)      ! depth of crossing
      YCROSS = (ALI*BFL - AFL*BLI)/(ALI - AFL) ! locat. of crossing
      IF(YCROSS .GT. YLEFT  .AND.  YCROSS .LT. YRIGHT ) THEN
         IF( XCROSS .GT. TZULSH) GO TO 220
      END IF
  110 CONTINUE
      GO TO 900
C                                                     ! BGR ends  
C           CLOSEST FAULTS.
C
  220 DO 252 I = 1,NFAULT
      TZUL(I) = XTOP+((TZU(I,1)-TOPZR)/VSCALE)
C
C       SKIP THE IMAGINARY EXTENSION OF A FAULT.
C
      IF( XZ1 .LT. TZUL(I)  .AND.  XZ2 .LT. TZUL(I) ) GO TO 252
C      IF( FINTZL(I) .LT. TZUL(I)  .OR.  FINTZR(I) .LT. TZUL(I) ) !KEEP
C     1   GO TO 252                                               !KEEP
      IF (NFAULT .GT. 1) THEN  ! Replacement of previous 2 lines, 11/02
         DO 251 J = 1,NFAULT
         IF ( I .EQ. J) GO TO 251
         IF( (FINTZL(I) .LT. FINTZL(J)  .AND.  
     1        FINTZR(I) .GT. FINTZR(J))   
     2                   .OR.
     3       (FINTZL(I) .GT. FINTZL(J)  .AND.  
     4        FINTZR(I) .LT. FINTZR(J)) ) THEN  ! There is crossing.
            IF( XZ1 .LT. TZUL(I)) THEN
               GO TO 252     ! Skip extension,
            END IF 
         END IF                           ! first approximation.
  251    CONTINUE
      END IF                   ! End of replacement, 11/02
C
      IF((XZ1 .GT. FINTZL(I) .AND. XZ2 .LT. FINTZR(I)) .OR.
     1     (XZ1 .LT. FINTZL(I) .AND. XZ2 .GT. FINTZR(I))) THEN
         IF ( ABS(FINTZL(I) - XZ1) .LT. ABS(CLOFL - XZ1) ) THEN
            CLOFL = FINTZL(I)
            NCLOFL = I
         END IF
C
C        CUMULATIVE MISSING SECTION.  SKIP THE CALCULATION
C        WHEN THE MARKER IS MISSING.
C
         IF ( .NOT. (MSFLAG(L,NPS+1)  .OR.  MSFLAG(L,NPS))  .OR.
     1       (MENU .EQ. 'TRAC'  .AND.   TRMODE  .AND. 
     2       .NOT. SWITCH)) THEN
            Z1L = TOPZR + VSCALE*(XZ1 - XTOP)
            SMS = SMS + GGROWTH(.TRUE.,I,NPS, Z1L)
         END IF
         NIF = NIF + 1
         DISTF(NIF) = ABS(FINTZL(I) - XZ1)
         NINTF(NIF) = I
      END IF
  252 CONTINUE
C
C        SORT THE FAULTS BY INCREASING DISTANCE FROM (XZ1,YZ1).
C
      DO 259 I = 1,NIF
      FAULNO(I) = I
  259 CONTINUE
      CALL SNGLX(DISTF,FAULNO,1,NIF)
      DO 253 I = 1,NIF
      SNINTF(I) = NINTF(FAULNO(I))
  253 CONTINUE
  900 RETURN
      END
      SUBROUTINE DRAWFS(NPS,L,WCCOE,XZ1,YZ1,XZ2,YZ2,NCLOFL,SMS,NIF,
     1               TOPZR,BOTZR,TOPZM,BOTZM,ZZ1L,DIGS1,ZZ2L,DIGS2,
     2               FSTTIME)                  ! RAO 2/2002
C
C                   DRAWS AN EQUIVALENCE LINE IN THE PRESENCE OF FAULTS.
C                   CALCULATIONS ARE IN INCHES IN THE DRAWING BOARD
C                   RATHER THAN IN LENGTH UNITS OF THE TRUE
C                   CROSS-SECTION IN THE SUBSURFACE.
C     
C                   IN THE PRESENCE OF FAULT INTERSECTION, FOR 
C                   LITHOSTRATIGRAPHIC DISPLAY, THE FALSE COLOR
C                   FOR ANY EQUIVALENCE LINE REMAINS THE SAME TO
C                   THE RIGHT OF THE LEFTMOST FAULT.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      LOGICAL FSTTIME
      REAL*4 STAX(11)
      REAL*4 STAY(11)
C
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
         INTEGER*4 NWF(MAX_NO_FAULTS)
         REAL*4 ZFAULT(MAX_NO_FAULTS)
         REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTZ/ FINTZL,FINTZR
         REAL*4 FINTZL(MAX_NO_FAULTS)
         REAL*4 FINTZR(MAX_NO_FAULTS)
      COMMON /SNINTF/ SNINTF
         INTEGER*4 SNINTF(MAX_NO_FAULTS)
      COMMON /MSFLAG/MSFLAG
             LOGICAL MSFLAG(LOG_LENGTH,21)
      COMMON /TZUL/ TZUL(MAX_NO_FAULTS)
      COMMON /MARTMS/MARTMSR, MARTMSL
C        TWO TYPES OF DEPTHS FOR MISSING MARKERS DUE TO FAULTING
C        USED BY SUBROUTINE INTERF JOINTLY WITH VARIABLE MSFLAG.
C        DEPTH TO START THE TRACING AT THE PRESENT PAIR OF WELLS.
             REAL*4 MARTMSR(LOG_LENGTH,20)
C        DEPTH TO START THE TRACING AT THE NEXT PAIR OF WELLS.
             REAL*4 MARTMSL(LOG_LENGTH,20)
      COMMON /MENUPP/ MENU                         ! RAO 2/2000
             CHARACTER*4 MENU                      ! RAO 2/2000
      COMMON /SCALI/ SCALI
      COMMON /POLIN/ POLIN
C            OPTION TO EITHER DRAW LINE OR PAINT
             CHARACTER*1 POLIN(LOG_LENGTH)
      COMMON /SWITCH/ SWITCH
C            INDICATOR OF MARKER (.TRUE.) OR CORRELATION (.FALSE.).
      LOGICAL SWITCH
      COMMON /CTRMODE/ TRMODE
      LOGICAL TRMODE
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /IFACO/ IFA
C
C          CORRECTION CALCULATED IN SUBROUTINE MISSER
C
C                   FIND INTERSECTING FAULTS.
         CALL INTERF(NPS,L,XZ1,XZ2, TOPZR, NCLOFL,SMS,NIF)
      IF ( NIF .EQ. 0 ) THEN
         IF ( MENU .NE. 'LITH'  .AND.  MENU .NE. 'PORO'  .AND.
     1    MENU .NE. 'LIT2') THEN    
            CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFT,
     1               -999, WCCOE,XZ1,YZ1,XZ2,YZ2)
          ELSE IF ( MENU .EQ. 'LITH') THEN                                      
            CALL LITYPE(ZZ1L, DIGS1, 'R', SH1, ILINE1, NDUMM)
            CALL LITYPE(ZZ2L, DIGS2, 'M', SH2, ILINE2, NDUMM)
            CALL MCLINE(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFT,WCCOE,
     1           XZ1,YZ1,XZ2,YZ2, SH1, ILINE1, SH2, ILINE2,0.2)
          ELSE IF ( MENU .EQ. 'PORO') THEN    
            CALL POROSCALE(ZZ1L, DIGS1, 'R', SH1, ILINE1, NDUMM)
            CALL POROSCALE(ZZ2L, DIGS2, 'M', SH2, ILINE2, NDUMM)
            CALL MCLINE(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFT,WCCOE,
     1           XZ1,YZ1,XZ2,YZ2, SH1, ILINE1, SH2, ILINE2,SCALI)
          ELSE IF ( MENU .EQ. 'LIT2') THEN
            CALL FCLITH(ZZ1L,DIGS1,'R',NPS,SH1,NUPEN1)
            CALL FCLITH(ZZ2L,DIGS2,'M',NPS,SH2,NUPEN2)
            CALL MCLINE2(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFT,
     1           XZ1,YZ1,XZ2,YZ2, SH1, NUPEN1, SH2, NUPEN2)
         END IF                                     ! ... RAO 2/2000
         GO TO 900
      END IF
C                 STARTING POINT
      IF ( MENU .EQ. 'LITH' )                       ! RAO 2/2000 ...
     1      CALL LITYPE(ZZ1L, DIGS1, 'R', SH1, ILINE1, NDUMM)    ! ...
      IF ( MENU .EQ. 'PORO')            ! RAO 2/2001 ...
     1      CALL POROSCALE(ZZ1L, DIGS1, 'R', SH1, ILINE1, NDUMM) ! ...
      IF ( MENU .EQ. 'LIT2') CALL FCLITH(ZZ1L,DIGS1,'R',NPS,SH1,ILINE1)
      STAX(1) = XZ1
      STAY(1) = YZ1
C                 CUMULATIVE MISSING SECTION.
      CORRMS = SIGN(1.0,FTDIP(NPS,NCLOFL))*SMS/VSCALE
C                 LINE THROUGH MARKER IN LEFTMOST FAULT BLOCK.
      CALL LINPAR(XZ1,YZ1,XZ2 - CORRMS,YZ2,AC0,BC0)
      IF (FSTTIME) THEN     !RAO 2/2002 
         FSTTIME = .FALSE.
      END IF                !RAO 2/2002
C                 TRUE APPARENT DIP.  COMPLEMENTATION IS REQUIRED
C                 BECAUSE THE REGRESSION IS ON HORIZONTAL DISTANCE,
C                 Y, AND NOT ON DEPTH, X.
      BETA = SIGN(1.0,AC0)*(1.570796 - SIGN(1.0,AC0)*ATAN(AC0))
      DO 200 I = 1,NIF
C                 FAULT TRACE.
         CALL LINPAR(FINTZL(SNINTF(I)),YZ1,FINTZR(SNINTF(I)),YZ2,AF,BF)
      IF ( MSFLAG(L,NPS)  .AND.  I .EQ. 2 ) THEN
         ADJ = 0.0
         Z1L = TOPZR + VSCALE*(XZ1 - XTOP)
         IF ( MARTMSL(L,NPS)  .NE.  MARTMSR(L,NPS) ) THEN
            DO 100 J = 2,NIF
            ADJ = ADJ + GGROWTH(.TRUE.,SNINTF(I),NPS,Z1L)/VSCALE
  100       CONTINUE
         END IF
C                 LINE THROUGH MARKER IN LEFTMOST FAULT BLOCK.
         CALL LINPAR(XZ1+ADJ,YZ1,XZ2,YZ2,AC0,BC0)
      END IF
C                 LINE THROUGH STARTING POINT.
         CALL LINTSP(STAX(I),STAY(I),AC0,BC)
C                INTERSECTION OF FAULT AND LINE THROUGH STARTING POINT.
         X0 = (BF - BC)/(AC0 - AF)
         Y0 = (AF*BC - AC0*BF)/(AF - AC0)
         IF( I .EQ. 2) THEN
         END IF 
C                 DRAW MARKER SEGMENT.
         IF ( I .GT. 1  .AND. Y0 .LT. STAY(I) ) THEN
C                 IGNORE THE EXTENSION OF A CROSSING FAULT.
            STAX(I+1) = STAX(I)
            STAY(I+1) = STAY(I)
             GO TO 200
          ELSE
            IF ( .NOT. MSFLAG(L,NPS)  .OR. I .GT. 1  .OR.
     1       (MENU .EQ. 'TRAC'  .AND.   TRMODE  .AND. 
     2       .NOT. SWITCH)) THEN
               FRDIST = HWDIST*((Y0 - STAY(I))/(YRIGHT - YLEFT))
               CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,STAY(I),
     1               ILINE1, WCCOE,STAX(I),STAY(I),X0,Y0) !RAO 2/2000
C     1              -999, WCCOE,STAX(I),STAY(I),X0,Y0)   !RAO 2/2000 
            END IF
         END IF
C                 STARTING POINT FOR MARKER IN NEXT BLOCK.
      IF ((MSFLAG(L,NPS) .AND.  I .EQ. 1  .AND. MENU .EQ. 'TRAC'  .AND.
     1     TRMODE  .AND.  SWITCH)
     2                 .OR.
     3    (MSFLAG(L,NPS) .AND.  I .EQ. 1  .AND. MENU .EQ. 'TRAC'  .AND.
     4     POLIN(L) .EQ. 'L')) THEN
C                 MISSING SECTION AT THE REFERENCE ELEVATION. 
         STAX(I+1) = X0
         STAY(I+1) = Y0
       ELSE
C                 NO MISSING SECTION AT THE REFERENCE ELEVATION.
C                 APPARENT FAULT DIP.
         ALPHA= ATAN((FINTZR(SNINTF(I)) - 
     1           FINTZL(SNINTF(I)))*HSCALE/HWDIST)
C                 DISPLACEMENT.
         Z1L = TOPZR + VSCALE*(XZ1 - XTOP)
         DISP = ABS((GGROWTH(.TRUE.,SNINTF(I),NPS,Z1L)*COS(BETA))/
     1           (SIN(ALPHA - BETA)*VSCALE))
         STAX(I+1) = X0 + (DISP*SIN(ALPHA))
         STAY(I+1) = Y0 + (DISP*COS(ALPHA))
      END IF
C          STOP TRACING WHEN THE STARTING POINT IS TO THE RIGHT OF
C          THE RIGHT WELL. THIS SITUATION MAY HAPPEN WHEN THE MARKER
C          IS MISSING IN THE RIGHT WELL.
      IF ( I .GT. 1  .AND.  STAX(I+1) .LT. TZUL(I)) THEN
C                 START FROM PREVIOUS FAULT WHEN ABOVE BEGINING
C                 OF LAST FAULT.
C                 FAULT TRACE.
         CALL LINPAR(FINTZL(SNINTF(I-1)),YZ1,FINTZR(SNINTF(I-1)),
     1                       YZ2,AF,BF)
C                 LINE THROUGH STARTING POINT.
         CALL LINTSP(STAX(I+1),STAY(I+1),AC0,BC)
C               INTERSECTION OF FAULT AND LINE THROUGH STARTING POINT.
         STAX(I+1) = (BF - BC)/(AC0 - AF)
         STAY(I+1) = (AF*BC - AC0*BF)/(AF - AC0)
      END IF
      IF ( STAY(I+1) .GT. YZ2 ) GO TO 900
  200 CONTINUE
         FRDIST = HWDIST*((YZ2 - STAY(NIF+1))/(YRIGHT - YLEFT))
      IF ( (MSFLAG(L,NPS+1)  .AND.
     1      MARTMSL(L,NPS+1)  .GT.  FINTZ(IFA,NPS+1))  .OR.
     1    ( MSFLAG(L,NPS)  .AND. MSFLAG(L,NPS+1)  .AND.
     1     MARTMSL(L,NPS) .EQ. MARTMSR(L,NPS)))  GO TO 900
      IF ( MENU .EQ. 'LITH' )                       ! RAO 2/2000 ...
     1      CALL LITYPE(ZZ2L, DIGS2, 'M', SH2, ILINE2, NDUMM)    ! ...
      IF ( MENU .EQ. 'PORO')            ! RAO 2/2001 ...
     1      CALL POROSCALE(ZZ2L, DIGS2, 'M', SH2, ILINE2, NDUMM) ! ...
      IF ( MENU .EQ. 'LIT2') CALL FCLITH(ZZ2L,DIGS2,'M',NPS,SH2,ILINE2)
      CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,STAY(NIF+1),
     1     ILINE2, WCCOE,STAX(NIF+1),STAY(NIF+1),XZ2,YZ2) ! RAO 2/2000
  900 FSTTIME = .FALSE.
      RETURN
      END
      SUBROUTINE LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,HDIST,LEFTY,ILINE,
     1                  WCCOE,X1,Y1,X2,Y2)
      REAL*4 LEFTY
C
C                DRAW THAT PORTION OF A LINE WHICH IS INSIDE A BOX.
C
C**********************************************************************
C
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      XBOTL = XTOP + ((BOTZR - TOPZR)/VSCALE)
      IF(X1.LE.XTOP .AND. X2.LE.XTOP .OR.
     1   X1.GE.XBOTL .AND. X2.GE.XBOTL) GO TO 270
      XZ1 = X1
      YZ1 = Y1
      XZ2 = X2
      YZ2 = Y2
      Z1 = TOPZR + (XZ1 - XTOP)*VSCALE
      Z2 = TOPZM + (XZ2 - XTOP)*VSCALE
      IF(Z1.GE.TOPZR .AND. Z1.LE.BOTZR .AND.
     1   Z2.GE.TOPZM .AND. Z2.LE.BOTZM) GO TO 250
C               AT LEAST ONE CENTER OUT OF THE BOX.
      CASEB=LEFTY+((HDIST*(ABS(BOTZR-Z1)))/
     1                    ((ABS((Z1-TOPZR)-(Z2-TOPZM)))*HSCALE))
      CASET=LEFTY+((HDIST*(ABS(TOPZR-Z1)))/
     1                    ((ABS((Z1-TOPZR)-(Z2-TOPZM)))*HSCALE))
      IF((Z1-TOPZR).LT.(Z2-TOPZM)) GO TO 230
C                    LEFT DIPPING.
      IF(Z1.LT.BOTZR .AND. Z2.LT.TOPZM) GO TO 215
      IF(Z1.GE.BOTZR   .AND. Z2.LT.TOPZM) GO TO 220
C                         LEFT OUTSIDE BOX, RIGHT IN.
      XZ1=XBOTL
      YZ1=CASEB
      GO TO 250
C                         LEFT AND RIGHT OUTSIDE THE BOX.
  220 XZ1=XBOTL
      YZ1=CASEB
      XZ2=XTOP
      YZ2=CASET
      GO TO 250
C                         LEFT INSIDE BOX, RIGHT OUT.
  215 XZ2=XTOP
      YZ2=CASET
      GO TO 250
C                    RIGHT DIPPING.
  230 IF(Z1.GE.TOPZR .AND. Z2.GT.BOTZM) GO TO 245
      IF(Z1.LT.TOPZR   .AND. Z2.GT.BOTZM) GO TO 240
C                         LEFT OUTSIDE BOX, RIGHT IN.
      XZ1=XTOP
      YZ1=CASET
      GO TO 250
C                         LEFT AND RIGHT OUTSIDE THE BOX.
  240 XZ1=XTOP
      YZ1=CASET
      XZ2=XBOTL
      YZ2=CASEB
      GO TO 250
C                         LEFT INSIDE BOX, RIGHT OUT.
  245 XZ2=XBOTL
      YZ2=CASEB
C               BOTH CENTERS WITHIN THE BOX.
  250 IF ( MENU .NE. 'LITH'  .AND.  MENU .NE. 'PORO'  .AND.
     1    MENU .NE. 'LIT2') THEN
         CALL EQLINE(WCCOE,XZ1,YZ1,XZ2,YZ2)
       ELSE IF ( MENU .EQ. 'LITH') THEN
         IF (ILINE .GE. 0) THEN                  !RAO 2/2000
            CALL COLORSCH(ILINE, NUPEN)
            CALL GMPLCR(NUPEN)
         END IF                                  !RAO 2/2000  
         CALL GMPMOV(XZ1,YZ1)
         CALL GMPDRW(XZ2,YZ2)
       ELSE IF ( MENU .EQ. 'PORO') THEN
         IF (ILINE .GE. 0) THEN                  !RAO 2/2000
            CALL COLORPOR(ILINE, NUPEN)
            CALL GMPLCR(NUPEN)
         END IF                                  !RAO 2/2000  
         CALL GMPMOV(XZ1,YZ1)
         CALL GMPDRW(XZ2,YZ2)
       ELSE IF ( MENU .EQ. 'LIT2') THEN
         IF (ILINE .GT. 0) CALL GMPLCR(ILINE)
         CALL GMPMOV(XZ1,YZ1)
         CALL GMPDRW(XZ2,YZ2)
      END IF
  270 RETURN
      END
C
      SUBROUTINE FAUFIL(J1STIM)
C
C                  PREPARES A FAULT FILE.
C
C***********************************************************************
C
      CHARACTER*1 LASTCHAR
      CHARACTER*4 HEFA /'FAUL'/
      CHARACTER*1 CHP /'P'/
C
      COMMON /FAULTF/ PAR1
         CHARACTER*40 PAR1
      COMMON / FAFINU/ PAR2,PAR3,PAR4,PAR5,PAR6,PAR7,PAR8,
     1                 PAR9, PAR10, PAR11, PAR12
         INTEGER*4 PAR2,PAR3,PAR7,PAR8
         REAL*4 PAR4,PAR5,PAR6
C
C         READ PARAMETERS
C
   11 CALL OPFAFI(J1STIM,*900)
C
C         START A NEW FILE
C
      IF ( PAR2 .EQ. 1) THEN
         CALL OPEND(88,PAR1,-1,51)
         K = 0
         NUMREC = 1
         WRITE (88,9000,REC=1) HEFA,PAR8,K, NUMREC
       ELSE IF ( PAR2 .EQ. 2) THEN
         READ (88,9000,REC=1) HEFA,PAR8,K, NUMREC
         WRITE (88,9000,REC=1) HEFA,PAR8,K+1, NUMREC+1
         WRITE (88,9001,REC=NUMREC+1) 
     1               PAR3,PAR4,PAR10,PAR5,PAR7, 0,CHP
       ELSE IF ( PAR2 .EQ. 3) THEN
         READ (88,9000,REC=1) HEFA,PAR8,K, NUMREC
         WRITE (88,9000,REC=1) HEFA,PAR8,K, NUMREC+1
         DO 100 I = NUMREC,1,-1
         K = I
         READ (88,9003,REC=K) LASTCHAR
         IF ( LASTCHAR .EQ. 'P') THEN
            READ (88,9001,REC=K) IWELL, FDEPTH, AZ, ANGLE, IPEN, NTAB
            WRITE (88,9001,REC=K) IWELL, FDEPTH, AZ, ANGLE, IPEN,
     1                            NTAB+1, CHP
            GO TO 200
         END IF
  100    CONTINUE
  200    WRITE (88,9002,REC=NUMREC+1) PAR9, PAR6, PAR11, PAR12
      END IF
      CALL RPFAFI
      CLOSE (88,STATUS='KEEP')
      IF (PAR2 .EQ. 2 ) PAR2 = 3
      IF (PAR2 .EQ. 1 ) PAR2 = 2
      GO TO 11
  900 RETURN
 9000 FORMAT (A4,31X,3I5)
 9001 FORMAT (2X,I3,3F10.2,2I5,4X,1A1)
 9002 FORMAT (2F10.2, 10X, F10.4, F10.2)
 9003 FORMAT (49X,1A1)
      END
      SUBROUTINE OPFAFI(J1STIM,*)
C
C                   OPTIONS FOR COMMAND 'PF'.
C
C**********************************************************************
C
      include 'pen.inc'
      INCLUDE 'log.inc'
C
      LOGICAL FLAG
      LOGICAL DTFLAG
      CHARACTER*1 ANS
      CHARACTER*1 CHARP
      CHARACTER*1 LASTCHAR
      CHARACTER*2 OPTION
      CHARACTER*3 NUMAN
      CHARACTER*4 BOMU
      CHARACTER*10 D1, D2
      CHARACTER*11 SOA(3) /'START','FAULT PLANE', 'TABLE'/
      CHARACTER*8 DOG(2) /' DEGREE','GRADIENT'/
C
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*15 DATUM
C            LOG DATA FILE NAME AND WELL DATA FILE
             CHARACTER*40 FYLES
C            REFERENCE WELL NAME.
             CHARACTER*20 NAME1
C            MATCHING WELL NAME.
             CHARACTER*20 NAME2
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
         CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/  ICOLOR(6)
      COMMON /FAULTF/ PAR1
         CHARACTER*40 PAR1
      COMMON / FAFINU/ PAR2,PAR3,PAR4,PAR5,PAR6,PAR7,PAR8,
     1                 PAR9, PAR10, PAR11, PAR12
         INTEGER*4 PAR2,PAR3,PAR7,PAR8
         REAL*4 PAR4,PAR5,PAR6
C
      LOGICAL ERROR
C
      IF (J1STIM .EQ. 0) THEN
         PAR1 = '*????*'
         PAR2 = 1
         PAR3 = 1
         PAR4 = 0
         PAR5 = -1
         PAR6 = 20
         PAR7 = 10
         PAR8 = 2
         PAR9 = -1
         PAR10 = 0.0
         PAR11 = 0.0
         PAR12 = 0.0
      END IF
C
C        MENU
C
   11 FLAG = .FALSE.
      DTFLAG = .TRUE.
      CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'PREPARATION OF A FAULT FILE')
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, 4,'FN - NAME OF THE FAULT FILE')
      CALL GTXTRJ(75, 4,PAR1)
      LINE = 4
      IF ( PAR1 .NE. '*????*' ) THEN
         CALL GTEXTS( 3, 5,
     1    'SA - START A NEW FILE (S), DEFINE A FAULT PLANE IN AN')
         CALL GTXTRJ(75, 5,SOA(PAR2))
         CALL GTEXTS( 8, 6,
     1    'EXISTING FILE (P) OR ENTER MISSING SECTION TABLE (T)')
      LINE = 6
         IF ( PAR2 .EQ. 1 ) THEN
            CALL GTEXTS( 3, LINE+1,
     1    'DG - FAULT DIP UNITS, DEGREE(D) OR GRADIENT(G)')
            CALL GTXTRJ(75, LINE+1,DOG(PAR8))
            LINE = LINE+1
          ELSE IF ( PAR2 .EQ. 2 ) THEN
            CALL GTEXTS( 3, LINE+1,
     1   'SN - SEQUENTIAL NUMBER FOR THE WELL INTERCEPTED BY THE FAULT')
            CALL GTXTIN(75, LINE+1,PAR3)
            CALL GTEXTS( 3, LINE+2,'DI - DEPTH TO THE INTERCEPTION, '
     1      // BOMU(BOM) // ' BELOW ' // DATUM)
            CALL GTXTRL(75, LINE+2,PAR4,2)
            CALL GTEXTS( 3, LINE+3,
     1    'AZ - FAULT AZIMUTH, COUNTERCLOCKWISE DEGREES FROM EAST')
            CALL GTXTRL(75, LINE+3,PAR10,2)
            CALL GTEXTS( 3, LINE+4,
     1    'TD - FAULT TRUE DIP, '//DOG(PAR8))
            CALL GTXTRL(75, LINE+4,PAR5,2)
            CALL GTEXTS( 3,LINE+5,'PN - PEN NUMBER')
            CALL GTXTIN(75,LINE+5,PAR7)
            LINE = LINE + 5
          ELSE IF ( PAR2 .EQ. 3 ) THEN
            CALL GTEXTS( 3, LINE+1,
     1       'DT - DEPTH FOR TOP OF INTERVAL AT UPTHROW, '// BOMU(BOM))
            CALL GTXTRL(75, LINE+1,PAR9,2)
            CALL GTEXTS( 3, LINE+2,'MS - MISSING SECTION, '// BOMU(BOM))
            CALL GTXTRL(75, LINE+2,PAR6,2)
            CALL GTEXTS( 3, LINE+3,
     1       'RI - RATE OF INCREASE IN MISSING SECTION WITH DEPTH')
            CALL GTXTRL(75, LINE+3,PAR11,4)
            CALL GTEXTS( 3, LINE+4,
     1       'RD - DEPTH FOR REFERENCE ELEVATION, '// BOMU(BOM))
            CALL GTXTRL(75, LINE+4,PAR12,2)
            LINE = LINE + 4
         END IF
      END IF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      IF ( .NOT.((PAR1 .EQ. '*????*') .OR. (PAR1 .EQ. ' '))  )
     1   CALL GTEXTS( 3,LINE+3,'GO - UPDATE THE FAULT FILE')
C
      LINE = LINE + 5
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN 1
C
      IF (.NOT.((PAR1 .EQ. '*????*') .OR. (PAR1 .EQ. ' '))  .AND. 
     1                (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'FN') CALL AGETST(PAR1,40)
      IF (OPTION .EQ. 'SA') THEN
         CALL AGETST(ANS,1)
         IF (ANS .EQ. 'S') PAR2 = 1
         IF (ANS .EQ. 'P') PAR2 = 2
         IF (ANS .EQ. 'T') PAR2 = 3
      ENDIF
      IF (OPTION .EQ. 'SN') CALL AGETIN(PAR3,ERROR)
      IF (OPTION .EQ. 'DI') CALL AGETRL(PAR4,ERROR)
      IF (OPTION .EQ. 'TD') CALL AGETRL(PAR5,ERROR)
      IF (OPTION .EQ. 'MS') CALL AGETRL(PAR6,ERROR)
      IF (OPTION .EQ. 'PN') CALL AGETIN(PAR7,ERROR)
      IF (OPTION .EQ. 'DG') THEN
         CALL AGETST(ANS,1)
         IF (ANS .EQ. 'D') PAR8 = 1
         IF (ANS .EQ. 'G') PAR8 = 2
      ENDIF
      IF (OPTION .EQ. 'DT') CALL AGETRL(PAR9,ERROR)
      IF (OPTION .EQ. 'RI') CALL AGETRL(PAR11,ERROR)
      IF (OPTION .EQ. 'AZ') CALL AGETRL(PAR10,ERROR)
      IF (OPTION .EQ. 'RD') CALL AGETRL(PAR12,ERROR)
      GO TO 15
C
C          PARAMETER CHECKING.
C
   51 CALL TXTCLR(ICOLOR(6))
      IF ( PAR2 .EQ. 1 ) THEN
         CALL CHKOLF(88,PAR1,51,1,LINE+2,ICKERR,*11) 
       ELSE
         CALL CHKOTY(88,PAR1,0,51,1,LINE+2,ICKERR)
         IF ( ICKERR .NE. 0 ) GO TO 11
      END IF
      IF ( PAR2 .EQ. 2 ) THEN
         READ (88,9001,REC=1) NFAULT,NUMREC
         IF ( NFAULT .GE. MAX_NO_FAULTS) THEN
            WRITE(NUMAN,'(I3)') MAX_NO_FAULTS
            CALL GTEXTS(5,LINE+2,
     1       '***** MODIFY FILE log.inc TO HAVE MORE THAN '
     2       // NUMAN //' FAULTS PER CROSS-SECTION.')
            LINE = LINE + 1
            FLAG = .TRUE.
         END IF
         READ (88,9003,REC=NUMREC) CHARP
         IF ( CHARP .EQ. 'P') THEN
            CALL GTEXTS(5,LINE+2,
     1     '***** PREPARE THE MISSING SECTION TABLE FOR THE PREVIOUS')
            CALL GTEXTS(11,LINE+3,
     1      'FAULT BEFORE ATTEMPTING TO DEFINE ANOTHER FAULT PLANE.')
            LINE = LINE + 3
            FLAG = .TRUE.
         END IF
         IF ( PAR3 .LE. 0 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+10,
     1   '***** SEQUENTIAL WELL NUMBER LESS THAN ONE.')
            FLAG = .TRUE.
            LINE = LINE + 1  
         END IF
          IF ( PAR7 .LT. 1 ) THEN
             CALL GTEXTS(15,LINE+2,
     1       '***** THE PEN NUMBER MUST BE LARGER THAN ZERO.')
             LINE = LINE + 1
             FLAG = .TRUE.
          END IF
         IF ( PAR7 .GT. NRGB ) THEN
            CALL GTEXTS(15,LINE+2,
     1       '***** THE PEN NUMBER CANNOT BE GREATER THAN   .')
            CALL GTXTIN(60,LINE+2,NRGB)
            FLAG = .TRUE.
           END IF
         IF ( PAR5 .EQ. 0 ) THEN
            CALL GTEXTS(15,LINE+2,
     1       '***** THE FAULT CANNOT BE IN A HORIZONTAL POSITION.')
            FLAG = .TRUE.
           END IF
         IF ( PAR10 .LT. -360.0 ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** THE FAULT AZIMUTH CANNOT BE LESS THAN 360 DEGREES.')
            FLAG = .TRUE.
           END IF
         IF ( PAR5 .LT. 0.0 ) THEN
            CALL GTEXTS(15,LINE+2,
     1'***** THE FAULT DIP CANNOT BE LESS THAN 0, '//DOG(PAR8)//'.')
            FLAG = .TRUE.
           END IF
         IF ( PAR8 .EQ. 1  .AND.  PAR5 .GT. 90.0 ) THEN
            CALL GTEXTS(15,LINE+2,
     1'***** THE FAULT DIP CANNOT BE LESS THAN 90, '//DOG(PAR8)//'.')
            FLAG = .TRUE.
           END IF
      END IF
      IF ( PAR2 .EQ. 3 ) THEN
         READ (88,9000,REC=1) NUMREC
         DO 70 I = NUMREC,2,-1
         K = I
         READ (88,9003,REC=K) LASTCHAR
         IF ( LASTCHAR .EQ. 'P') THEN
             READ (88,9004,REC=K) NTAB
             GO TO 80
         END IF
   70    CONTINUE
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** DEFINE THE FAULT PLANE FIRST.')
            FLAG = .TRUE.
            GO TO 90
   80    IF ( NTAB .GE. MAX_REC_TAB ) THEN
            WRITE(NUMAN,'(I3)') MAX_REC_TAB
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+2,
     1   '***** MODIFY FILE log.inc TO HAVE MORE THAN ' )
            CALL GTEXTS(11,LINE+3,
     1    NUMAN // ' RECORDS IN THE MISSING SECTION TABLE.')
            FLAG = .TRUE.
            LINE = LINE + 3  
         END IF
         IF ( PAR9 .LT. -99999.99 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** DEPTH TOO SMALL.')
            FLAG = .TRUE.
            LINE = LINE + 1  
         END IF
          IF ( PAR9 .GT. 999999.99 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** DEPTH TOO LARGE.')
            FLAG = .TRUE.
            LINE = LINE + 1  
         END IF
         READ (88,9003,REC=NUMREC) CHARP
         IF ( CHARP .NE. 'P') THEN
            READ (88,9002,REC=NUMREC) PDEPTH
            IF ( PAR9 .LE. PDEPTH) THEN
               WRITE(D1,'(F10.2)') PAR9
               WRITE(D2,'(F10.2)') PDEPTH
  111          CALL TXTCLR(ICOLOR(6))
               CALL GTEXTS(15,LINE+2,
     1       '***** WARNING:  DEPTH ' // D1 // ' NOT DEEPER THAN ')
               CALL GTEXTS(20,LINE+3,
     1     ' PREVIOUS DEPTH OF '  // D2 // ' ' // BOMU(BOM) // '.')
               CALL GTEXTS(21,LINE+5,
     1           'RE -- IGNORE THE VALUE.')
               CALL GTEXTS(21,LINE+6,
     1           'GO -- KEEP THE VALUE')
               CALL GTEXTS(21,LINE+8,
     1           'PLEASE ENTER YOUR SELECTIONS:')
               CALL AINPUT(51,LINE+8)
  151          CALL AGETST(OPTION,2)
               IF (OPTION .EQ. '  ') GO TO 111
               IF (OPTION .EQ. 'RE') GO TO 11
               IF (OPTION .EQ. 'GO') THEN
                  DTFLAG = .FALSE.
                  GO TO 90
               END IF
               GO TO 151
            END IF
         END IF
      ENDIF
   90 IF ( FLAG ) THEN
         IF ( DTFLAG ) CALL SCHOLD
         GO TO 11
      END IF
C
      J1STIM = 1
      RETURN
 9000 FORMAT (45X, I5)
 9001 FORMAT (40X,2I5)
 9002 FORMAT (F10.0)
 9003 FORMAT (49X,1A1)
 9004 FORMAT (40X,I5)
      END
      SUBROUTINE RPFAFI
C
C                 DISPLAY CONTENT OF FAULT FILE.
C
C***********************************************************************
C
C
      CHARACTER*4 BOMU,HEFA
      CHARACTER*8 DOG(2) /'DEGREE','GRADIENT'/
      CHARACTER*20 UNDIP
C
      COMMON /FAULTF/ PAR1
         CHARACTER*40 PAR1
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
C
      CALL ANMODE
      READ (88,9000,REC=1) HEFA,IDOG,NFAULT,NUMREC
      IF ( IDOG .EQ. 1 ) THEN
         UNDIP = DOG(IDOG)
       ELSE
         UNDIP = 'VERT. '// BOMU(BOM) //'/HOR. ' // BOMU(BOM)
      END IF
      WRITE (QTEKOT,9001) PAR1,NFAULT
      IF ( NFAULT .EQ. 0 ) THEN
         WRITE (QTEKOT,9005) DOG(IDOG)
         GO TO 999
      END IF
      K = 2
      DO 150 I = 1,NFAULT
      READ(88,9003,REC=K) IWELL,DEPTH,AZ,DIP,IPEN,NTAB, CHP
      WRITE(QTEKOT,9002) I, IWELL,DEPTH,BOMU(BOM),AZ,
     1                    DIP, UNDIP, IPEN
      K = K + 1
      IF ( NTAB .GT. 0 ) THEN
         WRITE (QTEKOT,9006) BOMU(BOM),BOMU(BOM), BOMU(BOM)
         DO 100 II = 1,NTAB
         READ(88,9007,REC=K) ZU, SMISS, SMICCINC, ZREF
         IF ( SMICCINC .NE. 0.0 ) THEN
            WRITE(QTEKOT,9004) ZU, SMISS, SMICCINC, ZREF
          ELSE
            WRITE(QTEKOT,9004) ZU, SMISS
         END IF
         K = K + 1
  100    CONTINUE
      END IF
  150 CONTINUE
C
  999 CALL RETKEY
      RETURN
 9000 FORMAT (A4,31X,3I5)
 9001 FORMAT (///,34X,'FAULT FILE',/,
     1            34X,'**********',///,
     2        1X,'FAULT FILE NAME',22X,A40,/,
     3        1X,'NUMBER OF FAULTS IN THE FILE', 6X,I4)
 9002 FORMAT(//3X,'TRACE OF FAULT PLANE NO. ',I2,'.'/
     1       3X,'SEQUENTIAL NUMBER OF THE INTERSECTED WELL',2X,I4/
     2       3X,'DEPTH OF THE INTERSECTION',15X,F10.2,', ', A4/
     3       3X,'AZIMUTH',35X,F10.4,', DEGREES'/
     4       3X,'TRUE DIP',34X,F10.4,', ',A20/
     6       3X,'DRAWING PEN NUMBER',25X,I4/)
 9003 FORMAT (2X,I3,3F10.2,2I5,4X,1A1)
 9004 FORMAT (11X,F10.2,3X,F10.2,3X,F10.4,3X,F10.2)
 9005 FORMAT (1X,'UNIT FOR THE APPARENT DIP',12X,A8////)
 9006 FORMAT ( 14X,'TOP OF',7X,'MISSING',
     1          4X,'INCREMENT',4X,'REFERENCE'/
     2         13X,'INTERVAL',6X,'SECTION',19X,'DEPTH'/     
     3         15X, A4,9X, A4, 21X, A4/
     4        10X,51('-'))
 9007 FORMAT(2F10.2, 10X, F10.4, F10.2)
      END
      REAL FUNCTION GROWTH(K, Z1L)
C
C              CUMULATIVE EFFECT OF MISSING PLUS EXPANDED SECTION
C              VIEWED FROM THE UPTHROW.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /PENFAU/ PENFAU
             INTEGER*4 PENFAU(MAX_NO_FAULTS)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
C
C          APPARENT MISSING SECTION
C
      GROWTH = 0.0
      IF ( Z1L .GE. TZU(K,NRTAB(K)) )
     1         GROWTH = SECM(K,NRTAB(K)) + 
     2         SMICCINC(K,NRTAB(K))*(Z1L - ZREF(K,NRTAB(K)))
      IF ( NRTAB(K) .GT. 1) THEN
         DO 100 I = 1,NRTAB(K)-1
            IF ( Z1L .GE. TZU(K,I)  .AND.  Z1L .LT. TZU(K,I+1)) THEN
               AUX = SECM(K,I) + SMICCINC(K,I)*(Z1L - ZREF(K,I))
               GROWTH = SECM(K,I) + SMICCINC(K,I)*(Z1L - ZREF(K,I))
               GO TO 900
            END IF
  100    CONTINUE
      END IF
  900 RETURN
      END
      SUBROUTINE MCLINE(TOPZR,BOTZR,TOPZM,BOTZM,HDIST,LEFTY,WCCOE,
     1           XZ1,YZ1,XZ2,YZ2, SH1, ILINE1, SH2, ILINE2,SCALI)
C
C                DRAWS A LINE CODED ACCORDING TO THE AMOUNT OF SHALE.
C
C***********************************************************************
C
      INTEGER*4 DIL
      REAL*4 LEFTY
C
C           BOTH VALUES IN THE SAME COLOR CLASS
C
      IF ( ILINE1 .EQ. ILINE2) THEN
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,HDIST,YZ1,ILINE1,
     1                  WCCOE,XZ1,YZ1,XZ2,YZ2)
C
C           DIFFERENT COLOR CLASS
C
       ELSE
         DIL = IABS(ILINE1 - ILINE2)
         DSH = ABS(SH1 -SH2)
         DX = XZ2 - XZ1
         DY = YZ2 - YZ1
         IF ( SH2 .GT. SH1) THEN
            SEG1 = (ILINE1+1)*SCALI - SH1
          ELSE
            SEG1 =  SH1 - ILINE1*SCALI
         END IF
         X1 = XZ1 + (DX*SEG1)/DSH
         Y1 = YZ1 + (DY*SEG1)/DSH
         FRDIST = HDIST*((YZ1 - Y1)/DY)
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,Y1,ILINE1,
     1                  WCCOE,X1,Y1,XZ1,YZ1)
         IF ( DIL .GT. 1) THEN
            DO 100 I = 1,DIL-1
            X2 = X1 + (DX*SCALI)/DSH
            Y2 = Y1 + (DY*SCALI)/DSH
            FRDIST = HDIST*((Y2 - Y1)/DY)
            IF ( SH2 .GT. SH1) THEN
       CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,Y1,ILINE1+I,
     1                  WCCOE,X1,Y1,X2,Y2)
             ELSE
       CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,Y1,ILINE1-I,
     1                  WCCOE,X1,Y1,X2,Y2)
            END IF
            X1 = X2
            Y1 = Y2
  100       CONTINUE
         END IF
         FRDIST = HDIST*((YZ2 - Y1)/DY)
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,Y1,ILINE2,
     1                  WCCOE,X1,Y1,XZ2,YZ2)
      END IF
      RETURN
      END
      SUBROUTINE PAINT(Z1L,Z2L,L,M,IPER,NPS,WCCOE,*,*)
C
C**********************************************************************
C
C        MAKES USE OF CORRELATIONS TO COLOR BETWEEN TRACING LINES
C
C***********************************************************************
C
C
      INCLUDE 'log.inc'
C
      COMMON /SWITCH/ SWITCH
C            INDICATOR OF MARKER (.TRUE.) OR CORRELATION (.FALSE.).
      LOGICAL SWITCH
      COMMON /IOLD/ IOLD
      COMMON /PERCOR/ PERCO
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /TEQCOR/ TEQCOR(LOG_LENGTH,40)
      COMMON /MSFLAG/ MSFLAG
             LOGICAL MSFLAG(LOG_LENGTH,21)
C
      IF (SWITCH) THEN
         Z1LOLD = Z1L
         Z2LOLD = Z2L
         DO 100 I = 1,M
         IF (TEQCOR(I,2*NPS-1) .GE. Z1LOLD) THEN
            IF( L .LT. IPER  .AND.
     1          TEQCOR(I,2*NPS-1) .GT. PERCO(L+1,NPS) ) RETURN 2  
            Z1L = TEQCOR(I,2*NPS-1)
            Z2L = TEQCOR(I,2*NPS)
            MSFLAG(L,NPS) = .FALSE.
            IOLD = I
            SWITCH = .FALSE.
            WCCOE = 0
            RETURN 1
         END IF
  100    CONTINUE
         GO TO 300
       ELSE
         IOLD = IOLD + 1
         IF (IOLD .GT. M) THEN
            GO TO 300
          ELSE
            IF (L .EQ. IPER) THEN
               Z1L = TEQCOR(IOLD,2*NPS-1)
               Z2L = TEQCOR(IOLD,2*NPS)
               MSFLAG(L,NPS) = .FALSE.
               RETURN 1
             ELSE
               IF (TEQCOR(IOLD,2*NPS-1) .LE. PERCO(L+1,NPS)) THEN
                  Z1L = TEQCOR(IOLD,2*NPS-1)
                  Z2L = TEQCOR(IOLD,2*NPS)
                  MSFLAG(L,NPS) = .FALSE.
                  RETURN 1
                ELSE
                  GO TO 300
               END IF
            END IF
         END IF
      END IF
  200 CONTINUE
  300 RETURN
      END
      SUBROUTINE MCLINE2(TOPZR,BOTZR,TOPZM,BOTZM,HDIST,LEFTY,
     1           XZ1,YZ1,XZ2,YZ2, SH1, NUPEN1, SH2, NUPEN2)
C
C            DRAWS A LINE CODED ACCORDING TO LITHOLOGY
C
C***********************************************************************
C
      REAL*4 LEFTY
C
      COMMON /PENSH/ PENSH
              INTEGER*4 PENSH
C
C           BOTH VALUES IN THE SAME COLOR CLASS
C
      IF ( NUPEN1 .EQ. NUPEN2) THEN
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,HDIST,YZ1,NUPEN1,
     1                  -999.9,XZ1,YZ1,XZ2,YZ2)
C
C           DIFFERENT COLOR CLASS
C
       ELSE if (NUPEN1 .EQ. PENSH  .OR.  NUPEN2 .EQ. PENSH) THEN
         DSH = ABS(SH1 -SH2)
         SEG1 = ABS(SH1 - 0.50)
         DX = XZ2 - XZ1
         DY = YZ2 - YZ1
         X1 = XZ1 + (DX*SEG1)/DSH
         Y1 = YZ1 + (DY*SEG1)/DSH
         FRDIST = HDIST*((YZ1 - Y1)/DY)
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,Y1,NUPEN1,
     1                  -999.9,X1,Y1,XZ1,YZ1)
         FRDIST = HDIST*((YZ2 - Y1)/DY)
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,Y1,NUPEN2,
     1                  -999.9,X1,Y1,XZ2,YZ2)
         ELSE
         X1 = 0.5*(XZ1 + XZ2)
         Y1 = 0.5*(YZ1 + YZ2)
         FRDIST = HDIST*((YZ1 - Y1)/DY)
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,Y1,NUPEN1,
     1                  -999.9,X1,Y1,XZ1,YZ1)
         FRDIST = HDIST*((YZ2 - Y1)/DY)
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,Y1,NUPEN2,
     1                  -999.9,X1,Y1,XZ2,YZ2)
      END IF
      RETURN
      END
      REAL FUNCTION GROWTHDT(K, Z1L)
C
C              CUMULATIVE EFFECT OF MISSING PLUS EXPANDED SECTION
C              VIEWED FROM THE DOWNTHROW.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      REAL*4 TZUM(MAX_REC_TAB) 
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /PENFAU/ PENFAU
             INTEGER*4 PENFAU(MAX_NO_FAULTS)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
C
C          APPARENT MISSING SECTION
C
      GROWTHDT = 0.0
      DO 50 I = 1,NRTAB(K)
      TZUM(I) = TZU(K,I) + SECM(K,I)
   50 CONTINUE
      IF ( Z1L .GE. TZUM(NRTAB(K)) )  THEN
         FACTOR = 1.0/(1 + SMICCINC(K,NRTAB(K)))
         FACTOR2 = SMICCINC(K,NRTAB(K))*
     1                  (TZU(K,NRTAB(K)) - ZREF(K,NRTAB(K)))
C        SAME TIE LINE DEPTH AT UPTHROW
         UPZ = TZU(K,NRTAB(K)) + FACTOR*
     1          ( Z1L - TZUM(NRTAB(K)) - FACTOR2) 
         GROWTHDT = GROWTH(K,UPZ)
       ELSE IF ( NRTAB(K) .GT. 1) THEN
         DO 100 I = 1,NRTAB(K)-1
         FACTOR = 1.0/(1 + SMICCINC(K,I))
         FACTOR2 = SMICCINC(K,I)*(TZU(K,I) - ZREF(K,I))
         IF ( Z1L .GE. TZUM(I)  .AND.  Z1L .LT. TZUM(I+1)) THEN
            UPZ = TZU(K,I) + FACTOR*( Z1L - TZUM(I) - FACTOR2 )
            GROWTHDT = GROWTH(K,UPZ)
         GO TO 900
         END IF
  100    CONTINUE
      END IF
  900 RETURN
      END
      REAL FUNCTION CORTIEL(K,TIELINE)
C
C              COMPENSATION IN MISSING SECTION OF TIE LINE FOR
C              PRESENCE OF FAULT NOT PREDICTED IN PREVIOUS (K+1)TH
C              PAIR OF WELLS WHEN TRACING TO THE LEFT TIE LINE I.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /TIELF/ TIELF
             LOGICAL TIELF(MAX_NO_FAULTS)
C
      COMMON /TIELCOMP/ TIELCOMP
             REAL*4 TIELCOMP(LOG_LENGTH,20)
C
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
C
      COMMON /CORRMA/ COMAT
            REAL*4 COMAT(LOG_LENGTH,40)
C
      COMMON /IINTA/ IINTA
C
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
C
      CORTIEL = 0.0
      DO 100 J = 1,NFAULT
      IF ( .NOT. TIELF(J)  .AND.  COMAT(IINTA,K) .GT. FINTZ(J,K)  
     1            .AND.  TIELINE  .LT. FINTZ(J,K+1) ) THEN
         CORTIEL = CORTIEL + GROWTHDT(J, TIELINE)
      END IF
  100 CONTINUE
      RETURN
      END
      REAL FUNCTION GGROWTH(DTRAC, I, K, Z)
C
C           SELECTION OF METHOD OF CALCULATION OF MISSING PLUS 
C           EXPANDED SECTION.  THE DECISION DEPENDS ON:
C           1. DIRECTION OF TRACING OR DRAWING, RIGHT OR LEFT,
C           2. DIPPING OF FAULT, LEFT OR RIGHT; AND
C           3. POSITION IN BLOCK, UPTHROW OR DOWNTHROW
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      LOGICAL DTRAC    !  .TRUE. means tracing to the right
C
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21) ! Well-fault intersections
C
      INTEGER*4 I      !   Fault number
C
      INTEGER*4 K      !   Pair of well number
C
      REAL*4 Z         !   Depth
C
C
      IF( DTRAC ) THEN   ! TRACING TO THE RIGHT
         IF(FINTZ(I,K) .LT. FINTZ(I,K+1)) THEN  ! Fault dipping right
            IF(Z .GT. FINTZ(I,K)) THEN   !  Z in upthrow, case 1
               GGROWTH = GROWTH(I,Z)
             ELSE                    !right,right, down, case 2
               continue     ! not possible
            END IF          !  End of fault block
          ELSE              ! right, left
            IF(Z .GT. FINTZ(I,K)) THEN   !  Z in upthrow, case 3
               continue     ! not possible
             ELSE                    !right,left, down, case 4
               GGROWTH = GROWTHDT(I,Z)
            END IF          !  End of fault block
         END IF          !  End of fault dipping block
       ELSE              !  TRACING TO THE LEFT
         IF(FINTZ(I,K) .LT. FINTZ(I,K+1)) THEN  ! Fault dipping right
           IF(Z .GT. FINTZ(I,K+1)) THEN   !  Z in upthrow, case 5
               continue     ! not possible
             ELSE                    !left,right, down, case 6
               GGROWTH = GROWTHDT(I,Z)
            END IF          !  End of fault block
          ELSE              ! left, left
            IF(Z .GT. FINTZ(I,K+1)) THEN   !  Z in upthrow, case 7
               GGROWTH = GROWTH(I,Z)
             ELSE                    !left,left, down, case 8
               continue     ! not possible
            END IF          !  End of fault block
         END IF          !  End of fault dipping block
      END IF             ! End of tracing direction block
      RETURN
      END
