C     CORRELATOR MODULE PPTSPE
C
C***********************************************************************
C
C                    WELL LOG POSTING.
C
C***********************************************************************
C
      SUBROUTINE PPTSPE(IDN,NAME,RLOG1,IL1,RLOG2,IL2,DSTART,
     1                  TOPZ,BOTZ,YL1,PSYMB,NPS,NPAIRS,ROM)
C
C        ELEVATION FOR THE BOTTOM OF THE DISPLAY, FT OR M
      REAL*4 BOTZ
C        ELEVATION FOR THE MIDDLE OF THE DISPLAY, FT OR M
      REAL*4 CDEPTH
C        ELEVATION FOR THE BOTTOM OF THE DISPLAY, FT OR M
      REAL*4 CEND
C        ELEVATION FOR TOP OF DISPLAY, FT OR M  
      REAL*4 CSTART
C        ELEVATION FOR THE SHALLOWEST ANNOTATION, FT OR M
      REAL*4 DS
C        ELEVATION FOR THE SHALLOWEST LOG READING, FT OR M
      REAL*4 DSTART
C        HALF THE DISPLAY LENGTH, FT OR M
      REAL*4 DWIND
C        ELEVATION FOR THE ORIGIN OF LOG READINGS (KELLY
C        BUSHING), FT OR M
      REAL*4 FDELEV
C        NUMBER OF SAMPLING POINTS BETWEEN THE CENTER OF THE
C        DISPLAY AND THE SHALOWEST READING
      INTEGER*4 ICPTH1
C        HALF THE NUMBER OF READINGS IN THE DISPLAY
      INTEGER*4 IDINT
C        NUMBER OF SAMPLING POINTS BETWEEN TOP OF DISPLAY AND 
C        FIRST LOG READING
      INTEGER*4 IDADJ
C        SEQUENTIAL NUMBER FOR THE DEEPEST LOG READING IN
C        THE DISPLAY
      INTEGER*4 IDE
C        SEQUENTIAL NUMBER FOR THE SHALLOWEST LOG READING IN
C        THE DISPLAY
      INTEGER*4 IDS
C        IN DRAWING OF DEPTH SCALE, SEQUENTIAL NUMBER ASSOCIATED
C        TO THE SAMPLING POINTS, WITH 1 BEING FIRST READING AND
C        NEGATIVE NUMBERS DENOTING UNSAMPLED ELEVATIONS.
      INTEGER*4 ILS
C        LENGTH OF INTERVAL WITH NO READINGS BETWEEN KELLY BUSHING 
C        AND FIRST READING, IN NUMBER OF SAMPLING INTERVALS
      INTEGER*4 NOREADINGS
C        SIZE OF DISPLAY FROM TOP TO BOTTOM, INCHES
      REAL*4 XEND
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
      INTEGER*4 DOE
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
C
C          VARIABLE DEFINITION.
C
      CHARACTER*20 NAME
      REAL*4 RLOG1(IL1),RLOG2(IL2)
      INTEGER*4 PSYMB
C
      CHARACTER*1 ROM
      INTEGER*4 TICKMN
      INTEGER*4 TICKSY
C
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER*4 IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LOGPOS/ AELG
             INTEGER*4 AELG
      COMMON /TICKMS/ TIC10,TIC50,TIC100
      COMMON /LOGMAX/ SHLLMX,CORLMX
      COMMON /INCZ/ INCZ
C
      COMMON /CODINC/ DINC
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /DORIGIN/ DEPOR
             CHARACTER*1 DEPOR
      COMMON /ELOD/  ELOD
             CHARACTER*1 ELOD
C
      IF ( ELOD .EQ. 'E') THEN
         DOE = -1
       ELSE
         DOE = 1
      END IF
      CALL CENWID(TOPZ,BOTZ,CDEPTH,DWIND)
      Y20=YL1+TKWD
      Y20P5=Y20 + TIC10
      Y20P8=Y20 + TIC50
      Y21=Y20 + TIC100
      YMID=Y20+0.5*DSWH
      Y27=Y20+DSWH
      Y26=Y27 - TIC100
      Y26P8=Y27 - TIC50
      Y26P5=Y27 - TIC10
      Y47 = Y27 + TKWD
      TICKMN = 10*INCZ
      TICKSY = 5*INCZ
      ICPTH1=ANINT((CDEPTH-DSTART)/DINC+1.0)
C      ICPTH1=ANINT((CDEPTH-DSTART)/DINC+1.5)     !2/2002
      IDINT=DWIND/DINC+0.05
C      IDINT=ANINT(DWIND/DINC+0.5)
      IDS=MAX0(1,ICPTH1-IDINT)
      IDE=MIN0(IL1,ICPTH1+IDINT)
      IDADJ=ICPTH1-IDINT
      SCALE=1.0/VSCALE
      XEND=XTOP+(DINC*SCALE*FLOAT(IDE-IDS))
      IF(TOPZ . LT. DSTART) XEND=XEND+(SCALE*(DSTART-TOPZ))
         IF(ROM.EQ.'R') THEN
            FDELEV = DATUM1

          ELSE
            FDELEV = DATUM2
         END IF
      IF (DEPOR .EQ. 'S') THEN
         DS=FLOAT((NINT(SEQDEP(IDADJ,DSTART,DINC))/INCZ)*INCZ)
       ELSE
         DS=FLOAT((NINT(SEQDEP(IDADJ,DSTART,DINC) + FDELEV)/
     1                       INCZ)*INCZ) - FDELEV
      END IF
      ILS=ANINT((DS-DSTART)/DINC+1.0)
      ILB=ILS
      ILI=ANINT(INCZ/DINC)
C
C          WELL NAME.
C
      IF ( MENU .NE. 'TDIP') THEN
         IF(AELG.EQ.1 .AND. NPS.GT.1 .AND. ROM.EQ.'R') GO TO 15
      END IF
      CALL WELLDY(YMID,IDN,NAME,PSYMB,NPS,ROM)
C
C          LOG TYPES.
C
      CALL LGSLAB(YMID,ROM)
C
C          DISPLAY DEPTH SCALE
C
      CALL GMPLCR(1)
      DEND=DSTART+(AMAX0(IL1,IL2)*DINC)-DINC       ! FDELEV and DSTART
      NOREADINGS = -((FDELEV + DSTART)/DINC + 0.05)  ! have opposite
      IF( DSTART .GE. BOTZ  .OR. DEND .LE. TOPZ) GO TO 8999 !  signs
      DELTA = CSTART + FDELEV   ! CSTART & FDELEV have opposite signs
      IF (DELTA .LT. 0.0  .AND. DATUMF .EQ. 1) THEN
         STARTDS = XTOP - (FDELEV + CSTART)/VSCALE 
        ELSE
         STARTDS = XTOP
      END IF                       
      CALL GMPMOV(STARTDS,Y20)
      CALL GMPDRW(XEND,Y20)
      CALL GMPMOV(XEND,Y27)
      CALL GMPDRW(STARTDS,Y27)
   11 IF (ILS .GT. IDE  ) GO TO 15
C      IF (ILS .LT. IDADJ ) GO TO 13
      IF (ILS .LT. IDADJ  .OR.  ILS .LT. NOREADINGS) GO TO 13
      X=XTOP+FLOAT(ILS-IDADJ)*SCALE*DINC
      IF (DEPOR .EQ. 'S') THEN
         ILL = ANINT(DS+FLOAT(ILS-ILB)*DINC)
       ELSE
         ILL = ANINT(DS+FDELEV+FLOAT(ILS-ILB)*DINC)  
      END IF
      IF (MOD(ILL,TICKMN) .EQ. 0) GO TO 12
      IF (MOD(ILL,TICKSY) .EQ. 0) GO TO 14
C      IF (MOD(ILL,TICKMN) .LT. DINC) GO TO 12
C      IF (MOD(ILL,TICKSY) .LT. DINC) GO TO 14
      CALL GMPMOV(X,Y20)
      CALL GMPDRW(X,Y20P5)
      CALL GMPMOV(X,Y26P5)
      CALL GMPDRW(X,Y27)
      GO TO 13
   14 CALL GMPMOV(X,Y20P8)
      CALL GMPDRW(X,Y20)
      CALL GMPMOV(X,Y26P8)
      CALL GMPDRW(X,Y27)
      GO TO 13
   12 CALL GMPMOV(X,Y21)
      CALL GMPDRW(X,Y20)
      CALL GMPMOV(X,Y26)
      CALL GMPDRW(X,Y27)
C      CALL GMPNUM(DOE*ILL/100,X+0.5*ZLSZ,YMID,1.2*ZLSZ,90.0,JUSTIF)  !Baltic
      CALL GMPNUM(DOE*ILL,X+0.5*ZLSZ,YMID,ZLSZ,90.0,JUSTIF)
C      CALL GMPNUM(ILL,X+0.5*ZLSZ,YMID,ZLSZ,90.0,JUSTIF)
   13 ILS=ILS+ILI
      GO TO 11
C
C          DISPLAY SHALE LOG
C
   15 IF ( MENU .NE. 'TDIP') THEN
         IF(AELG.EQ.1 .AND. NPS.GT.1 .AND. ROM.EQ.'R') GO TO 1122
      END IF
      CALL GMPLCR(3)
      IF ( SHLLMX .LT. 0 ) THEN
         RMIN1=+1.0E 30
         RMAX1=-RMIN1
C         DO 111 I=IDS,IDE
         DO 111 I=IDS,IDE
         R=RLOG1(I)
         RMIN1=AMIN1(R,RMIN1)
         RMAX1=AMAX1(R,RMAX1)
  111    CONTINUE
         CALL DRWLOG(RLOG1,IL1,IDS,IDE,IDADJ,DINC,RMAX1,YL1,Y20,SCLSHL)
        ELSE
         CALL DRWLOG(RLOG1,IL1,IDS,IDE,IDADJ,DINC,SHLLMX,YL1,Y20,SCLSHL)
        END IF
C
C          DISPLAY CORRELATION LOG.
C
 1122 IF( MENU .NE. 'TDIP') THEN
         IF(AELG.EQ.1 .AND. NPS.NE.NPAIRS .AND. ROM.EQ.'M') GO TO 8999
      END IF
C      CALL GMPLCR(2)
      CALL GMPLCR(3)
      IDE=MIN0(IL2,ICPTH1+IDINT)
      IF ( CORLMX .LT. 0 ) THEN
         RMIN2=+1.0E 30
         RMAX2=-RMIN2
C         DO 121 I=IDS,IDE
         DO 121 I=IDS,IDE
         R=RLOG2(I)
         RMIN2=AMIN1(R,RMIN2)
         RMAX2=AMAX1(R,RMAX2)
  121    CONTINUE
         CALL DRWLOG(RLOG2,IL2,IDS,IDE,IDADJ,DINC,RMAX2,Y27,Y47,SCLCOL)
       ELSE
         CALL DRWLOG(RLOG2,IL2,IDS,IDE,IDADJ,DINC,CORLMX,Y27,Y47,SCLCOL)
      END IF
 8999 RETURN
      END
C***********************************************************************
C
C                   DRAWS A LOGS.
C
C***********************************************************************
C
      SUBROUTINE DRWLOG(RLOG2,IL2,IDS,IDE,IDADJ,DINC,CORLMX,
     2                  YLFT,YRGT,FSCL)
C
      CHARACTER*1 FSCL
      REAL*4 RLOG2(IL2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      SCALE = 1.0/VSCALE
      IRMX=0
      RMIN2=+1.0E 30
      DO 121 I=IDS,IDE
      R=RLOG2(I)
      RMIN2=AMIN1(R,RMIN2)
  121 CONTINUE
      YSCALE=(YRGT-YLFT)/(CORLMX-RMIN2)
C      YSCALE=TKWD/(CORLMX-RMIN2)
      DO 122 I=IDS,IDE
      X=XTOP+FLOAT(I-IDADJ)*SCALE*DINC
      CALL MOVEPN(RLOG2(I),RMIN2,YSCALE,YLFT,YRGT,FSCL,Y)
      IF (I .GT. IDS) GO TO 1213
C                    FIRST POINT.
      CALL GMPMOV(X,Y)
      IF (RLOG2(I) .GT. CORLMX) IRMX=1
      GO TO 122
 1213 IF (RLOG2(I) .GT. CORLMX) GO TO 1215
C               POINT INSIDE TRACK.
      IF (IRMX .EQ. 0) GO TO 12135
C                    POINT IN FOLLOWING POINT OUT.
      XAUX=X-((DINC*SCALE*(RLOG2(I)-CORLMX))/(RLOG2(I)-RLOG2(I-1)))
      CALL MOVEPN(CORLMX,RMIN2,YSCALE,YLFT,YRGT,FSCL,YAUX)
      CALL GMPMOV(XAUX,YAUX)
C                    POINT IN FOLLOWING POINT IN.
12135 CALL GMPDRW(X,Y)
      IRMX=0
      GO TO 122
C               POINT OUTSIDE TRACK.
C                    PREVIOUS POINT OUT.
 1215 IF (IRMX .EQ. 1) GO TO 122
C                    PREVIOUS POINT IN.
      XAUX=X-((DINC*SCALE*(RLOG2(I)-CORLMX))/(RLOG2(I)-RLOG2(I-1)))
      CALL MOVEPN(CORLMX,RMIN2,YSCALE,YLFT,YRGT,FSCL,YAUX)
      CALL GMPDRW(XAUX,YAUX)
      IRMX=1
  122 CONTINUE
      RETURN
      END
C***********************************************************************
C
C                  FIND ABSCISSA FOR NEXT PEN MOVEMENT.
C
C***********************************************************************
C
      SUBROUTINE MOVEPN(RLOG1,RMIN1,XSCALE,XL1,X20,FSCL,X)
C
      CHARACTER*1 FSCL
C
      X=(RLOG1-RMIN1)*XSCALE
      IF ( FSCL .NE. 'L' ) THEN
         X = XL1 + X
      ELSE
         X = X20 - X
      END IF
      RETURN
      END
C***********************************************************************
C
C                    DISPLAYS TITLE ON TOP OF PLOT.
C
C***********************************************************************
C
      SUBROUTINE DTITLE
C
      INTEGER VEREXA
      CHARACTER*1 EXIS /'X'/
      CHARACTER*6 VEXAG
      CHARACTER*23 TITLE3 /'Vertical exaggeration: '/
      CHARACTER*30 TITLE4
      CHARACTER*25 TITLE5 /'Vertical scale is in feet'/
      CHARACTER*27 TITLE6 /'Vertical scale is in meters'/
      CHARACTER*18 TITLE7 /'Datum is sea level'/
C

      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /TITLE/ TITLE1,TITLE2
             CHARACTER*80 TITLE1,TITLE2
      COMMON /PLATENO/ PLATENO
             CHARACTER*4 PLATENO
      common /menupp/ menu
             character*4 menu
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /YSTARTI/ YSTARTI
      COMMON /YSTART/ YSTART
      COMMON /XTOPIM/ XTOPIM
      COMMON /WTHLEG/ WTHLEG
      COMMON /TITLETRAC/ TITLETRAC
             CHARACTER*36 TITLETRAC
      COMMON /TITLESECT/ TITLESECT
             CHARACTER*32 TITLESECT
      COMMON /TITLEPERS/ TITLEPERS
             CHARACTER*24 TITLEPERS
      COMMON /TITLELITH/ TITLELITH
             CHARACTER*30 TITLELITH
      COMMON /TITLEPORO/ TITLEPORO
             CHARACTER*40 TITLEPORO
      COMMON /TITLETDIP/ TITLETDIP
             CHARACTER*16 TITLETDIP
      COMMON /TITLEADIP/ TITLEADIP
             CHARACTER*22 TITLEADIP
      COMMON /TITLELIT2/ TITLELIT2
             CHARACTER*9 TITLELIT2
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
C
      PARAMETER (UP1 = 3.8, UP2 = 3.2, UP3 = 4.4, UP4= 2.7, UP5 = 5.0 )
C
      C = YSTARTI + 0.5*(YSIZE - YSTARTI)
      IF ( XTOPIM .LE. (XTOP+2.0)) THEN
         XXT = XTOP - 0.4
       ELSE
         XXT = XTOP + 1.0
      END IF
      CALL GMPLCR(4)
C      IF(XXT .LT. 1.0E20) GO TO 100    ! Publication
C
      IF( .NOT. FLASTR) THEN
         call gmptxt('WIRELINE LOGS', XXT-UP3,c,ttlsz,90.0,justif)
      END IF
      call gstxfp(-3,2)
      CALL GMPTXT(TITLE1,XXT-UP1,C,TTLSZ,90.0,JUSTIF)
      CALL GMPTXT(TITLE2,XXT-UP2,C,TTLSZ,90.0,JUSTIF)
      call gstxfp(-1,2)
      IF( .NOT. FLASTR) GO TO 900
      if (menu .eq. 'PERS') then
         call gmptxt(TITLEPERS,XXT-UP3,c,ttlsz,90.0,justif)
       else if (menu .eq. 'TRAC') then
         call gmptxt(TITLETRAC,XXT-UP3,c,ttlsz,90.0,justif)
       else if (menu .eq. 'ADIP') then
         call gmptxt(TITLEADIP, XXT-UP3,c,ttlsz,90.0,justif)
       else if (menu .eq. 'TDIP') then
         call gmptxt(TITLETDIP,XXT-UP3,c,ttlsz,90.0,justif)
       else if (menu .eq. 'LITH') then
         call gmptxt(TITLELITH,XXT-UP3,c,ttlsz,90.0,justif)
       else if (menu .eq. 'PORO') then
         call gmptxt(TITLEPORO,XXT-UP3,c,ttlsz,90.0,justif)
        else if (menu .eq. 'LIT2') then
         call gmptxt(TITLELIT2,XXT-UP3,c,ttlsz,90.0,justif)
      else
         call gmptxt(TITLESECT,XXT-UP3,c,ttlsz,90.0,justif)          
      endif
  100 CALL GMPLCR(1)
C
      IF ( XTOPIM .LE. (XTOP+2.0)) THEN
         C = YSTARTI + 0.5*(YSIZE - YSTARTI)
         XXT = XTOP + 0.15
C         XXT = XTOP
       ELSE
         C = 0.5 + YSIZE + 0.5*WTHLEG
         XXT = XTOPIM + 0.6
      END IF
      VEREXA = NINT(ANINT(HSCALE/VSCALE))
      IF ( .NOT.(MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')) THEN
         IF ( VEREXA .NE. 1) THEN
            WRITE (VEXAG,'(I6)') VEREXA
            title4 = title3//vexag//exis
C            title4 = ' '              !Publication
          ELSE
            TITLE4 = '  No vertical exaggeration  '
          END IF
            CALL GMPTXT(TITLE4,XXT-UP4,C,0.65*TTLSZ,90.0,JUSTIF)
       ELSE
         IF ( XTOPIM .LE. (XTOP+2.0)) THEN
            XXT = XTOP + 0.5
          ELSE
            XXT = XXT + 2.0
         END IF
      END IF
      IF (BOM .EQ. 'F') THEN
C            title5 = ' '                !Publication
         CALL GMPTXT(TITLE5,XXT-UP4-0.5,C,0.65*TTLSZ,90.0,JUSTIF)
       ELSE
         CALL GMPTXT(TITLE6,XXT-UP4-0.5,C,0.65*TTLSZ,90.0,JUSTIF)
      END IF
C      XTOPIM = XTOPIM - 0.8
C**
C        Publication
C      CALL GMPTXT(TITLE7,XXT-UP4-1.0,C,0.65*TTLSZ,90.0,JUSTIF)
C      CALL GMPOIL(XXT-UP4-2.1,C-0.6,14,SYMSZ,0.01)
C      CALL GMPTXT('Dry well',XXT-UP4-2.0,C-0.4,0.65*TTLSZ,90.0,-1)
C      CALL GMPOIL(XXT-UP4-2.6,C-0.6,12,SYMSZ,0.01)
C      CALL GMPTXT('Gas well',XXT-UP4-2.5,C-0.4,0.65*TTLSZ,90.0,-1)
C      CALL GMPOIL(XXT-UP4-3.1,C-0.6,11,SYMSZ,0.01)
C      CALL GMPTXT('Oil well',XXT-UP4-3.0,C-0.4,0.65*TTLSZ,90.0,-1)
C      CALL GMPTXT('PRODUCTION SYMBOLS',XXT-UP4-3.6,C,0.65*TTLSZ,90.0,0)
C**
      IF (MENU .EQ. 'SECT' .OR. MENU .EQ. 'ADIP'  .OR.
     1                          MENU .EQ. 'TDIP'  .OR.
     2    MENU .EQ. 'LITH' .OR. MENU .EQ. 'PERS' .OR.
     3    MENU .EQ. 'PORO') CALL WCLEGE
  900 IF ( PLATENO .NE. '    ') THEN
         CALL GMPLCR(1)
         C = 0.5 + YSIZE + 0.5*WTHLEG
         IF ( XTOPIM .LE. (XTOP+2.0)) THEN
            XXT = XTOPIM - 2.0
          ELSE
            XXT = XTOPIM - UP5
            IF ( MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'LIT2')
     1             XXT =  XXT + 1.5
         END IF
         IF (MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP') XXT = XXT + 2.0
         CALL GMPTXT('PLATE '//PLATENO,XXT,C,0.8*TTLSZ,90.0,JUSTIF)
      END IF
      RETURN
      END
      SUBROUTINE WELLDY(YMID,IDN,NAME,PSYMB,I,ROM)
C
C                    DISPLAYS WELL IDENTIFICATION AND SYMBOL
C
C***********************************************************************
C
      INTEGER*4 PSYMB
      CHARACTER*1 ROM
      CHARACTER*20 NAME
C
      COMMON /CHARPP/ SON
             CHARACTER*1 SON
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LOGPOS/ AELG
             INTEGER AELG
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
C
      IF(ROM.EQ.'R') THEN
         FDELEV = DATUM1
       ELSE
         FDELEV = DATUM2
      END IF
      DELTA = CSTART + FDELEV   ! CSTART & FDELEV have different signs
      IF (DATUMF .EQ. 1  .AND.  DELTA .LT. 0.0) THEN
         XLL = XTOP - 0.3 - DELTA/VSCALE    
       ELSE
         XLL = XTOP - 0.3    
      END IF
      IF ( PSYMB .EQ. 5 ) THEN
         SYMBSZ = 0.5*SYMSZ
        ELSE
         SYMBSZ = SYMSZ
        END IF
      CALL GMPLCR(1)
      CALL GMPOIL(XLL-0.06,YMID,PSYMB,SYMBSZ,0.01)
C      CALL GMPOIL(XLL,YMID,PSYMB,SYMBSZ,0.01)
C**      SPECIAL DISPLAY OF CROSSINGS IN OFR2000-49 PLATES, OLEA,WATNEY,DAVIS
C**      DISPLAY OF CROSSINGS IN PLATES 2A AND 2B
C      IF (I.EQ.1  .AND.  ROM .EQ. 'R') THEN
C         CALL GMPOIL(XTOP-1.5,YMID,15,0.8,0.01) !!
C         CALL GMPNUM(5,XTOP-1.4,YMID,0.2,90.0,JUSTIF)
C      END IF
C      IF (I.EQ.5  .AND.  ROM .EQ. 'M') THEN
C         CALL GMPOIL(XTOP-1.5,YMID,15,0.8,0.01) !!
C         CALL GMPNUM(6,XTOP-1.4,YMID,0.2,90.0,JUSTIF)
C      END IF
C      IF (I.EQ.6  .AND.  ROM .EQ. 'M') THEN
C         CALL GMPOIL(XTOP-1.5,YMID,15,0.8,0.01) !!
C         CALL GMPNUM(7,XTOP-1.4,YMID,0.2,90.0,JUSTIF)
C      END IF
C**
C**
C**      SPECIAL DISPLAY OF BOTTOMS IN MECKLENBURG-BRANDENBURG.
      IF (IDN.EQ.5  .AND.  ROM .EQ. 'M') THEN
         CALL GMPLCR(13)
         CALL GMPTXT('tolmR',RINCH(343.6),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPTXT('tpa',RINCH(553.6),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPLCR(6)
         CALL GMPTXT('joki(o)',RINCH(571.6),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPTXT('jmal',RINCH(1013.6),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPTXT('juhe',RINCH(1336.6),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPLCR(2)
         CALL GMPTXT('ko4',RINCH(1383.6),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPTXT('ku',RINCH(1860.6),YMID,0.3*TTLSZ,90.0,JUSTIF)
      END IF
      IF (IDN.EQ.13  .AND.  ROM .EQ. 'M') THEN
         CALL GMPLCR(13)
         CALL GMPTXT('tolRT',RINCH(324.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPTXT('tpa',RINCH(524.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPLCR(7)
         CALL GMPTXT('krc',RINCH(548.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPLCR(6)
         CALL GMPTXT('jm',RINCH(607.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPTXT('juhe',RINCH(1209.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPLCR(2)
         CALL GMPTXT('ko4',RINCH(1231.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPTXT('kuSO',RINCH(2279.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
         CALL GMPTXT('mu',RINCH(2652.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
C         CALL GMPTXT('soS',RINCH(2931.5),YMID,0.3*TTLSZ,90.0,JUSTIF)
      END IF
      CALL GMPLCR(1)
C
      IF (SON .EQ. 'N') THEN
         IF ( AELG . EQ. 0   .AND.  MOD(I,2) .NE. 0  .AND.
     1        ROM .EQ. 'M' ) THEN
            XLL = XTOP - 0.6 - (1.66*WIDSZ)
          ELSE
            XLL = XTOP - 0.6
         END IF
      IF (DATUMF .EQ. 1  .AND.  DELTA .LT. 0.0) THEN
            XLL = XTOP - 0.6 - DELTA/VSCALE
         END IF
C         CALL GMPTXT(NAME,XLL,YMID,1.25*WIDSZ,90.0,JUSTIF)
         CALL GMPTXT(NAME,XLL,YMID,WIDSZ,90.0,JUSTIF)
       ELSE
         CALL GMPNUM(IDN,XTOP-0.6,YMID,WIDSZ,90.0,JUSTIF)
      END IF
      RETURN
      END
C***********************************************************************
C
C               LEGEND ON PLOTS FOR WEIGHTED-CORRELATION SCALE.
C
C***********************************************************************
C
      SUBROUTINE WCLEGE
C
      CHARACTER*27 TITLE(3)
     1            /'Correlation strength scale',
C     2             '     Magnetic index' ,
C     2             '     Acoustic index' ,
     2             'Shale content, percentage',
C     2              'Transit time, microsec/ft',
C     3             'Density index' /
     3             'Porosity, percentage' /
C
      COMMON /WCCMIN/ WCCMIN
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /YSTARTI/ YSTARTI
      COMMON /YSTART/ YSTART
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      common /menupp/ menu
             character*4 menu
      COMMON /XTOPIM/ XTOPIM
      COMMON /WTHLEG/ WTHLEG
      COMMON /PORPAR/ PORMAX, PHISHALE
C
      CALL GMPLCR(1)
      IF ( XTOPIM .LE. (XTOP+2.0)) THEN
         C = YSTARTI + 0.5*(YSIZE - YSTARTI)
C         XXT = XTOP + 0.7
         XXT = XTOP + 0.05
       ELSE
         C = 0.5 + YSIZE + 0.5*WTHLEG
         XXT = XTOPIM - 2.0
      IF ( MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP') XXT = XXT + 2.0
C         XXT = XTOPIM + 1.0
      END IF
C      C = 4.05 + C    !Fig 11.15 & 11.17
C      XXT = XXT + 2.78  ! Fig 11.15 & 11.17
      DELCUT = (1.0 - WCCMIN)/5.0
      YLEFT = C - 0.5 - 0.50*TTLSZ
      YRIGHT = YLEFT + 1.0
      IF ( MENU .NE. 'LITH'  .AND.  MENU .NE. 'PORO') THEN
         IT = 1
         CORR = WCCMIN - 0.5*DELCUT
         CALL GMPREA(WCCMIN,2,XXT-1.27,YLEFT+0.05,0.45*TTLSZ,90.0,
     1               JUSTIF)
         CALL GMPREA(1.0,1,XXT-1.27,YRIGHT,0.45*TTLSZ,90.0,JUSTIF)
       ELSE IF ( MENU .EQ. 'LITH') THEN
         IT = 2
         CORR = 1.0 + 0.5*DELCUT
C         CALL GMPREA(60.0,1,XXT-1.3,YLEFT,0.4*TTLSZ,90.0,JUSTIF) !T. time
C         CALL GMPREA(120.0,1,XXT-1.3,YRIGHT,0.4*TTLSZ,90.0,JUSTIF) !T. time
         CALL GMPREA(0.0,1,XXT-1.27,YLEFT+0.05,0.45*TTLSZ,90.0,JUSTIF)
         CALL GMPREA(100.0,1,XXT-1.27,YRIGHT,0.45*TTLSZ,90.0,JUSTIF)
       ELSE IF ( MENU .EQ. 'PORO') THEN
         IT = 3
         DELCUT = PORMAX/5.0
         CORR = 0.0 - 0.5*DELCUT
         CALL GMPREA(0.0,1,XXT-1.27,YLEFT+0.05,0.45*TTLSZ,90.0,JUSTIF)
         CALL GMPREA(100.0*PORMAX,1,XXT-1.27,YRIGHT,0.45*TTLSZ,90.0,
     1               JUSTIF)
      END IF
      CALL GMPTXT(TITLE(IT),XXT-2.1,C,0.6*TTLSZ,90.0,JUSTIF)
C
      XLOW = XXT - 1.8
      XHIGH = XXT - 1.5
      Y = YLEFT + 0.09
      DO 101 I = 1,5
       IF ( MENU .NE. 'LITH') THEN
          CORR = CORR + DELCUT
        ELSE
          CORR = CORR - DELCUT
      END IF
      CALL PENSET(CORR,NPEN)
      CALL GMPLCR(NPEN)
      DO 101 J = 1,20
      Y = Y + 0.01
      CALL GMPMOV(XLOW,Y)
      CALL GMPDRW(XHIGH,Y)
  100 CONTINUE
  101 CONTINUE
      RETURN
      END
C***********************************************************************
C
C               DRAWS BLOCK TITLE ON PLOTS.
C
C***********************************************************************
C
      SUBROUTINE LEGEND
C
      CHARACTER*4 BOMU
      CHARACTER*4 TXTPOR
      CHARACTER*55 TITLE
      CHARACTER*27 TITLE3 /'STARTING DEPTH FOR TRACING '/
C
      INCLUDE 'log.inc'
C
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /PRINTC/ FYLEPR
             CHARACTER*40 FYLEPR
      COMMON /FYLPLO/ FYLPLO
             CHARACTER*40 FYLPLO
      COMMON /FFAULT/ FFAULT
             CHARACTER*40 FFAULT
      COMMON /IFAULT/ IFAULT
         INTEGER*2 IFAULT
      COMMON /FYLDAT/ NDATUM
             CHARACTER*40 NDATUM
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /COFIPR/ COFIPR
             CHARACTER*40 COFIPR
      COMMON /FYLTRA/ FILTRA
             CHARACTER*40 FILTRA
      COMMON /TRACNG/ TSTART,TEND
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /TITLE0/ TITLE0
             CHARACTER*25 TITLE0
      COMMON /TITLE/ TITLE1,TITLE2
             CHARACTER*80 TITLE1,TITLE2
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /YSTART/ YSTART
      COMMON /BBOTM/ BBOTM
      COMMON /WTHLEG/ WTHLEG
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /SPEFIL/ SPEFIL
             CHARACTER*40 SPEFIL
      COMMON /XRCOMM/ XR
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /STRACOF/ STRACOFL,STRACOFR
             CHARACTER*40 STRACOFL,STRACOFR
      COMMON /IFSC/ IFSC
      COMMON /PRINTINTERP/ FYLEINTERP
             CHARACTER*40 FYLEINTERP
      COMMON /PORPAR/ PORMAX, PHISHALE
      COMMON /LITHF/ LITHF
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /TITLETRAC/ TITLETRAC
             CHARACTER*36 TITLETRAC
      COMMON /TITLESECT/ TITLESECT
             CHARACTER*32 TITLESECT
      COMMON /TITLEPERS/ TITLEPERS
             CHARACTER*24 TITLEPERS
      COMMON /TITLELITH/ TITLELITH
             CHARACTER*30 TITLELITH
      COMMON /TITLEPORO/ TITLEPORO
             CHARACTER*40 TITLEPORO
      COMMON /TITLETDIP/ TITLETDIP
             CHARACTER*16 TITLETDIP
      COMMON /TITLEADIP/ TITLEADIP
             CHARACTER*22 TITLEADIP
      COMMON /TITLELIT2/ TITLELIT2
             CHARACTER*9 TITLELIT2
      COMMON /FILCOLITH/ FILCOLITH
      CHARACTER*40 FILCOLITH
C
      include 'corrdb.inc'
C
      CALL GMPLCR(1)
      YLEFT = 0.5 + YSIZE
      C = YLEFT + 0.5*WTHLEG
      YRIGHT = YLEFT + WTHLEG
      Y1 = 0.6 + YLEFT
      BBOTM = XSIZE - 0.5
      XR = BBOTM - (0.7 - TTLSZ)
      TITLE = 'PROCESSED BY:  '//FYLEINTERP
      CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
      XR = XR - TTLSZ
      IF (MENU .EQ. 'PORO') THEN
         WRITE(TXTPOR,"(F4.2)") PORMAX
         TITLE = 'APPARENT SHALE POROSITY (0-1):  '//TXTPOR
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      TITLE = 'PRINTING FILE:  '//FYLEPR
      CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
      XR = XR - TTLSZ
      TITLE = 'PLOTTING FILE:  '//FYLPLO
      CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
      XR = XR - TTLSZ
      IF ( IFAULT .EQ. 1  .AND.
     1     .NOT.(MENU .EQ. 'TDIP'  .OR.  MENU .EQ. 'ADIP')) THEN
         TITLE = 'FAULT FILE:  '//FFAULT
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF ( DATUMF .EQ. 2 ) THEN
         TITLE = 'DATUM FILE:  '//NDATUM
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF (MENU .EQ. 'TRAC') THEN
         TITLE = 'MARKER FILE:  '//FILTRA
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF (MENU .EQ. 'LIT2') THEN
         TITLE = 'FALSE COLOR LITHOLOGY FILE:  '//FILCOLITH
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
C
      IF (MENU .EQ. 'PERS') THEN
         WRITE (TITLE,9001) TEND,BOMU(BOM)
 9001    FORMAT('ENDING DEPTH FOR TRACING:  ',F8.2,' ',A4)
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
         WRITE (TITLE,9002) TSTART,BOMU(BOM)
 9002    FORMAT('STARTING DEPTH FOR TRACING:  ',F8.2,' ',A4)
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF ( LITHF .EQ. 2  .OR.  LITHF .EQ. 3) THEN
         TITLE = 'RIGHT:   '//LFILER
         CALL GMPTXT(TITLE,XR,Y1+0.2,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF ( LITHF .EQ. 1  .OR.  LITHF .EQ. 3) THEN
         TITLE = 'LEFT:  '//LFILEL
         CALL GMPTXT(TITLE,XR,Y1+0.2,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF ( LITHF .EQ. 3) THEN
         TITLE = 'LITHOLOGY FILES:'
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
       ELSE IF ( IFSC .NE. 0) THEN
         TITLE = 'LITHOLOGY FILE:'
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF ( IFSC .EQ. 2  .OR.  IFSC .EQ. 3) THEN
         TITLE = 'RIGHT:   '//STRACOFR
         CALL GMPTXT(TITLE,XR,Y1+0.2,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF ( IFSC .EQ. 1  .OR.  IFSC .EQ. 3) THEN
         TITLE = 'LEFT:  '//STRACOFL
         CALL GMPTXT(TITLE,XR,Y1+0.2,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      IF ( IFSC .EQ. 3) THEN
         TITLE = 'STRATIGRAPHIC COLUMN FILES:'
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
       ELSE IF ( IFSC .NE. 0) THEN
         TITLE = 'STRATIGRAPHIC COLUMN FILE:'
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      TITLE = 'SPECIFICATION FILE:  '//SPEFIL
      CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
      XR = XR - TTLSZ
      IF ( COFIPR .NE. '*????*' ) THEN
         TITLE = 'SOURCE FILE:  '//COFIPR
         CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
         XR = XR - TTLSZ
      END IF
      TITLE = 'CORRELATION DATA FILE:  '//CORRFN
      CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
      XR = XR - TTLSZ
      TITLE = 'WELL DATA FILE:  '//FYLES
      CALL GMPTXT(TITLE,XR,Y1,0.4*TTLSZ,90.0,-1)
      XR = XR - (0.7 - 0.6*TTLSZ)
      CALL GMPMOV(XR,YRIGHT)
      CALL GMPDRW(XR,YLEFT)
      XR = XR - (0.7 - TTLSZ)
C
      CALL PLDATE(XR,C)
      CALL BLOTIT(TITLE2,XR,C)
      CALL BLOTIT(TITLE1,XR,C)
      IF (MENU .EQ. 'PERS') THEN
         CALL GMPTXT(TITLEPERS,XR,C,0.5*TTLSZ,90.0,JUSTIF)
       ELSE IF (MENU .EQ. 'TRAC') THEN
         CALL GMPTXT(TITLETRAC,XR,C, 0.5*TTLSZ,90.0,JUSTIF)
       ELSE IF (MENU .EQ. 'ADIP') THEN
         CALL GMPTXT(TITLEADIP,XR,C,0.5*TTLSZ,90.0,JUSTIF)
       ELSE IF (MENU .EQ. 'TDIP') THEN
         CALL GMPTXT(TITLETDIP,XR,C,0.5*TTLSZ,90.0,JUSTIF)
       ELSE IF (MENU .EQ. 'LITH') THEN
         CALL GMPTXT(TITLELITH,XR,C,0.5*TTLSZ,90.0,JUSTIF)
       ELSE IF (MENU .EQ. 'PORO') THEN
         CALL GMPTXT(TITLEPORO,XR,C,0.5*TTLSZ,90.0,JUSTIF)
       ELSE IF (MENU .EQ. 'LIT2') THEN
         CALL GMPTXT(TITLELIT2,XR,C,0.5*TTLSZ,90.0,JUSTIF)
       ELSE
         IF ( FLASTR) THEN
            CALL GMPTXT(TITLESECT,XR,C,0.5*TTLSZ,90.0,JUSTIF)
          ELSE
            CALL GMPTXT('WIRELINE LOGS',XR,C,0.5*TTLSZ,90.0,JUSTIF)
         END IF
      ENDIF
      XR = XR - (0.7 - 0.5*TTLSZ)
      CALL GMPMOV(XR,YRIGHT)
      CALL GMPDRW(XR,YLEFT)
      XR = XR - (0.7 - TTLSZ)
C
      CALL GMPTXT(TITLE0,XR,C,0.7*TTLSZ,90.0,JUSTIF)
      XR = XR - (0.7 - 0.3*TTLSZ)
      CALL PLTBOX(0,0,1,XR,BBOTM,YRIGHT,YLEFT)
C
      RETURN
      END
      SUBROUTINE BLOTIT(TITLE,XR,C)
C
C                  BREAKS A LONG TITLE BY SEARCHING FOR A SPACING
C                  FROM THE 30TH TO THE 50TH CHARACTER.
C
C***********************************************************************
C
      CHARACTER*80 TITLE
      CHARACTER*50 TITLE1,TITLE2
C
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
C        LAST CHARACTER.
C
      DO 100 I = 80,41,-1
      IF ( TITLE(I:I) .NE. ' ') GO TO 110
  100 CONTINUE
C
C        TITLE SHORTHER THAN 40 CHARACTERS.
C
      CALL GMPTXT(TITLE,XR,C,0.5*TTLSZ,90.0,JUSTIF)
      GO TO 400
C
C        TITLE LONGER THAN 40 CHARACTERS.
C
  110 TITLE1 = ' '
      TITLE2 = ' '
      DO 200 K = 1,11
      I = K - 1
C        SEARCH FOR CLOSEST SPACING TO THE 40TH CHARACTER.
      IF (TITLE(40+I:40+I) .EQ. ' ') THEN
         TITLE1(1:I+39)=TITLE(1:I+39)
         TITLE2(1:40-I)=TITLE(I+40:80)
         GO TO 300
      END IF
      IF (TITLE(40-I:40-I) .EQ. ' ') THEN
         IB=40-I
         TITLE1(1:IB-1)=TITLE(1:IB-1)
         TITLE2(1:80-IB)=TITLE(IB+1:80)
         GO TO 300
      END IF
  200 CONTINUE
C
C        NO SPACING, ARBITRARY BREAK.
C
      TITLE1(1:40)=TITLE(1:40)
      TITLE1(41:41) = '-'
      TITLE2(1:40)=TITLE(41:80)
C
C        DISPLAY THE LONG TITLE.
C
  300 CALL GMPTXT(TITLE2,XR,C,0.5*TTLSZ,90.0,JUSTIF)
      XR = XR - TTLSZ
      CALL GMPTXT(TITLE1,XR,C,0.5*TTLSZ,90.0,JUSTIF)
  400 XR = XR - TTLSZ
      RETURN
      END
      SUBROUTINE HORSCALE
C
C                    DISPLAY OF HORIZONTAL SCALE BAR
C
C***********************************************************************
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
C
      CALL GMPLCR(1)
      IF (BOM .EQ. 'F') THEN
         IF (HSCALE .LT. 1500.0) THEN
            CALL FOOTBAR
          ELSE
            CALL MILEBAR
         END IF
       ELSE
         CALL METRICBAR
      END IF
      RETURN
      END
      SUBROUTINE FOOTBAR
C
C                    DISPLAY OF HORIZONTAL SCALE BAR IN FEET
C
C***********************************************************************
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /XTOPIM/ XTOPIM
      COMMON /WTHLEG/ WTHLEG
C        CLASS CUTOFF IN THE DEFINITION OF THE DIFFERENT KIND OF BARS
      REAL*4 CUT(6) /0.3, 0.45, 0.75, 1.5, 2.25, 3.25/
C        DISTANCES FOR THE TICK MARKS IN METER BAR
      REAL*4 DTMK(3,5) /  0.3281, 0.6562, 0.9843,
     2                0.6562, 1.3124, 1.9686,
     3                1.3124, 2.6248, 3.9372,
     4                1.605, 3.281, 4.9215,
     5                2.6248, 5.2496, 7.8744/
C        LABELS FOR THE FEET SCALE
      REAL*4 FLAB(5) /  1.0, 2.0, 4.0, 5.0, 8.0/
C        LABELS FOR THE METER SCALE
      REAL*4 ML(3,5) /  0.1, 0.2, 0.3,
     2                0.2, 0.4, 0.6,
     3                0.4, 0.8, 1.2,
     4                0.5, 1.0, 1.5,
     5                0.8, 1.6, 2.4/
C        ORDER OF MAGNITUDE OF VARIABLE SF
      INTEGER*4 POWSF
C        DIVIDER TO BRING THE HORIZONTAL SCALE TO ONE OF THE BASIC TYPES
      REAL*4 SF
C        UNITS
      CHARACTER*2 TITLE(2) /'ft',  'm' /
C        INDEX ASSIGNED TO THE FIVE BASIC KINDS OF BAR
      INTEGER*4 TYPE
C
C         DETERMINATION OF BAR TYPE
C
      CUT0 = CUT(1)
      CUT7 = 10.0*CUT(2)
      SF = 1.0
  100 SFHSC = HSCALE/SF   ! Variable change to allow scale reduction
      IF (SFHSC .GE. CUT0  .AND.  SFHSC .LT. CUT(3)) THEN
         TYPE = 1
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(3)  .AND.  SFHSC .LT. CUT(4)) THEN
         TYPE = 2
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(4)  .AND.  SFHSC .LT. CUT(5)) THEN
         TYPE = 3
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(5)  .AND.  SFHSC .LT. CUT(6)) THEN
         TYPE = 4
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(6)  .AND.  SFHSC .LT. CUT7) THEN
         TYPE = 5
         GO TO 200
        ELSE              ! Too large a scale to fit in a 2-inch bar
         SF = 10.0*SF     ! Keep track of scale reduction
         CUT0 = CUT(2)
         GO TO 100
      END IF
  200 POWSF = INT(ALOG10(SF))
      FACTOR = 2.0*SFHSC  ! number of field feet in a 2-inch long bar
      XXT = XTOPIM - 1.3
      CENTER = -0.1 + YSIZE + 0.5*WTHLEG + 0.3*TTLSZ*POWSF
      YLEFT = CENTER - FLAB(TYPE)/FACTOR
      YRIGHT = CENTER + FLAB(TYPE)/FACTOR
C
C        A. FOOT BAR
C
      Y25 = CENTER - 0.5*FLAB(TYPE)/FACTOR
      Y75 = CENTER + 0.5*FLAB(TYPE)/FACTOR
      CALL GMPREA(0.0,0,XXT,YLEFT,0.6*TTLSZ,90.0,0)
      CALL GMPREA(SF*FLAB(TYPE),0,XXT,YRIGHT,0.6*TTLSZ,90.0,0)
      YUN = YRIGHT + 0.25 + 0.3*TTLSZ*POWSF
      CALL GMPTXT(TITLE(1),XXT,YUN,0.6*TTLSZ,90.0,-1)
      XXT = XXT + 0.2
      CALL GMPMOV(XXT-0.1,YLEFT)
      CALL GMPDRW(XXT,YLEFT)
      CALL GMPDRW(XXT,YRIGHT)
      CALL GMPDRW(XXT-0.1,YRIGHT)
      CALL GMPDRW(XXT-0.1,YLEFT)
      CALL GMPMOV(XXT-0.1,Y25)
      CALL GMPDRW(XXT,Y25)
      CALL GMPMOV(XXT-0.05,YLEFT)
      CALL GMPDRW(XXT-0.05,Y25)
      CALL GMPMOV(XXT-0.1,CENTER)
      CALL GMPDRW(XXT,CENTER)
      CALL GMPMOV(XXT-0.1,Y75)
      CALL GMPDRW(XXT,Y75)
      CALL GMPMOV(XXT-0.05,CENTER)
      CALL GMPDRW(XXT-0.05,Y75)
C
C        B. KILOMETER BAR
C
      ND = 0
      IF ( POWSF .EQ. 0 )  ND = 1
      XXT = XXT + 0.3
      Y05 = YLEFT + DTMK(1,TYPE)/SFHSC
      Y1 = YLEFT + DTMK(2,TYPE)/SFHSC
      Y15 = YLEFT + DTMK(3,TYPE)/SFHSC
      CALL GMPMOV(XXT+0.1,YLEFT)
      CALL GMPDRW(XXT,YLEFT)
      CALL GMPDRW(XXT,Y15)
      CALL GMPDRW(XXT+0.1,Y15)
      CALL GMPDRW(XXT+0.1,YLEFT)
      CALL GMPMOV(XXT+0.05,YLEFT)
      CALL GMPDRW(XXT+0.05,Y05)
      CALL GMPMOV(XXT+0.1,Y05)
      CALL GMPDRW(XXT,Y05)
      CALL GMPMOV(XXT+0.05,Y15)
      CALL GMPDRW(XXT+0.05,Y1)
      CALL GMPMOV(XXT+0.1,Y1)
      CALL GMPDRW(XXT,Y1)
      XXT = XXT + 0.4
      CALL GMPREA(0.0,ND,XXT,YLEFT,0.6*TTLSZ,90.0,0)
      IF (POWSF .LE. 2) THEN
         CALL GMPREA(SF*ML(1,TYPE),ND,XXT,Y05,0.6*TTLSZ,90.0,0)
         CALL GMPREA(SF*ML(2,TYPE),ND,XXT,Y1,0.6*TTLSZ,90.0,0)
      END IF
      CALL GMPREA(SF*ML(3,TYPE),ND,XXT,Y15,0.6*TTLSZ,90.0,0)
      CALL GMPTXT(TITLE(2),XXT,YUN,0.6*TTLSZ,90.0,-1)
C
      RETURN
      END
      SUBROUTINE MILEBAR
C
C                    DISPLAY OF HORIZONTAL SCALE BAR IN MILES
C
C***********************************************************************
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /XTOPIM/ XTOPIM
      COMMON /WTHLEG/ WTHLEG
C        CLASS CUTOFF IN THE DEFINITION OF THE DIFFERENT KIND OF BARS
      REAL*4 CUT(6) /1500.0, 2376.0, 3960.0, 7920.0, 11880.0, 17160.0/
C        DISTANCES FOR THE TICK MARKS IN KILOMETER BAR
      REAL*4 DTMK(3,5) /  1641.0, 3281.0, 4921,
     2                3281.0, 6562.0, 9842.0,
     3                6562.0, 13123.0, 19685.0,
     4                13123.0, 26246.0, 26246.0,
     5                13123.0, 26246.0, 39370.0/
C        LABELS FOR THE KILOMETER SCALE
      REAL*4 KL(3,5) /  0.5, 1.0, 1.5,
     2                1.0, 2.0, 3.0,
     3                2.0, 4.0, 6.0,
     4                4.0, 8.0, 8.0,
     5                4.0, 8.0, 12.0/
C        LABELS FOR THE MILE SCALE
      REAL*4 ML(2,5) /  0.5, 1.0,
     2                1.0, 2.0,
     3                2.0, 4.0,
     4                2.5, 5.0,
     5                4.0, 8.0/
C        DECIMALS IN NUMERICAL LABELS
      INTEGER*4 ND
C        ORDER OF MAGNITUDE OF VARIABLE SF
      INTEGER*4 POWSF
C        DIVIDER TO BRING THE HORIZONTAL SCALE TO ONE OF THE BASIC TYPES
      REAL*4 SF
C        UNITS
      CHARACTER*2 TITLE(2) /'mi',  'km' /
C        INDEX ASSIGNED TO THE FIVE BASIC KINDS OF BAR
      INTEGER*4 TYPE
C
C         DETERMINATION OF BAR TYPE
C
      CUT0 = CUT(1)
      CUT7 = 10.0*CUT(2)
      ND = 0
      SF = 1.0
  100 SFHSC = HSCALE/SF   ! Variable change to allow scale reduction
      IF (SFHSC .GE. CUT0  .AND.  SFHSC .LT. CUT(3)) THEN
         TYPE = 1
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(3)  .AND.  SFHSC .LT. CUT(4)) THEN
         TYPE = 2
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(4)  .AND.  SFHSC .LT. CUT(5)) THEN
         TYPE = 3
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(5)  .AND.  SFHSC .LT. CUT(6)) THEN
         TYPE = 4
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(6)  .AND.  SFHSC .LT. CUT7) THEN
         TYPE = 5
         GO TO 200
        ELSE              ! Too large a scale to fit in a 2-inch bar
         SF = 10.0*SF     ! Keep track of scale reduction
         CUT0 = CUT(2)
         ND = 0
         GO TO 100
      END IF
C
  200 POWSF = INT(ALOG10(SF))
      FACTOR = 2.0*SFHSC/5280.0  ! field feet in a 2-inch long bar
      XXT = XTOPIM - 1.3
      CENTER = 0.3 + YSIZE + 0.5*WTHLEG + 0.3*TTLSZ*POWSF
C      CENTER = 0.05 + YSIZE + 0.5*WTHLEG + 0.3*TTLSZ*POWSF
      YLEFT = CENTER - ML(2,TYPE)/FACTOR
      YRIGHT = CENTER + ML(2,TYPE)/FACTOR
      IF ( POWSF .EQ. 0 )  THEN
         IF (TYPE .EQ. 1  .OR.  TYPE .EQ. 4)  ND = 1
      END IF  
C
C        A. MILE BAR
C
      Y25 = CENTER - 0.5*ML(2,TYPE)/FACTOR
      Y75 = CENTER + 0.5*ML(2,TYPE)/FACTOR
      CALL GMPREA(0.0,ND,XXT,YLEFT,0.6*TTLSZ,90.0,0)
      CALL GMPREA(SF*ML(1,TYPE),ND,XXT,CENTER,0.6*TTLSZ,90.0,0)
      CALL GMPREA(SF*ML(2,TYPE),ND,XXT,YRIGHT,0.6*TTLSZ,90.0,0)
      YUN = YRIGHT + 0.25 + 0.3*TTLSZ*POWSF
      CALL GMPTXT(TITLE(1),XXT,YUN,0.6*TTLSZ,90.0,-1)
      XXT = XXT + 0.2
      CALL GMPMOV(XXT-0.1,YLEFT)
      CALL GMPDRW(XXT,YLEFT)
      CALL GMPDRW(XXT,YRIGHT)
      CALL GMPDRW(XXT-0.1,YRIGHT)
      CALL GMPDRW(XXT-0.1,YLEFT)
      CALL GMPMOV(XXT-0.1,Y25)
      CALL GMPDRW(XXT,Y25)
      CALL GMPMOV(XXT-0.05,YLEFT)
      CALL GMPDRW(XXT-0.05,Y25)
      CALL GMPMOV(XXT-0.1,CENTER)
      CALL GMPDRW(XXT,CENTER)
      CALL GMPMOV(XXT-0.1,Y75)
      CALL GMPDRW(XXT,Y75)
      CALL GMPMOV(XXT-0.05,CENTER)
      CALL GMPDRW(XXT-0.05,Y75)
C
C        B. KILOMETER BAR
C
      XXT = XXT + 0.3
      Y05 = YLEFT + DTMK(1,TYPE)/SFHSC
      Y1 = YLEFT + DTMK(2,TYPE)/SFHSC
      Y15 = YLEFT + DTMK(3,TYPE)/SFHSC
      CALL GMPMOV(XXT+0.1,YLEFT)
      CALL GMPDRW(XXT,YLEFT)
      CALL GMPDRW(XXT,Y15)
      CALL GMPDRW(XXT+0.1,Y15)
      CALL GMPDRW(XXT+0.1,YLEFT)
      CALL GMPMOV(XXT+0.05,YLEFT)
      CALL GMPDRW(XXT+0.05,Y05)
      CALL GMPMOV(XXT+0.1,Y05)
      CALL GMPDRW(XXT,Y05)
      CALL GMPMOV(XXT+0.05,Y15)
      CALL GMPDRW(XXT+0.05,Y1)
      CALL GMPMOV(XXT+0.1,Y1)
      CALL GMPDRW(XXT,Y1)
      XXT = XXT + 0.4
      CALL GMPREA(0.0,ND,XXT,YLEFT,0.6*TTLSZ,90.0,0)
      CALL GMPREA(SF*KL(1,TYPE),ND,XXT,Y05,0.6*TTLSZ,90.0,0)
      CALL GMPREA(SF*KL(2,TYPE),ND,XXT,Y1,0.6*TTLSZ,90.0,0)
      CALL GMPREA(SF*KL(3,TYPE),ND,XXT,Y15,0.6*TTLSZ,90.0,0)
      CALL GMPTXT(TITLE(2),XXT,YUN,0.6*TTLSZ,90.0,-1)
C
      RETURN
      END
      SUBROUTINE METRICBAR
C
C                    DISPLAY OF HORIZONTAL SCALE BAR IN KILOMETERS
C
C***********************************************************************
C
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /XTOPIM/ XTOPIM
      COMMON /WTHLEG/ WTHLEG
C        CLASS CUTOFF IN THE DEFINITION OF THE DIFFERENT KIND OF BARS
      REAL*4 CUT(6) /0.3, 0.45, 0.75, 1.5, 2.25, 3.25/
C        SCALE LABELS
      REAL*4 MLAB(2,5) /  0.5, 1.0,
     2                1.0, 2.0,
     3                2.0, 4.0,
     4                2.5, 5.0,
     5                4.0, 8.0/
C        DECIMALS IN NUMERICAL LABELS
      INTEGER*4 ND
C        ORDER OF MAGNITUDE OF VARIABLE SF
      INTEGER*4 POWSF
C        DIVIDER TO BRING THE HORIZONTAL SCALE TO ONE OF THE BASIC TYPES
      REAL*4 SF
C        UNITS
      CHARACTER*10 TITLE(2) /'  meters',  'kilometers' /
C        INDEX ASSIGNED TO THE FIVE BASIC KINDS OF BAR
      INTEGER*4 TYPE
C
C         DETERMINATION OF BAR TYPE
C
      CUT0 = CUT(1)
      CUT7 = 10.0*CUT(2)
      SF = 1.0
  100 SFHSC = HSCALE/SF   ! Variable change to allow scale reduction
      IF (SFHSC .GE. CUT0  .AND.  SFHSC .LT. CUT(3)) THEN
         TYPE = 1
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(3)  .AND.  SFHSC .LT. CUT(4)) THEN
         TYPE = 2
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(4)  .AND.  SFHSC .LT. CUT(5)) THEN
         TYPE = 3
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(5)  .AND.  SFHSC .LT. CUT(6)) THEN
         TYPE = 4
         GO TO 200
        ELSE IF ( SFHSC .GE. CUT(6)  .AND.  SFHSC .LT. CUT7) THEN
         TYPE = 5
         GO TO 200
        ELSE              ! Too large a scale to fit in a 2-inch bar
         SF = 10.0*SF     ! Keep track of scale reduction
         CUT0 = CUT(2)
         GO TO 100
      END IF
  200 POWSF = INT(ALOG10(SF))
      FACTOR = 2.0*SFHSC  ! number of field meters in a 2-inch bar
      XXT = XTOPIM - 0.8
      CENTER = 0.4 + YSIZE + 0.5*WTHLEG
      YLEFT = CENTER - MLAB(2,TYPE)/FACTOR
      Y25 = CENTER - 0.5*MLAB(2,TYPE)/FACTOR
      Y75 = CENTER + 0.5*MLAB(2,TYPE)/FACTOR
      YRIGHT = CENTER + MLAB(2,TYPE)/FACTOR
      FKM = 0.00001*SF
C
C       A. LABELS
C
      IF (POWSF .GE. 3)  THEN
         FKM = 0.001*SF
C      IF (POWSF .GE. 5)  THEN  ! Baltic cm case
C         FKM = 0.00001*SF      ! Baltic cm case
         IT = 2
       ELSE
         FKM = SF
C         FKM = 0.01*SF         ! Baltic cm case
         IT = 1
      END IF
      IF (POWSF .EQ. 0  .OR.  POWSF .EQ. 3)  THEN
C      IF (POWSF .LE. 2  .OR.  POWSF .EQ. 5)  THEN  ! Baltic cm case
         ND = 1
       ELSE
         ND = 0
      END IF
      CALL GMPTXT(TITLE(IT),XXT-0.45,CENTER,0.6*TTLSZ,90.0,0)
      CALL GMPREA(0.0,0,XXT,YLEFT,0.6*TTLSZ,90.0,0)
      CALL GMPREA(FKM*MLAB(1,TYPE),ND,XXT,CENTER,0.6*TTLSZ,90.0,0)
      CALL GMPREA(FKM*MLAB(2,TYPE),ND,XXT,YRIGHT,0.6*TTLSZ,90.0,0)
      YUN = YRIGHT + 0.25 + 0.3*TTLSZ*POWSF
C
C       B. BAR
C
      XXT = XXT + 0.2
       CALL GMPMOV(XXT+0.1,YLEFT)
       CALL GMPDRW(XXT+0.1,YRIGHT)
       CALL GMPDRW(XXT,YRIGHT)
       CALL GMPDRW(XXT,YLEFT)
       CALL GMPDRW(XXT+0.1,YLEFT)
       CALL GMPMOV(XXT+0.1,Y25)
       CALL GMPDRW(XXT,Y25)
       CALL GMPMOV(XXT+0.05,YLEFT)
       CALL GMPDRW(XXT+0.05,Y25)
       CALL GMPMOV(XXT+0.1,CENTER)
       CALL GMPDRW(XXT,CENTER)
       CALL GMPMOV(XXT+0.05,CENTER)
       CALL GMPDRW(XXT+0.05,Y75)
       CALL GMPMOV(XXT+0.1,Y75)
       CALL GMPDRW(XXT,Y75)
C
      RETURN
      END
C
C***********************************************************************
C
C               PREPARES A LIST OF LITHOLOGY SYMBOLS
C               USED IN STRATIGRAPHIC COLUMNS
C
C***********************************************************************
C
      SUBROUTINE LITHLEGEND
C
      INTEGER*4 PAIR
      LOGICAL FLAG
C
      COMMON /XTOPIM/ XTOPIM
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /WTHLEG/ WTHLEG
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
C
      XTOPIM = XTOPIM - 1.0
      YLEFT = 0.5 + YSIZE
      YRIGHT = 3.0 + YSIZE
      C = YLEFT + 0.5*WTHLEG
      Y1 = 0.7 + YLEFT
      Y2 = 2.1 + Y1
      CALL GMPLCR(1)
      FLAG = .TRUE.
      Y = Y2
      NLITHA = NLITH
C
C        FIRST PATTERN WHEN TOTAL NUMBER IS ODD
C
      PAIR = MOD(LITHLEGTOT,2)
      IF ( PAIR .NE. 0) THEN
         YMID = (Y1 + Y2)/2.0
         DO 100 I = NLITH, 1, -1
         NLITHA = I - 1
         IF (LITHFLAG(I) .EQ. 1) THEN
            CALL EXPLAINLITH(I,XTOPIM,YMID,XTOPIM+0.5,YMID+0.75)
            XTOPIM = XTOPIM - 0.9
            GO TO 150
         END IF
  100    CONTINUE
      END IF
C
C        EVEN NUMBER OF PATTERNS
C
  150 IF (NLITHA .EQ. 0) GO TO 900
      DO 200 I = NLITHA, 1, -1
      IF (LITHFLAG(I) .EQ. 1) THEN
         CALL EXPLAINLITH(I,XTOPIM,Y,XTOPIM+0.5,Y+0.75)
         IF (FLAG) THEN
            Y = Y1
            FLAG = .FALSE.
          ELSE
            Y = Y2
            FLAG = .TRUE.
            XTOPIM = XTOPIM - 0.9
         END IF
      END IF
  200 CONTINUE
C
      IF (FLAG) XTOPIM = XTOPIM + 0.5
      CALL GMPTXT('LITHOLOGY SYMBOLS',XTOPIM,C,0.65*TTLSZ,90.0,0)
      XTOPIM = XTOPIM - 2.0*TTLSZ
C
  900 RETURN
      END
C
C***********************************************************************
C
C               SELECTS THE SUBROUTINE TO EXPLAIN
C               THE LITHOLOGY SYMBOL IN THE LEGEND
C
C***********************************************************************
C
      SUBROUTINE EXPLAINLITH(I,X1,Y1,X2,Y2)
C
       IF ( I .EQ. 1) THEN
         CALL LEGENDANH(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 2) THEN
         CALL LEGENDCHALK(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 3) THEN
         CALL LEGENDCOAL(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 4) THEN
         CALL LEGENDDOL(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 5) THEN
         CALL LEGENDGRAN(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 6) THEN
         CALL LEGENDLS(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 7) THEN
         CALL LEGENDSALT(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 8) THEN
         CALL LEGENDSAND(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 9) THEN
         CALL LEGENDSHALE(X1,Y1,X2,Y2)
       ELSE IF ( I .EQ. 10) THEN
         CALL LEGENDUNRES(X1,Y1,X2,Y2)
      END IF
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE ANHYDRITE
C
C***********************************************************************
C
      SUBROUTINE LEGENDANH(X1,Y1,X2,Y2)
C
      PARAMETER (PI= 3.1415926535)    
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LITHOPAR/ HINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      include 'lithcolor.inc'
C
      IF (MENU .EQ. 'LIT2') CALL LEGCOL(X1,Y1,X2,Y2,LITHFCOL(1))
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Anhydrite',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
C        HORIZONTAL LINES
C
      DO 100 I = 1,4
      X3 = X1 + I*HINC
      CALL GMPMOV(X3,Y1)
      CALL GMPDRW(X3,Y2)
  100 CONTINUE
C
      SINFAC = 0.1*HINC
      B = SQRT(2.0)*HINC
      FACT = 2.0*PI/B
C
C        FIRST SET OF DIAGONAL SINUSOIDS
C
      DO 200 J = 1,3
      X3 = X1 + 2.0*(J-1)*HINC
      DO 200 I = 1,7
      Y3 = Y1 + (I+0.5)*HINC
      CALL ANHMOTIF2(X3,Y3,B,SINFAC,FACT,X3+HINC)  
  200 CONTINUE
C
C        SECOND SET OF DIAGONAL SINUSOIDS
C
      DO 300 J = 1,2
      X3 = X1 + (2.0*J-1)*HINC
      DO 300 I = 1,7
      Y3 = Y1 + I*HINC
      CALL ANHMOTIF2(X3,Y3,B,SINFAC,FACT,X3+HINC)  
  300 CONTINUE
C
C        UPPER HALF OF DIAGONAL SINUSOIDS
C
      DO 400 I = 1,3
      X3 = X1 + 2.0*(I-1)*HINC
      Y3 = Y1 + 0.5*HINC
      CALL ANHMOTIF5(X3,Y3,B,SINFAC,FACT,X3+HINC)  
  400 CONTINUE
C
C        LOWER HALF OF DIAGONAL SINUSOIDS
C
      DO 500 I = 1,2
      X3 = X1 + 2.0*I*HINC
      Y3 = Y2 - 0.5*HINC
      CALL ANHMOTIF6(X3,Y3,X3-HINC,B,SINFAC,FACT)  
  500 CONTINUE
C
      RETURN
      END
C
C***********************************************************************
C
C            PIECE OF ANHIDRITE MOTIF, UPPER HALF OF A DIAGONAL
C            SINUSOID DRAWN FROM UPPER RIGHT TO BOTTOM LEFT
C
C***********************************************************************
C
      SUBROUTINE ANHMOTIF5(X,Y,B,SINFAC,FACT,XBOT)
C
      PARAMETER (PI= 3.1415926535)
C
      COMMON /LITHOPAR/ HINC
C
      STEPS = 20.0*(XBOT-X)/HINC
      NSTEP = NINT(STEPS)
      X1 = X
      Y1 = Y
      DO 100 K = 2, NSTEP/2 + 1
      ARG = B*(K-1)/20.0
      YSIN = SINFAC*SIN(PI + FACT*ARG)
      XNEXT = X + (K-1)*(XBOT-X)/NSTEP
      YNEXT = Y - (K-1)*(XBOT-X)/NSTEP + SQRT(2.0)*YSIN
      CALL GMPMOV(X1,Y1)
      CALL GMPDRW(XNEXT,YNEXT)
      X1 = XNEXT
      Y1 = YNEXT
  100 CONTINUE
      RETURN
      END
C
C***********************************************************************
C
C            PIECE OF ANHIDRITE MOTIF, LOWER HALF OF A DIAGONAL
C            SINUSOID DRAWN FROM BOTTOM LEFT TO UPPER RIGHT
C
C***********************************************************************
C
      SUBROUTINE ANHMOTIF6(X,Y,XUP,B,SINFAC,FACT)

C
      PARAMETER (PI= 3.1415926535)
C
      COMMON /LITHOPAR/ HINC
C
      STEPS = 20.0*(X-XUP)/HINC
      NSTEP = NINT(STEPS)
      X1 = X
      Y1 = Y
      DO 100 K = 2, NSTEP/2 + 1
      ARG = B*(K-1)/20.0
      YSIN = SINFAC*SIN(3.0*PI - FACT*ARG)
      XNEXT = X - (K-1)*(X-XUP)/NSTEP
      YNEXT = Y + (K-1)*(X-XUP)/NSTEP + SQRT(2.0)*YSIN
      CALL GMPMOV(X1,Y1)
      CALL GMPDRW(XNEXT,YNEXT)
      X1 = XNEXT
      Y1 = YNEXT
  100 CONTINUE
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE CHALK
C
C***********************************************************************
C
      SUBROUTINE LEGENDCHALK(X1,Y1,X2,Y2)
C
      REAL*4 YEND(4)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /CHALKPAT1/ YSTART1, YLENGTH1
             REAL*4 YSTART1(4)
             REAL*4 YLENGTH1(4)
      COMMON /LITHOPAR/ HINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      include 'lithcolor.inc'
C
      IF (MENU .EQ. 'LIT2') CALL LEGCOL(X1,Y1,X2,Y2,LITHFCOL(2))
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Chalk',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
      CONSTANT1 = 2.0*HINC
      CONSTANT2 = -0.5*HINC
      X = X1 + HINC
      YMAX = Y1
      JLROW = 1
      DO 200 J = 1,4
      X3 = X + (J-1)*HINC
      JLROW = J
      CONSTANT3 = YSTART1(J)*HINC
      CONSTANT4 = YLENGTH1(J)*HINC
      DO 200 K = 1, 2
C
C            STARTING COORDINATES FOR THE ROW
C
      IF ( K. EQ. 1)  THEN
            Y3 = YMAX + CONSTANT3
            YEND(J) = Y3 + CONSTANT4
       ELSE
            Y3 = YEND(J) + CONSTANT1
            YEND(J) = Y3 + CONSTANT1
      END IF
      CALL CHALKMOTIF(0,X3,Y3,YEND(J),X3-0.75*HINC,
     2                   YEND(J)+CONSTANT2,
     3                   1,0,1,0,-1.0E20,1.0E20,
     4                   0,0,DUMMY,1,0,0,
     5                   0,0,0,' ',0,0,0,0,0,0)
  200    CONTINUE
C
C            INCOMPLETE PERIPHERAL MOTIFS
C
      CALL GMPMOV(X1+HINC,Y2-0.5*HINC)
      CALL GMPDRW(X1+HINC,Y2)
      CALL GMPMOV(X2-0.75*HINC,Y1+0.5*HINC)
      CALL GMPDRW(X2,Y1+0.5*HINC)
      CALL GMPMOV(X2-0.75*HINC,Y1+4.5*HINC)
      CALL GMPDRW(X2,Y1+4.5*HINC)
C
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE COAL
C
C***********************************************************************
C
      SUBROUTINE LEGENDCOAL(X1,Y1,X2,Y2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LITHOPAR/ HINC
C
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Coal',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
      X = X1
      DO 100 I = 1,99
      X = X + 0.05*HINC
      CALL GMPMOV(X,Y1)
      CALL GMPDRW(X,Y1+0.75)
  100 CONTINUE
C
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE DOLOMITE
C
C***********************************************************************
C
      SUBROUTINE LEGENDDOL(X1,Y1,X2,Y2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LITHOPAR/ HINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      include 'lithcolor.inc'
C
      IF (MENU .EQ. 'LIT2') CALL LEGCOL(X1,Y1,X2,Y2,LITHFCOL(4))
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Dolomite',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
C        HORIZONTAL LINES
C
      DO 100 I = 1,4
      X3 = X1 + I*HINC
      CALL GMPMOV(X3,Y1)
      CALL GMPDRW(X3,Y2)
  100 CONTINUE
C
C        DIAGONAL LINES
C
      DO 200 J = 1,5
      X3 = X1 + (J-1)*HINC
      DO 200 I = 1,4
      Y3 = Y1 + (2.0*I-0.75)*HINC
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X3+HINC,Y3-HINC)
  200 CONTINUE
C
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE GRANITE
C
C***********************************************************************
C
      SUBROUTINE LEGENDGRAN(X1,Y1,X2,Y2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LITHOPAR/ HINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      include 'lithcolor.inc'
C
      IF (MENU .EQ. 'LIT2') CALL LEGCOL(X1,Y1,X2,Y2,LITHFCOL(5))
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Granite',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
      DO 100 J = 1,7
      DO 100 I = 1,5
      X = X1 + (I - 0.5)*HINC
      Y = Y1 + (0.6+ 1.05*(J-1))*HINC
      CALL GRANMOTIF(0,X,Y,0,2,0,-1.0E20,1.0E20,DUMMY,1,
     1                  0,0,0,0,0,0,0,0,0,0,0,' ',0)
  100 CONTINUE
C
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE LIMESTONE
C
C***********************************************************************
C
      SUBROUTINE LEGENDLS(X1,Y1,X2,Y2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LITHOPAR/ HINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      include 'lithcolor.inc'
C
      IF (MENU .EQ. 'LIT2') CALL LEGCOL(X1,Y1,X2,Y2,LITHFCOL(6))
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Limestone',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
C        HORIZONTAL LINES
C
      DO 100 I = 1,4
      X3 = X1 + I*HINC
      CALL GMPMOV(X3,Y1)
      CALL GMPDRW(X3,Y2)
  100 CONTINUE
C
C        FIRST SET OF VERTICAL LINES
C
      DO 200 J = 1,3
      X3 = X1 + 2.0*(J-1)*HINC
      DO 200 I = 1,4
      Y3 = Y1 + (2.0*I-1)*HINC
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X3+HINC,Y3)
  200 CONTINUE
C
C        SECOND SET OF VERTICAL LINES
C
      DO 300 J = 1,2
      X3 = X1 + (2.0*J-1)*HINC
      DO 300 I = 1,3
      Y3 = Y1 + 2.0*I*HINC
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X3+HINC,Y3)
  300 CONTINUE
C
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE SALT
C
C***********************************************************************
C
      SUBROUTINE LEGENDSALT(X1,Y1,X2,Y2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LITHOPAR/ HINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU

      include 'lithcolor.inc'
C
      IF (MENU .EQ. 'LIT2') CALL LEGCOL(X1,Y1,X2,Y2,LITHFCOL(7))
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Salt',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
C        CENTRAL BAND FROM UPPER-LEFT TO LOWER-RIGHT
C
      X3 = X1
      X4 = X2
      DO 100 I = 1,3
      Y3 = Y1 + (I-1)*HINC
      Y4 = Y1 + HINC*(I + 4)
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X4,Y4)
  100 CONTINUE
C
C        UPPER-RIGHT CORNER
C
      X3 = X1
      Y4 = Y2
      DO 200 I = 1,5
      Y3 = Y2 - HINC*(I - 0.5)
      X4 = X1 + HINC*(I - 0.5)
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X4,Y4)
  200 CONTINUE
C
C        LOWER-LEFT CORNER
C
      Y3 = Y1
      X4 = X2
      DO 300 I = 1,4
      X3 = X2 - HINC*I
      Y4 = Y1 + HINC*I
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X4,Y4)
  300 CONTINUE
C
C        CENTRAL BAND FROM LOWER-LEFT TO UPPER-RIGHT
C
      X3 = X2
      X4 = X1
      DO 400 I = 1,3
      Y3 = Y1 + (I-1)*HINC
      Y4 = Y1 + HINC*(I + 4)
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X4,Y4)
  400 CONTINUE
C
C        UPPER-LEFT CORNER
C
      Y3 = Y1
      X4 = X1
      DO 500 I = 1,4
      X3 = X2 - HINC*I
      Y4 = Y1 + HINC*(5 - I)
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X4,Y4)
  500 CONTINUE
C
C        LOWER-RIGHT CORNER
C
      X3 = X2
      Y4 = Y2
      DO 600 I = 1,5
      Y3 = Y1 + HINC*(2 + I)
      X4 = X1 + HINC*(I - 0.5)
      CALL GMPMOV(X3,Y3)
      CALL GMPDRW(X4,Y4)
  600 CONTINUE
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE SANDSTONE
C
C***********************************************************************
C
      SUBROUTINE LEGENDSAND(X1,Y1,X2,Y2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LITHOPAR/ HINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU

      include 'lithcolor.inc'
C
      IF (MENU .EQ. 'LIT2') CALL LEGCOL(X1,Y1,X2,Y2,LITHFCOL(8))
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Sandstone',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
      DO 100 J = 1,7
      DO 100 I = 1,5
      X = X1 + 0.5*HINC + (I-1)*HINC
      Y = Y1 + HINC*(0.5 + 0.5*MOD(I-1,2) + (J-1))
      CALL GMPTXT('.',X,Y,0.1,90.0,0)
  100 CONTINUE
C
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND SYMBOL USED TO DENOTE SHALE
C
C***********************************************************************
C
      SUBROUTINE LEGENDSHALE(X1,Y1,X2,Y2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /LITHOPAR/ HINC
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU

      include 'lithcolor.inc'
C
      IF (MENU .EQ. 'LIT2') CALL LEGCOL(X1,Y1,X2,Y2,LITHFCOL(9))
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Shale',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
C
      DO 100 J = 1,3
      DO 100 I = 1,5
      IF ( MOD(I,2) .EQ. 0  .AND. J .EQ. 3) GO TO 100
      X = X1 + 0.5*HINC + (I-1)*HINC
      Y = Y1 + HINC*(0.5 + 0.75*MOD(I-1,2) + 2.5*(J-1))
      CALL GMPMOV(X,Y)
      CALL GMPDRW(X,Y+1.5*HINC)
  100 CONTINUE
C
      RETURN
      END
C
C***********************************************************************
C
C         DRAWS IN LEGEND EMPTY RECTANGLE TO
C         DENOTE UNRESOLVED LITHOLOGY
C
C***********************************************************************
C
      SUBROUTINE LEGENDUNRES(X1,Y1,X2,Y2)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      CALL PLTBOX(0,0,0,X1,X2,Y1,Y2)
      CALL GMPTXT('Unresolved',X1+0.3,Y1+0.85,0.4*TTLSZ,90.0,-1)
      RETURN
      END
C
C***********************************************************************
C
C         COLORING OF LITHOLOGY LEGENDS
C
C***********************************************************************
C
      SUBROUTINE LEGCOL(X1,Y1,X2,Y2,NUPEN)
c
      COMMON /CODINC/ DINC
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      CALL GMPLCR(NUPEN)
      DELTAX = DINC/VSCALE
      NOLINES = (X2 - X1)/DELTAX
C      XLINE = X1 + 0.5*DELTAX
      XLINE = X1 + DELTAX   !BGR
      DO 100 I = 1, NOLINES
      CALL GMPMOV(XLINE,Y1)
      CALL GMPDRW(XLINE,Y2)
      XLINE = XLINE + DELTAX
  100 CONTINUE
      CALL GMPLCR(1)
      RETURN
      END
C
C***********************************************************************
C
C         CONVERTION FROM DEPTH IN BOREHOLE TO INCHES IN CROSS SECTION
C
C***********************************************************************
C
      REAL FUNCTION RINCH(Z)
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1               DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      RINCH = XTOP + 0.15*TTLSZ + (Z - CSTART)/VSCALE    
      RETURN
      END
