C     CORRELATOR MODULE REGDIF
C
C***********************************************************************
C
C         REGRESSION ON DIFFERENCE IN ELEVATION
C         *************************************
C
C***********************************************************************
C
        SUBROUTINE REGDIF(J1STIM,MXN)
C
      INCLUDE 'log.inc'
C
      REAL*8 B(20,20),C(20)
      REAL*8 B1(20,20),C1(20)
      REAL*8 XP(20)
      REAL*8 XXP,YYP
      REAL*8 SY,SY2,SYC,SYC2
      REAL*8 SST,SSR,SSD,R2,R,PR
      REAL*8 ZERO
      REAL*4 RTEMP(48)
      INTEGER REGN1
      CHARACTER*2 OPTION
      CHARACTER*4 BOMU
      LOGICAL ERROR
      INTEGER NRGTAB(MAX_REG_DELZ)
      CHARACTER*70 TXTMES
      CHARACTER*79 MESG
      LOGICAL LOADCI,GOFLAG
      CHARACTER*3 STATUS(2)
      CHARACTER*2 YESNO
      DATA STATUS/'YES',' NO'/
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
C
      COMMON /DLOGSX/ D
             REAL*8 D(LOG_LENGTH,5)
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /PARRRD/ CSTART,CEND,ZMINC,ZMAXC,RCUTOF,
     1                REGN,LSTOPT,NREGS
      INTEGER REGN
C
      COMMON /CHARH/FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
C
      COMMON /LSTCIX/ LASTCI
C
      include 'welldb.inc'
      include 'wldwel.inc'
      include 'corrdb.inc'
C 
      IF (J1STIM .EQ. 0) THEN
         ZMINC =0.0
         ZMAXC =100.0
         CSTART=ZMINC
         CEND  =ZMAXC
         RCUTOF=0.00
         REGN = 3
         LSTOPT=2
         J1STIM = 1
        END IF
C
      LOADCI = .TRUE.
      GOFLAG = .FALSE.
C
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) LASTCI=0
      IF (LASTCI .GT. NCPWEL) LASTCI=0
      IF ((LASTCI .EQ. 0) .AND. (NCPWEL .GT. 0)) LASTCI=1
      IF (NCPWEL .EQ. 1) LASTCI=1
      ICP=LASTCI
      IF (ICP .GT. 0) CALL RCPHDR(ICPWEL(ICP))
C
    5 IF (ICP .LT. 1) THEN
         NZ=0
         NREGCP=0
        ELSE
         NZ=NNNNCP
        ENDIF
      IF (NREGCP .GT. 0) THEN
         IRN=NRGPTR
         DO 6601 I=1,NREGCP
         READ (25,REC=IRN) NEXT
         NRGTAB(I)=IRN
         IRN=NEXT
 6601    CONTINUE
        ENDIF
C
C        MENU.
C
      IREGFL = 0
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'REGRESSION ON DIFFERENCE IN ELEVATION')
      LINE=2
C
      CALL TXTCLR(ICOLOR(5))
      WRITE (MESG,3001) ID1,NAME1
      CALL GTEXTS(5,LINE+2,MESG)
      WRITE (MESG,3002) ID2,NAME2
      CALL GTEXTS(5,LINE+3,MESG)
      LINE=LINE+3
 3001 FORMAT ('REFERENCE WELL (',I2,'): ',A20)
 3002 FORMAT ('MATCHING WELL  (',I2,'): ',A20)
      IF (NCPWEL .GT. 0) THEN
         WRITE (MESG,3003) ICP,CPTITL
         CALL GTEXTS(5,LINE+1,MESG)
         LINE=LINE+1
 3003    FORMAT ('INTERPRETATION (',I1,'): ',A40)
         IF (NNNNCP .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+1,
     1           '***** NO CORRELATIONS IN SELECTED INTERPRETAION.')
            LINE=LINE+1
            GOFLAG=.FALSE.
            LOADCI=.FALSE.
           ENDIF
         IF (LOADCI) THEN
            GOFLAG=.FALSE.
C
C           READ IN CORRELATIONS.
            CALL RDELCO(NZ)
            LOADCI=.FALSE.
            GOFLAG=.TRUE.
            ZMINC=ZMINCP
            ZMAXC=ZMAXCP
            CSTART=ZMINC
            CEND  =ZMAXC
           ENDIF
        ELSE
          CALL TXTCLR(ICOLOR(6))
          CALL GTEXTS(5,LINE+1,
     1         '***** NO CORRELATION INTERPRETATIONS FOR WELL PAIR')
          LINE=LINE+1
          GOFLAG=.FALSE.
          LOADCI=.FALSE.
        ENDIF
C
      CALL TXTCLR(ICOLOR(3))
      IF (NCPWEL .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'CI - SELECT CORRELATION INTERPRETATION')
         CALL MARROW(75,LINE+2)
         LINE = LINE + 2
        ENDIF
C
      IF (NZ .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'ND - MINIMUM DEPTH FOR REGRESSION,')
         CALL GTEXTS(39,LINE+2,BOMU(BOM))
         CALL GTXTRL(75,LINE+2,CSTART,2)
         CALL GTEXTS( 3,LINE+3,'XD - MAXIMUM DEPTH FOR REGRESSION,')
         CALL GTEXTS(39,LINE+3,BOMU(BOM))
         CALL GTXTRL(75,LINE+3,CEND,2)
         CALL GTEXTS( 3,LINE+4,
     1       'MC - MINIMUM WEIGHTED CORRELATION COEFFICIENT')
         CALL GTXTRL(75,LINE+4,RCUTOF,3)
         CALL GTEXTS( 3,LINE+5,
     1 'PD - POLYNOMIAL DEGREE.  A NEGATIVE DEGREE DISPLAYS DATA ONLY.')
         CALL GTXTIN(75,LINE+5,REGN)
         CALL GTEXTS( 3,LINE+6,'LI - LIST DETAILED REPORT')
         CALL GTXTRJ(75,LINE+6,STATUS(LSTOPT))
         LINE = LINE + 6
         IF (NREGCP .GT. 0) THEN
            CALL GTEXTS( 3,LINE+2,
     1           'DE - DELETE EXISTING REGRESSION EQUATION')
            CALL MARROW(75,LINE+2)
            LINE = LINE + 2
           END IF
         IF (IREGFL .GT. 0) THEN
            IF (NREGCP .LT. 1) LINE=LINE+1
            IF (NREGCP .LT. 9) THEN
               CALL GTEXTS( 3,LINE+1,'SA - SAVE REGRESSION EQUATION')
               LINE=LINE+1
              ENDIF
            IF (NREGCP .GT. 0) THEN
               CALL GTEXTS( 3,LINE+1,
     1          'RR - REPLACE EXISTING REGRESSION EQUATION')
               CALL MARROW(75,LINE+1)
               LINE = LINE + 1
              ENDIF
           ENDIF
        ENDIF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO CORRELATION FINDING MENU')
      LINE=LINE+2
      IF (GOFLAG) THEN
         CALL GTEXTS( 3,LINE+1,'GO - CALCULATE REGRESSION COEFFICIENTS')
         LINE=LINE+1
        ENDIF
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. ' ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF (GOFLAG .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 0) THEN
         ICPSAV=ICP
         CALL SELTCP(ICP)
         IF (ICP .NE. ICPSAV) THEN
            LOADCI=.TRUE.
            GOFLAG=.FALSE.
           ENDIF
         GO TO 5
        ENDIF
      IF (OPTION .EQ. 'ND') THEN
            CALL AGETRL(TEMP,ERROR)
            IF (.NOT. ERROR) CSTART = TEMP
        END IF
      IF (OPTION .EQ. 'XD') THEN
            CALL AGETRL(TEMP,ERROR)
            IF (.NOT. ERROR) CEND = TEMP
        END IF
      IF (OPTION .EQ. 'MC') THEN
            CALL AGETRL(TEMP,ERROR)
            IF (.NOT. ERROR) RCUTOF = TEMP
        END IF
      IF (OPTION .EQ. 'PD') THEN
            CALL AGETIN(ITEMP,ERROR)
            IF (.NOT. ERROR) REGN = ITEMP
        END IF
      IF (OPTION .EQ. 'LI') THEN
         CALL AGETST(YESNO,2)
         IF (YESNO .EQ. 'YE') LSTOPT=1
         IF (YESNO .EQ. 'NO') LSTOPT=2
        ENDIF
C
      IF ((OPTION .EQ. 'SA') .AND. (IREGFL .GT. 0)) THEN
         IF (NREGCP .GT. 0) THEN
            IRN=NRGTAB(NREGCP)
            READ (25,REC=IRN) NEXT,RTEMP
           ELSE
            IRN=0
           ENDIF
         IF (ICFREC .GT. 0) THEN
            NEXT=ICFREC
            READ (25,REC=NEXT) ICFREC
           ELSE
            ICLREC=ICLREC+1
            NEXT=ICLREC
           ENDIF
         IF (IRN .GT. 0) WRITE (25,REC=IRN) NEXT,RTEMP
         NREGCP=NREGCP+1
         IRN =NEXT
         IF (NREGCP .EQ. 1) NRGPTR=IRN
         NRGTAB(NREGCP)=IRN
         NEXT=0
         WRITE (25,REC=IRN  ) NEXT,REGN,CSTART,CEND,RCUTOF,
     1                        RMIN,RMAX,R,C
         CALL WRTCPH
         CALL UPDCDH
         IREGFL=0
         GO TO 11
        ENDIF
C
      IF ((OPTION .EQ. 'DE') .AND. (NREGCP .GT. 0)) THEN
         IRP=0
6811     CALL MNMODE
         CALL TXTCLR(ICOLOR(2))
         CALL GTEXTC(40, 2,'DELETE EXISTING REGRESSION EQUATION')
         CALL TXTCLR(ICOLOR(4))
         LINE=4
         DO 6801 I=1,NREGCP
         IRN=NRGTAB(I)
         READ (25,REC=IRN) NEXT,IREGN,PCS,PCE,PRC,PRMN,PRMX,PR
         WRITE (TXTMES,6802) I,IREGN,PCS,PCE,PRC,PRMN,PRMX,PR
 6802    FORMAT (I2,2X,I4,2F10.1,2X,F8.3,2X,2F8.3,2X,F10.4)
         CALL GTEXTS( 5,LINE,TXTMES)
         LINE=LINE+1
 6801    CONTINUE
C
         CALL TXTCLR(ICOLOR(3))
         CALL GTEXTS( 3,LINE+2,'RD - REGRESSION EQUATION TO DELETE')
         CALL GTXTIN(75,LINE+2,IRP)
         CALL GTEXTS( 3,LINE+3,'RE - RETURN TO PREVIOUS MENU')
         LINE=LINE+3
         IF (IRP .GT. 0) THEN
            CALL GTEXTS( 3,LINE+1,'GO - DELETE REGRESSION EQUATION')
            LINE=LINE+1
           ENDIF
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
         CALL AINPUT(33,LINE+2)
 6815    CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
         IF (OPTION .EQ. ' ') GO TO 6811
C
         IF (OPTION .EQ. 'RE') GO TO 11
C
         IF ((IRP .GT. 0) .AND. (OPTION .EQ. 'GO')) GO TO 6851
C
         IF (OPTION .EQ. 'RD') THEN
            CALL AGETIN(ITEMP,ERROR)
            IF (.NOT. ERROR) THEN
               IF ((ITEMP .GT. 0) .AND.
     1             (ITEMP .LE. NREGCP)) IRP = ITEMP
                 ENDIF
           ENDIF
         GO TO 6815
 6851    IRN=NRGTAB(IRP)
         WRITE (25,REC=IRN) ICFREC
         ICFREC=IRN
         IF (IRP .GT. 1) THEN
            IRN=NRGTAB(IRP-1)
            READ (25,REC=IRN) NEXT,RTEMP
            IF (IRP .LT. NREGCP) THEN
               NEXT=NRGTAB(IRP+1)
              ELSE
               NEXT=0
              ENDIF
            WRITE (25,REC=IRN) NEXT,RTEMP
           ELSE
            IF (NREGCP .GT. 1) THEN
               NRGPTR=NRGTAB(2)
              ELSE
               NRGPTR=0
              ENDIF
           ENDIF
         IF (IRP .LT. NREGCP) THEN
            DO 6852 I=IRP,NREGCP-1
            NRGTAB(I)=NRGTAB(I+1)
 6852       CONTINUE
           ENDIF
         NREGCP=NREGCP-1
         CALL WRTCPH
         CALL UPDCDH
         GO TO 11
        ENDIF
C
      IF ((OPTION .EQ. 'RR') .AND. (IREGFL .GT. 0)
     1                       .AND. (NREGCP .GT. 0)) THEN
         IRP=0
6711     CALL MNMODE
         CALL TXTCLR(ICOLOR(2))
         CALL GTEXTC(40, 2,'REPLACE EXISTING REGRESSION EQUATION')
         CALL TXTCLR(ICOLOR(4))
         LINE=4
         DO 6701 I=1,NREGCP
         IRN=NRGTAB(I)
         READ (25,REC=IRN) NEXT,IREGN,PCS,PCE,PRC,PRMN,PRMX,PR
         WRITE (TXTMES,6702) I,IREGN,PCS,PCE,PRC,PRMN,PRMX,PR
 6702    FORMAT (I2,2X,I4,2F10.1,2X,F8.3,2X,2F8.3,2X,F10.4)
         CALL GTEXTS( 5,LINE,TXTMES)
         LINE=LINE+1
 6701    CONTINUE
C
         CALL TXTCLR(ICOLOR(3))
         CALL GTEXTS( 3,LINE+2,'RP - REGRESSION EQUATION TO REPLACE')
         CALL GTXTIN(75,LINE+2,IRP)
         CALL GTEXTS( 3,LINE+3,'RE - RETURN TO PREVIOUS MENU')
         LINE=LINE+3
         IF (IRP .GT. 0) THEN
            CALL GTEXTS( 3,LINE+1,'GO - REPLACE REGRESSION EQUATION')
            LINE=LINE+1
           ENDIF
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
         CALL AINPUT(33,LINE+2)
 6715    CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
         IF (OPTION .EQ. ' ') GO TO 6711
C
         IF (OPTION .EQ. 'RE') GO TO 11
C
         IF ((IRP .GT. 0) .AND. (OPTION .EQ. 'GO')) GO TO 6751
C
         IF (OPTION .EQ. 'RP') THEN
            CALL AGETIN(ITEMP,ERROR)
            IF (.NOT. ERROR) THEN
               IF ((ITEMP .GT. 0) .AND.
     1             (ITEMP .LE. NREGCP)) IRP = ITEMP
              ENDIF
           ENDIF
         GO TO 6715
C
 6751    IRN=NRGTAB(IRP)
         IF (IRP .LT. NREGCP) THEN
            NEXT=NRGTAB(IRP+1)
           ELSE
            NEXT=0
           ENDIF
         WRITE (25,REC=IRN  ) NEXT,REGN,CSTART,CEND,RCUTOF,
     1                        RMIN,RMAX,R,C
         CALL WRTCPH
         CALL UPDCDH
         IREGFL=0
         GO TO 11
        ENDIF
      GO TO 15
C
   51 IREGFL=0
      IF ( CSTART .GT. CEND ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1       '***** STARTING DEPTH DEEPER THEN ENDING.')
         CALL SCHOLD
         GO TO 11
        END IF
      IF ( CSTART .GT. ZMAXC  .OR.  CEND .LT. ZMINC ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1     '***** CORRELATION INTERVAL OUTSIDE INTERVAL TO DISPLAY.')
         CALL SCHOLD
         GO TO 11
        END IF
C
C          READ IN CORRELATION.
C
      N = 0
      DO 101 I=1,NZ
      ZZ1=Z1(I)
      ZZ2=Z2(I)
      WCCC=WCC(I)
      IF ((ZZ1 .LT. CSTART .OR.  ZZ1 .GT. CEND)  .OR.
     X        WCCC .LT. RCUTOF ) GO TO 101
        N = N + 1
        D(N,1)=ZZ1
        D(N,2)=ZZ2 - ZZ1
        D(N,5) = WCCC
  101 CONTINUE
      REGN1 = REGN + 1
      IF (REGN .LT. 0) GO TO 81
      IF (REGN .GE. N) THEN
       CALL TXTCLR(ICOLOR(6))
       CALL GTEXTS(3,LINE+6,'***** POLYNOMIAL DEGREE MUST BE LESS THAN')
       CALL GTEXTS(3,LINE+7,'   THE NUMBER OF CONTROL POINTS WHICH IS ')
       CALL GTXTIN(50,LINE+7,N)
       CALL SCHOLD
       GO TO 11
       ENDIF
C
      CALL SUMREG(D,B,C,XP,N,REGN1)
C
C       SAVE COEFFICIENTS.
C
      IF ( REGN1 .LT. 20) THEN
         DO 95 I = REGN1+1,20
         C(I) = 0.0D0
   95    CONTINUE
        ENDIF
      DO 103 I = 1,20
      C1(I) = C(I)
      DO 104 J = 1,20
      B1(I,J) = B(I,J)
  104 CONTINUE
  103 CONTINUE
C
C     SOLVE THE SIMULTANEOUS SYSTEM OF EQUATIONS.
C
      ZERO = 1.0D-35
      CALL SLED (B, C, REGN1, 20, ZERO, IERR)
      IF (IERR .GT. 0) GO TO 91
C
C     CALCULATE PREDICTED VALUES.
        DO 111 I = 1,N
          XXP = 1.0D0
          YYP = 0.0D0
          DO 112 J = 1,REGN1
            YYP = YYP + XXP * C(J)
            XXP = XXP * D(I,1)
  112      CONTINUE
          D(I,3) = YYP
          D(I,4) = YYP - D(I,2)
  111    CONTINUE
C
C     CALCULATE ERROR MEASURES.
      SY  = 0.0D0
      SY2 = 0.0D0
      DO 121 I = 1,N
        SY  = SY  + D(I,2)
        SY2 = SY2 + D(I,2) **2
  121  CONTINUE
      SYC  = 0.0D0
      SYC2 = 0.0D0
      DO 122 I = 1,N
         SYC  = SYC  + D(I,3)
         SYC2 = SYC2 + D(I,3) **2
  122   CONTINUE
C
C       STATISTICAL ANALYSIS.
C
      RMIN=+1.0E+30
      RMAX=-RMIN
      DO 131 I=1,N
      RTEST=D(I,4)
      RMIN=AMIN1(RMIN,RTEST)
      RMAX=AMAX1(RMAX,RTEST)
  131 CONTINUE
C
      SST = SY2  - SY **2  / DBLE(N)
      IF (REGN1 .GT. 1) THEN
         SSR = SYC2 - SYC **2 / DBLE(N)
        ELSE
         SSR = 0.0D0
        ENDIF
      SSD = SST - SSR
      IF (SST .LE. 0.0) GO TO 91
      R2 = SSR / SST
      IF ((R2 .LT. 0.0) .OR. (R2 .GT. 1.0)) GO TO 91
      R = DSQRT(R2)
C
C     PLOT ORIGINAL DATA AND REGRESSION LINE.
   81 CALL XYPLT(N,C,D,REGN1,NAME1,ID1,NAME2,ID2,RCUTOF,HDIST,
     1             IDSHAR,IDCORR,IDSHAM,IDCORM)
      IF ( REGN .LT. 0 ) GO TO 11
C
        CALL ANMOD2
        IF (LSTOPT .EQ. 1) THEN
          WRITE (QTEKOT,1004)
          CALL PRINTD (D, N, 5, MXN, 5)
          IF ( BOM .NE. 'M' ) THEN
             WRITE (QTEKOT, 1005)
            ELSE
             WRITE (QTEKOT,1006)
            END IF
          WRITE (QTEKOT,1001)
          CALL PRINTD (B1, REGN1, REGN1, 20, 20)
          WRITE (QTEKOT,1002)
          CALL PRINTD (C1, 1, REGN1, 1, 20)
          WRITE (QTEKOT,1003)
          CALL PRINTD (C , 1, REGN1, 1, 20)
         ENDIF
        WRITE (QTEKOT, 1990)
        WRITE (QTEKOT, 1995) REGN
        WRITE (QTEKOT, 2000) N
        WRITE (QTEKOT, 2001) SST
        WRITE (QTEKOT, 2002) SSR
        WRITE (QTEKOT, 2003) SSD
        WRITE (QTEKOT, 2004) RMIN,RMAX
        WRITE (QTEKOT, 2005) R2
        WRITE (QTEKOT, 2006) R
        CALL RETKEY
        IREGFL=1
        GO TO 11
C
C...  ERROR - NO SOLULTION FOR FOR REGRESSION
C
   91 CALL TXTCLR(ICOLOR(6))
      CALL GTEXTS( 3,LINE+6,
     X '**** NO SOLUTION FOR REQUESTED REGRESSION EQUATION')
      CALL SCHOLD
      GO TO 11
C
1001    FORMAT (///,' COEFFICIENT MATRIX OF UNKNOWN PARAMETERS',1X,
     X          'IN NORMAL EQUATIONS')
1002    FORMAT (///,' VECTOR OF CROSSPRODUCTS OF X AND Y')
1003    FORMAT (///,' THE PARAMETERS OF THE REGRESSION EQUATION')
1004    FORMAT (///,10X,'ORIGINAL DATA AND REGRESSED VALUES',/,
     X           10X,'**********************************',//)
1005    FORMAT (///,'     WHERE:',//,
     X      ' COLUMN 1 IS THE ELEVATION IN THE REFERENCE WELL, FEET',/,
     X      ' COLUMN 2 IS THE ACTUAL DIP, FEET',/,
     X      ' COLUMN 3 IS REGRESSED DIP, FEET',/,
     X      ' COLUMN 4 IS THE DIFFERENCE BETWEEN THE ',
     X        'REGRESSED AND THE ACTUAL DIPS, FEET',/,
     X      ' COLUMN 5 IS THE STRENGTH OF THE CORRELATION.')
1006    FORMAT (///,'     WHERE:',//,
     X      ' COLUMN 1 IS THE ELEVATION IN THE REFERENCE WELL, METERS'/
     X      ' COLUMN 2 IS THE ACTUAL DIP, METERS'/
     X      ' COLUMN 3 IS REGRESSED DIP, METERS'/
     X      ' COLUMN 4 IS THE DIFFERENCE BETWEEN THE ',
     X        'REGRESSED AND THE ACTUAL DIPS, METERS'/
     X      ' COLUMN 5 IS THE STRENGTH OF THE CORRELATION.')
1990    FORMAT (////)
1995    FORMAT (/ ' ORDER OF EQUATION : ', I5)
2000    FORMAT (/ ' NUMBER OF OBSERVATIONS : ', I5)
2001    FORMAT (/ ' TOTAL SUMS OF SQUARES : ', G15.5)
2002    FORMAT (/ ' SUMS OF SQUARES DUE TO REGRESSION : ', G15.5)
2003    FORMAT (/ ' SUMS OF SQUARES DUE TO DEVIATION : ', G15.5)
2004    FORMAT (/ ' MAXIMUM UNDERESTIMATION : ',G15.6/
     X          / ' MAXIMUM OVERESTIMATION : ',G15.6)
2005    FORMAT (/ ' GOODNESS OF FIT : ', G15.6)
2006    FORMAT (/ ' CORRELATION COEFFICIENT : ', G15.6)
        END
C***********************************************************************
C
C                  CALCULATES SUMS FOR REGRESSION.
C
C***********************************************************************
C
      SUBROUTINE SUMREG(A,B,C,XP,N,REGN)
C
      INCLUDE 'log.inc'
C
      INTEGER*4 REGN
      REAL*8 A(LOG_LENGTH,5)
      REAL*8 B(20,20)
      REAL*8 C(20)
      REAL*8 XP(20)
C
        DO 101 I = 1,REGN
          C(I) = 0.0D0
          DO 102 J = 1,REGN
            B(I,J) = 0.0D0
  102      CONTINUE
  101    CONTINUE
        DO 103 I = 1,N
          XP(1) = 1.0D0
          IF (REGN .GT. 1) THEN
             DO 104 J = 2,REGN
               XP(J) = XP(J-1) * A(I,1)
  104         CONTINUE
            ENDIF
          DO 105 J = 1,REGN
            DO 106 K = 1,REGN
              B(J,K) = B(J,K) + XP(J) * XP(K)
  106        CONTINUE
            C(J) = C(J) + XP(J) * A(I,2)
  105      CONTINUE
  103     CONTINUE
      RETURN
      END
C---------------------------------------------------------------------
C--  PROGRAM 4.9   SLE                              DAVIS 1973:144  --
C--                                                                 --
C--  SUBROUTINE FOR SOLUTION OF N SIMULTANEOUS EQUATIONS.  MATRIX   --
C--  A IS N BY N AND B IS A COLUMN VECTOR OF N ELEMENTS.  B CON-    --
C--  TAINS SOLUTION.                                                --
C--                                                                 --
C--  FORTRAN 77 VERSION:  21 JUN 84                                 --
*---------------------------------------------------------------------
C
        SUBROUTINE SLED(A, B, N, N1, ZERO,IERR)
C
        IMPLICIT NONE
        INTEGER I
        INTEGER J
        INTEGER K
        INTEGER N
        INTEGER N1
        REAL*8 A
        REAL*8 B
        REAL*8 DIV
        REAL*8 RATIO
        REAL*8 ZERO
        INTEGER IERR
        DIMENSION A(N1,N1)
        DIMENSION B(N1)
C
        IERR=0
        DO 101 I = 1,N
          DIV = A(I,I)
          IF (DABS(DIV) .LE. ZERO ) GO TO 99
            DO 102 J = 1,N
              A(I,J) = A(I,J) / DIV
  102        CONTINUE
            B(I) = B(I) / DIV
            DO 103 J = 1,N
              IF (I .NE. J) THEN
                RATIO = A(J,I)
                DO 104 K = 1,N
                  A(J,K) = A(J,K) - RATIO * A(I,K)
  104         CONTINUE
                B(J) = B(J) - RATIO * B(I)
              END IF
  103       CONTINUE
  101    CONTINUE
        RETURN
   99   IERR=1
        RETURN
        END
C***********************************************************************
C
C                   DISPLAY DATA AND REGRESSION ON SCREEN.
C
C***********************************************************************
C
      SUBROUTINE XYPLT(N,C,D,IORD,NAME1,ID1,NAME2,ID2,
     X           CUTOFF,HWDIST,IDSHAR,IDCORR,IDSHAM,IDCORM)
C
      INCLUDE 'log.inc'
C
C
C          COORDINATES FOR GRAPH BOX.
      COMMON /BOX/ XLL,YLL,XUR,YUR
C
      COMMON /COLOPT/ ICOLOR(6)
C
      CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      REAL*8 C(20)
      REAL*8 D(LOG_LENGTH,5)
C          TITLES
      CHARACTER*20 NAME1
      CHARACTER*20 NAME2
C
C          FIND EXTREMES FOR VARIABLES.
C
      XLL = 22.0
      XUR = 117.0
      YLL = 5.0
      YUR = 50.0
C      CALL SLINDX(0)    ! Publication
C
      RMNA1=+1.0E+30
      RMXA1=-1.0E+30
      RMNA2=+1.0E+30
      RMXA2=-1.0E+30
      DO 111 I=1,N
      ATEST=D(I,1)
      RMNA1=AMIN1(RMNA1,ATEST)
      RMXA1=AMAX1(RMXA1,ATEST)
      ATEST=D(I,2)
      RMNA2=AMIN1(RMNA2,ATEST)
      RMXA2=AMAX1(RMXA2,ATEST)
  111 CONTINUE
C
C          FIND EXTREMES FOR GRAPH.
C
      CALL GEXTRE(RMNA1,RMXA1,DELTAX)
      CALL GEXTRE(RMNA2,RMXA2,DELTAY)
C
C          SCALE
C
      XSCALE = (XUR - XLL)/(RMXA1 - RMNA1)
      YSCALE = (YUR - YLL)/(RMXA2 - RMNA2)
C
C          DRAW BOX
C
      CALL GRMODE
      CALL DWBOX(XLL,YLL,XUR,YUR)
C
C          LABEL THE GRAPH.
C
      CALL LABGRA(NAME1,ID1,NAME2,ID2,CUTOFF,IORD,
     X            IDSHAR,IDCORR,IDSHAM,IDCORM)
C
C          LABEL THE AXES.
C
      CALL TXTCLR(ICOLOR(2))
C      CALL SLINDX(0)    ! Publication
      CALL LABELX(RMNA1,RMXA1,DELTAX,NAME1,ID1)
      CALL LABELY(RMNA2,RMXA2,DELTAY)
      CALL LABEYD(RMNA2,RMXA2,HWDIST)
C
C          PLOT ORIGINAL DATA.
C
      CALL PLORD(N,D,RMNA1,XSCALE,RMNA2,YSCALE,CUTOFF)
C
C          DRAW THE REGRESSION LINE.
C
C      CALL TXTCLR(ICOLOR(2))
      CALL TXTCLR(ICOLOR(1))    ! Publication
      IF (IORD .GT. 0)
     XCALL REGRES(C,IORD,RMNA1,RMXA1,XSCALE,RMNA2,RMXA2,YSCALE)
C
C         THE WORK IS DONE.
C
      CALL SCHOLD
C
      RETURN
      END
C***********************************************************************
C
C                   PLOTS DATA.
C
C***********************************************************************
C
      SUBROUTINE PLORD(N,D,RMNA1,XSCALE,RMNA2,YSCALE,CUTOFF)
C
      INCLUDE 'log.inc'
C
      REAL*8 D(LOG_LENGTH,5)
C
      COMMON /BOX/ XLL,YLL,XUR,YUR
C
      DO 100 I = 1,N
      X = XLL + (D(I,1) - RMNA1)*XSCALE
      Y = YLL + (D(I,2) - RMNA2)*YSCALE
      WCCC = D(I,5)
      CALL COLCRS(X,Y,WCCC,CUTOFF)
  100 CONTINUE
      CALL SLINDX(1)
      RETURN
      END
C***********************************************************************
C
C                    DRAWS REGRESSION LINE.
C
C***********************************************************************
C
      SUBROUTINE REGRES(C,N,RMNA1,RMXA1,XSCALE,RMNA2,RMXA2,YSCALE)
C
      INTEGER*4 INC/200/
      REAL*8 C(20)
      REAL*8 X,Y,DELTA
C
      COMMON /BOX/ XLL,YLL,XUR,YUR
C
      X = RMNA1
      DELTA = (RMXA1 - RMNA1)/INC
      DO 200 I = 1,INC+1
      Y = C(N)
      DO 100 J = 1,N-1
      K = N + 1 - J
  100 Y = C(K-1) + X*Y
      XPLT = XLL + (X - RMNA1)*XSCALE
      YPLT = YLL + (Y - RMNA2)*YSCALE
      IF ( I .EQ. 1) THEN
C          FIRST POINT
         YAUX = YPLT
         IF (YPLT .LT. YLL) YAUX = YLL
         IF (YPLT .GT. YUR) YAUX = YUR
         CALL XMOVEA(XPLT,YAUX)
      ELSE
         IF (YPLT .LE. YUR  .AND.  YPLT .GE. YLL ) THEN
C          POINT INSIDE TRACK
            IF (YOLD .LE. YUR  .AND.  YOLD .GE. YLL ) THEN
C             POINT IN FOLLOWING POINT IN.
               CALL XDRAWA(XPLT,YPLT)
            ELSE
C             POINT IN FOLLOWING POINT OUT
               IF ( YOLD .LT. YLL ) THEN
                  XAUX=XPLT - (DELTA*XSCALE*(YPLT - YLL))/(YPLT - YOLD)
                  CALL XMOVEA(XAUX,YLL)
               ELSE
                  XAUX=XPLT - (DELTA*XSCALE*(YUR - YPLT))/(YOLD - YPLT)
                  CALL XMOVEA(XAUX,YUR)
               END IF
               CALL XDRAWA(XPLT,YPLT)
            END IF
         ELSE
C             POINT OUT.
            IF (YOLD .LE. YUR  .AND.  YOLD .GE. YLL ) THEN
C                POINT OUT FOLLOWING A POINT IN.
               IF ( YPLT .LT. YLL ) THEN
                  XAUX=XPLT - (DELTA*XSCALE*(YLL - YPLT))/(YOLD - YPLT)
                  CALL XDRAWA(XAUX,YLL)
               ELSE
                  XAUX=XPLT - (DELTA*XSCALE*(YPLT - YUR))/(YPLT - YOLD)
                  CALL XDRAWA(XAUX,YUR)
               END IF
            END IF
         END IF
      END IF
      YOLD = YPLT
      X = X + DELTA
  200 CONTINUE
      RETURN
      END
C***********************************************************************
C
C                   LABEL THE GRAPH.
C
C***********************************************************************
C
      SUBROUTINE LABGRA(NAME1,ID1,NAME2,ID2,CUTOFF,IORD,
     X                  IDSHAR,IDCORR,IDSHAM,IDCORM)
C
      CHARACTER*3 CHID1,CHID2
      CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      CHARACTER*4 LEGEN1
      CHARACTER*4 LEGEN2
      CHARACTER*11 LEGEND
      CHARACTER*20 NAME1
      CHARACTER*20 NAME2
      CHARACTER*47 TITLE1
      CHARACTER*65 TITLE2
C
      COMMON /BOX/ XLL,YLL,XUR,YUR
C
      COMMON /COLOPT/ ICOLOR(6)
C
C           FIRST LINE OF HEADING.
C
      IF (IORD .LE. 0 ) THEN
         TITLE1 = '               CHANGE IN DIP FOR               '
      ELSE
         WRITE(CHID1,'(I2)') IORD - 1
         TITLE1 = 'REGRESSION OF ORDER '//CHID1//
     X         'ON THE CHANGE IN DIP FOR'
      END IF
C
C           SECOND LINE OF HEADING.
C
      WRITE (CHID1,'(I3)') ID1
      WRITE (CHID2,'(I3)') ID2
      TITLE2 = 'WELLS '//CHID1//' ('//NAME1//')'//' AND '//
     X                   CHID2//' ('//NAME2//')'
C
C           PLOT THE HEADING.
C
       CALL XMOVEA(XLL+29.5,YUR+15.0)
       CALL GTEXTX(TITLE1)
       CALL XMOVEA(XLL+24.0,YUR+13.5)
       CALL GTEXTX(TITLE2)
       CALL XMOVEA(XLL+33.7,YUR+11.5)
       CALL GTEXTX('THE REFERENCE LOGS ARE '//IDSHAR//' AND '//IDCORR)
       CALL XMOVEA(XLL+33.7,YUR+10.0)
       CALL GTEXTX('THE MATCHING  LOGS ARE '//IDSHAM//' AND '//IDCORM)
       CALL XMOVEA(XLL+34.0,YUR+7.5)
       CALL GTEXTX('WEIGHTED CROSS-CORRELATION STRENGTH')
       X = XLL + 42.5
       Y = YUR + 7.5
       DELTA = (1.0 - CUTOFF)/5.0
       WCCC = 1.0 + 0.5*DELTA
       DO 100 I = 1,5
       Y = Y - 1.0
       WCCC = WCCC - DELTA
       CALL COLCRS(X,Y,WCCC,CUTOFF)
       CALL SLINDX(1)
C       CALL SLINDX(0)    ! Publication
       CALL XMOVEA(X+2.0,Y-0.3)
       WRITE(LEGEN1,'(F4.2)') WCCC+0.5*DELTA
       WRITE(LEGEN2,'(F4.2)') WCCC-0.5*DELTA
       LEGEND = LEGEN1//' - '//LEGEN2
C       CALL TXTCLR(ICOLOR(2))
       CALL TXTCLR(ICOLOR(6))
       CALL GTEXTX(LEGEND)
  100  CONTINUE
      RETURN
      END
C***********************************************************************
C
C                         RETRIVES COEFFICIENTS OF A POLYNOMIAL
C                         REGRESSION ON THE DIFFERENCE IN ELEVATION
C                         BETWEEN THE REFERENCE AND THE MATCHING
C                         WELLS. THE REGRESSION IS REQUIRED TO
C                         AUTOMATICALLY COMPUTE THE OFFSET ON THE
C                         CORRELATION SEARCH.
C
C***********************************************************************
C
      SUBROUTINE RETREC(IREG,C,REGN)
C
      INCLUDE 'log.inc'
C
      REAL*8 C(20)
      INTEGER REGN
      INTEGER NRGTAB(MAX_REG_DELZ)
      REAL*8 PR
      CHARACTER*2 OPTION
      LOGICAL ERROR
      CHARACTER*78 TXTMES
      REAL*8 R
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
C
      COMMON /LSTCIX/ LASTCI
      COMMON /COLOPT/ ICOLOR(6)
C
      include 'corrdb.inc'
C
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) LASTCI=0
      IF (LASTCI .GT. NCPWEL) LASTCI=0
      IF ((LASTCI .EQ. 0) .AND. (NCPWEL .GT. 0)) LASTCI=1
      IF (NCPWEL .EQ. 1) LASTCI=1
      ICP=LASTCI
      NREGCP=0
      IF (ICP .GT. 0) THEN
         CALL RCPHDR(ICPWEL(ICP))
        ENDIF
      IF (IREG .GT. NREGCP) IREG=0
C
      IRP=IREG
  11  CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40, 2,'SELECT REGRESSION EQUATION')
      CALL TXTCLR(ICOLOR(4))
      LINE=2
      IF (NREGCP .LE. 0) GO TO 12
      LINE=4
      IRN=NRGPTR

      WRITE (TXTMES,2001)
      CALL GTEXTS(2,LINE,TXTMES)
      WRITE (TXTMES,2002)
      CALL GTEXTS(2,LINE+1,TXTMES)
      WRITE (TXTMES,2003)
      CALL GTEXTS(2,LINE+2,TXTMES)
 2001 FORMAT (50X,'ERROR',11X,'CORR.')
 2002 FORMAT (3X,' #',2X,'DEGREE',4X,'TOP     BOTTOM',4X,
     1        'CUTOFF',3X,'MINIMUM',2X,'MAXIMUM',6X,'COEF.')
 2003 FORMAT (3X,69('-'),1X)
      LINE = LINE + 3
      DO 111 I=1,NREGCP
      NRGTAB(I)=IRN
      READ (25,REC=IRN) NEXT,IREGN,PCS,PCE,PRC,PRMN,PRMX,PR
      IRN=NEXT
      WRITE (TXTMES,6702) I,IREGN,PCS,PCE,PRC,PRMN,PRMX,PR
 6702 FORMAT (I2,2X,I4,2F10.1,2X,F8.3,2X,2F8.3,2X,F10.4)
      CALL GTEXTS( 5,LINE,TXTMES)
      LINE=LINE+1
  111 CONTINUE
C
   12 CALL TXTCLR(ICOLOR(3))
      IF (NCPWEL .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'CI - SELECT CORRELATION INTERPRETATION')
         CALL MARROW(75,LINE+2)
         LINE=LINE+1
        ENDIF
      IF (NREGCP .GT. 0) THEN
         CALL GTEXTS( 3,LINE+2,'SE - REGRESSION EQUATION TO SELECT')
         CALL GTXTIN(75,LINE+2,IRP)
         LINE=LINE+2
        ELSE
         LINE=LINE+1
        ENDIF
      CALL GTEXTS( 3,LINE+1,'RE - RETURN TO PREVIOUS MENU')
      LINE=LINE+1
      IF (IRP .GT. 0) THEN
         CALL GTEXTS( 3,LINE+1,'GO - SELECT REGRESSION EQUATION')
         LINE=LINE+1
        ENDIF
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. ' ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF ((IRP .GT. 0) .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'SE') THEN
         CALL AGETIN(ITEMP,ERROR)
         IF (.NOT. ERROR) THEN
            IF ((ITEMP .GT. 0) .AND.
     1          (ITEMP .LE. NREGCP)) IRP = ITEMP
           ENDIF
        ENDIF
C
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 0) THEN
         CALL SELTCP(ICP)
         IF (IREG .GT. NREGCP) IREG=NREGCP
         GO TO 11
        ENDIF
      GO TO 15
C
   51 IRN=NRGTAB(IRP)
      READ (25,REC=IRN) NEXT,NREG,CSTART,CEND,RCUTOF,
     1                       RMIN,RMAX,R,C
      REGN = NREG + 1
      IREG=IRP
      RETURN
      END
