C     CORRELATOR MODULE SECT
C
C*********************************************************************
C
C          PLOT CROSS SECTION WITH ALL CORRELATIONS
C
C*********************************************************************
C
      SUBROUTINE SECTXX(J1STIM,NUWELL)
C
      INCLUDE 'log.inc'
C
C
      CHARACTER*2 OPTION
C
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
             INTEGER*4 LOG1,LOG2,LOG3,LOG4
      COMMON /DIGS/ DIGS1,DIGS2
             REAL*4 DIGS1,DIGS2
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /DIGZ12/  DIGZS1,DIGZS2
      COMMON /CODINC/ DINC
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /YSTART/ YSTART
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /WTHLEG/ WTHLEG
      COMMON /DCI/ DCI
             CHARACTER*1 DCI
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /IFSC/ IFSC
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
      COMMON /RBOTZ/ RBOTZ
C            NAME OF FILE WITH ANNOTATION IN THE STRATIGRAPHIC COLUMN.
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
      COMMON /XTOPIM/ XTOPIM
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /TITLESECT/ TITLESECT
             CHARACTER*32 TITLESECT
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
      include 'corrdb.inc'
C
      MENU='SECT'
      NISECT=0
      FLASTR = .FALSE.
   11 DO 12 I = 1, NLITH
   12 LITHFLAG(I) = 0
C
C          DATA ENTRY.
C
      CALL READAT(J1STIM,OPTION,LINE,1,NISECT)
      IF (OPTION .EQ. 'RE') RETURN
      IF (OPTION .NE. 'GO') GO TO 11
      J1STIM = 1
      IF ( IFAULT .EQ. 1 ) CALL FAULIN(LINE,*11)
C
C          CORRELATION BOX BOUNDARIES.
C
      CALL BXBOUN(YSTART)
C
C         INITIALIZE PLOTTING FILE.
C
      YSP2=YSTART
      XSIZE=0.5+XBOT
      IF (AELG .EQ. 0) THEN
          NW = 2
         ELSE
          NW = 1 + NPAIRS
         ENDIF
      IF (IFSC .EQ. 1) THEN
         WLEG = 0.2 + WIDTHSCL
       ELSE  IF(IFSC .EQ. 2) THEN
         WLEG = 0.2 + WIDTHSCR
       ELSE  IF(IFSC .EQ. 3) THEN
         WLEG = 0.4 + WIDTHSCL + WIDTHSCR
       ELSE
         WLEG = 0.0
      END IF
      IF (LITHF .EQ. 1  ) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 2) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 1) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 3) THEN
         WLEG = WLEG + 2.0
         IF (IFSC .EQ. 1  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
         IF (IFSC .EQ. 0) WLEG = WLEG + 0.4
      END IF
      YSIZE=(YSTART+NW*(0.1+(2.0*TKWD)+DSWH)+(SHDIST/HSCALE)) - 0.05
     1                     + WLEG
      CALL TOOBIG(LINE,*11)
      CALL RPSECT(XSIZE,YSIZE+1.0+WTHLEG)
      IF (PLTSEL .EQ. 'V') THEN
         CALL MNMODE
         CALL BUSY(0,15,2,1)
        ENDIF
      CALL GMPINI(XSIZE,YSIZE+1.0+WTHLEG)
C
C          PREPARE TABLE OF EQUIVALENCE LINES.
C
      IF ( DCI .EQ. 'A' ) CALL TEQLIN
C
C          PLOT WELL PAIR.
C
      DO 101 NPS=1,NPAIRS
      JJ=NPS
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
C
C          DIGITIZED LOG FILE READING
C
      CALL RWELLH
      IF (NPS .NE. 1) GO TO 222
C
C          STRATIGRAPHIC COLUMN
C
      IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) 
     1           CALL STRACO(STRACOFL, 1, YSP2)
C
  222 HDIST = HDISTC(JJ)
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      IF (NPS .EQ. 1) THEN
         CALL REALOG(LOG1,IL1,RLOG1,CLG1MN,CLG1MX)
         CALL REALOG(LOG3,IL3,RLOG3,SLG3MN,SLG3MX)
        ELSE
         DO 102 I=1,IL1
         RLOG1(I)=RLOG2(I)
         RLOG3(I)=RLOG4(I)
  102    CONTINUE
        ENDIF
      CALL REALOG(LOG2,IL2,RLOG2,CLG2MN,CLG2MX)
      CALL REALOG(LOG4,IL4,RLOG4,SLG4MN,SLG4MX)
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
C
C          LITHOLOGY AT FIRST REFERENCE WELL
C
      YSP1=YSP2
      CALL TOPBOT(JJ+1,TOPZM,BOTZM)
      CALL TOPBOT(JJ,  TOPZR,BOTZR)
      IF (JJ .EQ. 1  .AND.  (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)) 
     1   CALL LITHANNOT(LFILEL, 1, YSP1,RLOG3,IL3,DIGS1,
     2                  TOPZR,BOTZR,YSP2)
      YSP1=YSP2
C
C          PLOT THE CORRELATIONS.
C
      CALL PLTCOR(RLOG1,IL1,RLOG2,IL2,RLOG3,IL3,RLOG4,IL4,DIGS1,DIGS2,
     1       TOPZR,BOTZR,TOPZM,BOTZM,YSP1,JJ,NPAIRS)
C
C          DRAW THE WELL LOGS.
C
      IF ((AELG .GT. 0 ) .OR. (JJ .EQ. 1)) THEN
         CALL PPTSPE(ID1,NAME1,RLOG3,IL3,RLOG1,IL1,DIGS1,
     1            TOPZR,BOTZR,YSP1,PSYMB1,JJ,NPAIRS,'R')
        END IF
      IF ( AELG .EQ. 0 ) THEN
         IF ( JJ .NE. NPAIRS) GO TO 660
         YSP2=0.05+YLEFT+(HDIST/HSCALE)
        ELSE
         YSP2=0.1+YSP1+(2.0*TKWD)+DSWH+(HDIST/HSCALE)
        END IF
      CALL PPTSPE(ID2,NAME2,RLOG4,IL4,RLOG2,IL2,DIGS2,
     1            TOPZM,BOTZM,YSP2,PSYMB2,JJ,NPAIRS,'M')
C
C...  LOAD CORRELATION INTERPRETATION
C
  660 IF ( AELG .EQ. 0  .AND. JJ .NE. NPAIRS)
     1      CALL WELLDY(YRIGHT,ID2,NAME2,PSYMB2,JJ,'M')
      IF (CPNUMB(NPS) .LT. 1) GO TO 669
      FLASTR = .TRUE.
      CALL RCPHDR(CPNUMB(NPS))
      NZ=NNNNCP
      NNCOR=NZ
C
C          PLOT FAULTS.
C
      IF ( IFAULT .EQ. 1 )
     1   CALL PLTFAU(TOPZR, RBOTZ, TOPZM, RBOTZ, YSP1, JJ)
c      IF (AELG .EQ. 0) YLEFT=YRIGHT
C
C          PRINT CORRELATION FILE
C
      CALL PRYNT(JJ,NP,NZ)
  669 IF (PLTSEL .EQ. 'V') CALL BUSY((100*JJ)/NPAIRS,15,2,1)
      IF (AELG .EQ. 0) YLEFT=YRIGHT
  101 CONTINUE
C
C          STRATIGRAPHIC COLUMN TO THE RIGHT OF THE CROSS-SECTION.    
C
      IF (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  THEN 
         IF (IFSC .EQ. 0  .OR.  IFSC .EQ. 1 ) THEN
            YSP1=YSIZE - 1.0
          ELSE
            YSP1=YSIZE - WIDTHSCR - 1.0
         END IF
         CALL LITHANNOT(LFILER, NPAIRS+1, YSP1,RLOG4,IL4,DIGS2,
     1                  TOPZM,BOTZM,YSP2)
      END IF
      IF (IFSC .EQ. 2  .OR.  IFSC .EQ. 3 ) THEN
         YSTART = YSIZE - WIDTHSCR
         CALL STRACO(STRACOFR, NPAIRS+1, YSP2)
      END IF
C
C          DISPLAY LEGENDS
C
      TITLESECT = 'LITHOSTRATIGRAPHIC CORRELATIONS'
      CALL LEGEND
      CALL INDEXM(NUWELL)
      LITHLEGTOT = 0
      DO 700 I = 1, NLITH
  700 LITHLEGTOT = LITHLEGTOT + LITHFLAG(I)
      HILITHLEG = XTOPIM - 1.1 - 0.9*(LITHLEGTOT+1)/2.0
      IF (LITHLEGTOT .GT. 0  .AND.  
     1    HILITHLEG .GE. 7.0 ) CALL LITHLEGEND
      CALL HORSCALE
C
C          DISPLAY TITLE
C
      CALL DTITLE               !Publication
C
C          CLOSE PLOTTING FILE.
C
      CALL GMPFIN
      CALL SCHOLD
      CALL XINITT
      GO TO 11
      END
C*********************************************************************
C
C                     PLOT PERSISTENT CORRELATIONS
C                     ****************************
C
C*********************************************************************
C
      SUBROUTINE PERSXX(J1STIM, NUWELL)
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION
C
      COMMON /IPERC/ IPER
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /DIGS/  DIGS1,DIGS2
      COMMON /DIGZ12/  DIGZS1,DIGZS2
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CODINC/ DINC
C
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /WSYMBL/ SYMBL1,SYMBL2
             INTEGER*4 SYMBL1(20),SYMBL2(20)
      COMMON /WIDENT/ IDENT1,IDENT2
             INTEGER*4 IDENT1(20),IDENT2(20)
      COMMON /WNAMES/ WNAME1,WNAME2
             CHARACTER*20 WNAME1(20),WNAME2(20)
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /RLEVEL/ RELEV1,RELEV2
             REAL*4 RELEV1(20),RELEV2(20)
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /YSTART/ YSTART
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /WTHLEG/ WTHLEG
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      COMMON /LABELL/ LDSHAR,LDCORR,LDSHAM,LDCORM
             CHARACTER*4 LDCORM(20),LDCORR(20)
             CHARACTER*4 LDSHAM(20),LDSHAR(20)
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /IFSC/ IFSC
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
      COMMON /RBOTZ/ RBOTZ
C            NAME OF FILE WITH ANNOTATION IN THE STRATIGRAPHIC COLUMN.
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
      COMMON /XTOPIM/ XTOPIM
      COMMON /TITLEPERS/ TITLEPERS
             CHARACTER*24 TITLEPERS
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
C
      MENU='PERS'
      NISECT=0
      FLASTR = .TRUE.
   11 DO 12 I = 1, NLITH
   12 LITHFLAG(I) = 0
C
C          DATA ENTRY.
C
      CALL READAT(J1STIM,OPTION,LINE,2,NISECT)
      IF (OPTION .EQ. 'RE') RETURN
      IF (OPTION .NE. 'GO') GO TO 11
      J1STIM = 1
C
C          CORRELATION BOX BOUNDARIES.
C
      CALL BXBOUN(YSTART)
C
C         CALCULATE SIZE OF PLOT.
C
      YSP2=YSTART
      XSIZE=0.5+XBOT
      IF (AELG .EQ. 0) THEN
          NW = 2
         ELSE
          NW = 1 + NPAIRS
         ENDIF
      IF (IFSC .EQ. 1) THEN
         WLEG = 0.2 + WIDTHSCL
       ELSE  IF(IFSC .EQ. 2) THEN
         WLEG = 0.2 + WIDTHSCR
       ELSE  IF(IFSC .EQ. 3) THEN
         WLEG = 0.4 + WIDTHSCL + WIDTHSCR
       ELSE
         WLEG = 0.0
      END IF
      IF (LITHF .EQ. 1  ) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 2) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 1) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 3) THEN
         WLEG = WLEG + 2.0
         IF (IFSC .EQ. 1  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
         IF (IFSC .EQ. 0) WLEG = WLEG + 0.4
      END IF
      YSIZE=(YSTART+NW*(0.1+(2.0*TKWD)+DSWH)+(SHDIST/HSCALE)) - 0.05
     1                     + WLEG
      CALL TOOBIG(LINE,*11)
C
C          DEFINE FAULTS
C
      IF ( IFAULT .EQ. 1 ) CALL FAULIN(LINE,*11)
C
C          PERSISTENT CORRELATION SEARCHING.
C
      CALL PERSIS
C
C          PRINT CORRELATION FILE
C
      IF ( IPER .LE. 0 ) RETURN
      CALL PRITRA
C
C          INITIALIZE PLOTTING DEVICE
C
      CALL RPTRAC(XSIZE,YSIZE+1.0+WTHLEG)
      IF (PLTSEL .EQ. 'V') THEN
         CALL MNMODE
         CALL BUSY(0,15,2,1)
        ENDIF
      CALL GMPINI(XSIZE,YSIZE+1.0+WTHLEG)
C
C          DIGITIZED LOG FILE READING
C
      DO 1600 NPS=1,NPAIRS
      JJ=NPS
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
      CALL RWELLH
      IF (NPS .NE. 1) GO TO 222
C
C          STRATIGRAPHIC COLUMN
C
      IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) 
     1            CALL STRACO(STRACOFL, 1, YSP2)
C
  222 HDIST = HDISTC(JJ)
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      IF (NPS .EQ. 1) THEN
         CALL REALOG(LOG1,IL1,RLOG1,CLG1MN,CLG1MX)
         CALL REALOG(LOG3,IL3,RLOG3,SLG3MN,SLG3MX)
        ELSE
         DO 102 I=1,IL1
         RLOG1(I)=RLOG2(I)
         RLOG3(I)=RLOG4(I)
  102    CONTINUE
        ENDIF
      CALL REALOG(LOG2,IL2,RLOG2,CLG2MN,CLG2MX)
      CALL REALOG(LOG4,IL4,RLOG4,SLG4MN,SLG4MX)
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
C
C          DRAW THE WELL LOGS.
C
      IDSHAR = LDSHAR(JJ)
      IDCORR = LDCORR(JJ)
      IDSHAM = LDSHAM(JJ)
      IDCORM = LDCORM(JJ)
      DIGS1=DIGZS1-RELEV1(JJ)
      DIGS2=DIGZS2-RELEV2(JJ)
      YSP1=YSP2
      CALL TOPBOT(JJ+1,TOPZM,BOTZM)
      CALL TOPBOT(JJ,TOPZR,BOTZR)
C
C          LITHOLOGY FOR FIRST WELL
C
      IF (JJ .EQ. 1  .AND.  (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)) 
     1   CALL LITHANNOT(LFILEL, 1, YSP1,RLOG3,IL3,DIGS1,
     2                  TOPZR,BOTZR,YSP2)
      YSP1=YSP2
C
C          PLOT THE CORRELATIONS.
C
      CALL PLTCOR(RLOG1,IL1,RLOG2,IL2,RLOG3,IL3,RLOG4,IL4,DIGS1,DIGS2,
     1            TOPZR,BOTZR,TOPZM,BOTZM,YSP1,JJ,NPAIRS)
C
C          DISPLAY WELLS
C
      IF ( AELG .EQ. 0 ) THEN
         IF ( JJ .NE. 1 ) GO TO 1550
      END IF
      CALL PPTSPE(IDENT1(JJ),WNAME1(JJ),RLOG3,IL3,RLOG1,IL1,DIGS1,
     1            TOPZR,BOTZR,YSP1,SYMBL1(JJ),JJ,NPAIRS,'R')
 1550 IF( AELG .EQ. 0 ) THEN
         IF ( JJ .NE. NPAIRS ) GO TO 1560
         YSP2=0.05+YLEFT+(HDISTC(JJ)/HSCALE)
      ELSE
         YSP2=0.1+YSP1+(2.0*TKWD)+DSWH+(HDISTC(JJ)/HSCALE)
      END IF
      CALL PPTSPE(IDENT2(JJ),WNAME2(JJ),RLOG4,IL4,RLOG2,IL2,DIGS2,
     1            TOPZM,BOTZM,YSP2,SYMBL2(JJ),JJ,NPAIRS,'M')
 1560 IF ( AELG .EQ. 0  .AND. JJ .NE. NPAIRS )
     1      CALL WELLDY(YRIGHT,IDENT2(JJ),WNAME2(JJ),SYMBL2(JJ),
     2                  JJ,'M')
      IF (PLTSEL .EQ. 'V') CALL BUSY((100*JJ)/NPAIRS,15,2,1)
C
C          PLOT FAULTS.
C
      IF ( IFAULT .EQ. 1 )
     1   CALL PLTFAU(TOPZR,RBOTZ,TOPZM,RBOTZ,YSP1,JJ)
      IF (AELG .EQ. 0) YLEFT=YRIGHT
 1600 CONTINUE
C
C          STRATIGRAPHIC COLUMN TO THE RIGHT OF THE CROSS-SECTION.    
C
      IF (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  THEN 
         IF (IFSC .EQ. 0  .OR.  IFSC .EQ. 1 ) THEN
            YSP1=YSIZE - 1.0
          ELSE
            YSP1=YSIZE - WIDTHSCR - 1.0
         END IF
         CALL LITHANNOT(LFILER, NPAIRS+1, YSP1,RLOG4,IL4,DIGS2,
     1                  TOPZM,BOTZM,YSP2)
      END IF
      IF (IFSC .EQ. 2  .OR. IFSC .EQ. 3 ) THEN
         YSTART = YSIZE - WIDTHSCR
         CALL STRACO(STRACOFR, NPAIRS+1, YSP2)
      END IF
C
C          DISPLAY LEGENDS
C
      TITLEPERS = 'PERSISTENT CORRELATIONS'
      CALL LEGEND
      CALL INDEXM(NUWELL)
      LITHLEGTOT = 0
      DO 700 I = 1, NLITH
  700 LITHLEGTOT = LITHLEGTOT + LITHFLAG(I)
      HILITHLEG = XTOPIM - 1.1 - 0.9*(LITHLEGTOT+1)/2.0
      IF (LITHLEGTOT .GT. 0  .AND.  
     1    HILITHLEG .GE. 7.0 ) CALL LITHLEGEND
      CALL HORSCALE
C
C          DISPLAY TITLE
C
      CALL DTITLE
C
C          CLOSE PLOTTING FILE.
C
      CALL GMPFIN
      CALL SCHOLD
      CALL XINITT
      GO TO 11
      END
C*********************************************************************
C
C                     TRACE CORRELATIONS ACROSS
C                     *************************
C
C*********************************************************************
C
      SUBROUTINE TRACXX(J1STIM, NUWELL)
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION
C
      COMMON /PERCOR/ PERCO
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /DIGS/  DIGS1,DIGS2
      COMMON /DIGZ12/  DIGZS1,DIGZS2
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CODINC/ DINC
C
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /WSYMBL/ SYMBL1,SYMBL2
             INTEGER*4 SYMBL1(20),SYMBL2(20)
      COMMON /WIDENT/ IDENT1,IDENT2
             INTEGER*4 IDENT1(20),IDENT2(20)
      COMMON /WNAMES/ WNAME1,WNAME2
             CHARACTER*20 WNAME1(20),WNAME2(20)
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /RLEVEL/ RELEV1,RELEV2
             REAL*4 RELEV1(20),RELEV2(20)
      COMMON /RBOTZ/ RBOTZ
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /YSTART/ YSTART
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /WTHLEG/ WTHLEG
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      COMMON /LABELL/ LDSHAR,LDCORR,LDSHAM,LDCORM
             CHARACTER*4 LDCORM(20),LDCORR(20)
             CHARACTER*4 LDSHAM(20),LDSHAR(20)
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /IFSC/ IFSC
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
C            NAME OF FILE WITH ANNOTATION IN THE STRATIGRAPHIC COLUMN.
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
      COMMON /XTOPIM/ XTOPIM
      COMMON /IPERC/ IPER
             INTEGER*4 IPER
      COMMON /POLIN/ POLIN
C            OPTION TO EITHER DRAW LINE OR PAINT
             CHARACTER*1 POLIN(LOG_LENGTH)
      COMMON /TITLETRAC/ TITLETRAC
             CHARACTER*36 TITLETRAC
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
C
      MENU='TRAC'
      NISECT=0
      FLASTR = .TRUE.
   11 DO 12 I = 1, NLITH
   12 LITHFLAG(I) = 0
C
C          DATA ENTRY.
C
      CALL READAT(J1STIM,OPTION,LINE,3,NISECT)
      IF (OPTION .EQ. 'RE') RETURN
      IF (OPTION .NE. 'GO') GO TO 11
      J1STIM = 1
C
C          CORRELATION BOX BOUNDARIES.
C
      CALL BXBOUN(YSTART)
C
C         CALCULATE PLOT SIZE.
C
      YSP2=YSTART
C      XSIZE=2.0+XBOT   !  Fig1.1
      XSIZE=0.5+XBOT   
      IF (AELG .EQ. 0) THEN
          NW = 2
         ELSE
          NW = 1 + NPAIRS
         ENDIF
      IF (IFSC .EQ. 1) THEN
         WLEG = 0.2 + WIDTHSCL
       ELSE  IF(IFSC .EQ. 2) THEN
         WLEG = 0.2 + WIDTHSCR
       ELSE  IF(IFSC .EQ. 3) THEN
         WLEG = 0.4 + WIDTHSCL + WIDTHSCR
       ELSE
         WLEG = 0.0
      END IF
      IF (LITHF .EQ. 1  ) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 2) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 1) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 3) THEN
         WLEG = WLEG + 2.0
         IF (IFSC .EQ. 1  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
         IF (IFSC .EQ. 0) WLEG = WLEG + 0.4
      END IF
      YSIZE=(YSTART+NW*(0.1+(2.0*TKWD)+DSWH)+(SHDIST/HSCALE)) - 0.05
     1                     + WLEG  !
      CALL TOOBIG(LINE,*11)
C
C          READ IN REFERENCE ELEVATIONS FOR TRACING.
C
      CALL REETRA(LINE,*11)
C
C          DEFINE FAULTS
C
      IF ( IFAULT .EQ. 1 ) CALL FAULIN(LINE,*11)
C
C          PREPARE TABLE OF EQUIVALENCE LINES.    !3/2002
C
      CALL TEQLIN
C
C          TRACE MARKERS.
C
      CALL TRACIN
C
C          INITIALIZE PLOTTING DEVICE
C
      CALL RPTRAC(XSIZE,YSIZE+1.0+WTHLEG)

      IF (PLTSEL .EQ. 'V') THEN
         CALL MNMODE
         CALL BUSY(0,15,2,1)
        ENDIF
      CALL GMPINI(XSIZE+0.5,YSIZE+1.0+WTHLEG)
C
C          DIGITIZED LOG FILE READING
C
      DO 3600 NPS=1,NPAIRS
      JJ=NPS
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
      CALL RWELLH
      IF (NPS .NE. 1) GO TO 222
C
C          STRATIGRAPHIC COLUMN
C
      IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) 
     1         CALL STRACO(STRACOFL, 1, YSP2)
C
  222 HDIST = HDISTC(JJ)
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      IF (NPS .EQ. 1) THEN
         CALL REALOG(LOG1,IL1,RLOG1,CLG1MN,CLG1MX)
         CALL REALOG(LOG3,IL3,RLOG3,SLG3MN,SLG3MX)
        ELSE
         DO 102 I=1,IL1
         RLOG1(I)=RLOG2(I)
         RLOG3(I)=RLOG4(I)
  102    CONTINUE
        ENDIF
      CALL REALOG(LOG2,IL2,RLOG2,CLG2MN,CLG2MX)
      CALL REALOG(LOG4,IL4,RLOG4,SLG4MN,SLG4MX)
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
      IDSHAR = LDSHAR(JJ)
      IDCORR = LDCORR(JJ)
      IDSHAM = LDSHAM(JJ)
      IDCORM = LDCORM(JJ)
      DIGS1=DIGZS1-RELEV1(JJ)
      DIGS2=DIGZS2-RELEV2(JJ)
      CALL TOPBOT(JJ+1,TOPZM,BOTZM)
      CALL TOPBOT(JJ,TOPZR,BOTZR)
      YSP1=YSP2
       IF (JJ .EQ. 1  .AND.  (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)) 
     1   CALL LITHANNOT(LFILEL, 1, YSP1,RLOG3,IL3,DIGS1,
     2                  TOPZR,BOTZR,YSP2)
      YSP1=YSP2
C
C          PLOT THE CORRELATIONS.
C
      CALL PLTCOR(RLOG1,IL1,RLOG2,IL2,RLOG3,IL3,RLOG4,IL4,DIGS1,DIGS2,
     1            TOPZR,BOTZR,TOPZM,BOTZM,YSP1,JJ,NPAIRS)
C
C          DRAW THE WELL LOGS.
C
      IF ( AELG .EQ. 0 ) THEN
         IF ( JJ .NE. 1 ) GO TO 3550
      END IF
      CALL PPTSPE(IDENT1(JJ),WNAME1(JJ),RLOG3,IL3,RLOG1,IL1,DIGS1,
     1            TOPZR,BOTZR,YSP1,SYMBL1(JJ),JJ,NPAIRS,'R')
 3550 IF( AELG .EQ. 0 ) THEN
         IF ( JJ .NE. NPAIRS ) GO TO 3560
         YSP2=0.05+YLEFT+(HDISTC(JJ)/HSCALE)
      ELSE
         YSP2=0.1+YSP1+(2.0*TKWD)+DSWH+(HDISTC(JJ)/HSCALE)
      END IF
      CALL PPTSPE(IDENT2(JJ),WNAME2(JJ),RLOG4,IL4,RLOG2,IL2,DIGS2,
     1            TOPZM,BOTZM,YSP2,SYMBL2(JJ),JJ,NPAIRS,'M')
 3560  IF (PLTSEL .EQ. 'V') CALL BUSY((100*JJ)/NPAIRS,15,2,1)
C
C          PLOT FAULTS.
C
      IF ( IFAULT .EQ. 1 )
     1   CALL PLTFAU(TOPZR,RBOTZ,TOPZM,RBOTZ,YSP1,JJ)
      IF (AELG .EQ. 0) YLEFT=YRIGHT
      IF ( AELG .EQ. 0  .AND. JJ .NE. NPAIRS)
     1      CALL WELLDY(YRIGHT,IDENT2(JJ),WNAME2(JJ),PSYMB2,JJ,'M')
 3600 CONTINUE
C
C          STRATIGRAPHIC COLUMN TO THE RIGHT OF THE CROSS-SECTION.    
C
      IF (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  THEN 
         IF (IFSC .EQ. 0  .OR.  IFSC .EQ. 1 ) THEN
            YSP1=YSIZE - 1.0
          ELSE
            YSP1=YSIZE - WIDTHSCR - 1.0
         END IF
         CALL LITHANNOT(LFILER, NPAIRS+1, YSP1,RLOG4,IL4,DIGS2,
     1                  TOPZM,BOTZM,YSP2)
      END IF
      IF (IFSC .EQ. 2  .OR.  IFSC .EQ. 3) THEN
         YSTART = YSIZE - WIDTHSCR
         CALL STRACO(STRACOFR, NPAIRS+1, YSP2)
      END IF
C
C          PRINT CORRELATION FILE
C
      CALL PRITRA
C
C          DISPLAY LEGEND
C
        NUMP = 0
        DO 3700 I = 1,IPER
        IF (POLIN(I) .EQ. 'P'  .OR.  POLIN(I) .EQ. 'B') THEN
           NUMP = NUMP + 1
        END IF
 3700   CONTINUE
        IF (NUMP .EQ. 0) THEN
           TITLETRAC = 'LITHOSTRATIGRAPHIC MARKERS'
         ELSE IF (NUMP .EQ. IPER) THEN
           TITLETRAC = 'LITHOSTRATIGRAPHIC UNITS'
C           TITLETRAC = 'GEOLOGIC CROSS SECTION'
         ELSE
           TITLETRAC = 'LITHOSTRATIGRAPHIC UNITS AND MARKERS'
        END IF
C      TITLETRAC = '    '   ! Publication.  Comment out next two also.
c      if (npairs .gt. 0) go to 777   !  Fig1.1
      CALL LEGEND
      CALL INDEXM(NUWELL)
C      XTOPIM = xsize - 12.65 ! Publication
C      ysize = ysize + 1.1   ! Publication
C      XTOPIM = xsize - 3 ! Fig11.14
C      ysize = -9.75 + (ysize-1.0)/2.0   ! Fig11.14
      LITHLEGTOT = 0
      DO 700 I = 1, NLITH
  700 LITHLEGTOT = LITHLEGTOT + LITHFLAG(I)
      HILITHLEG = XTOPIM - 1.1 - 0.9*(LITHLEGTOT+1)/2.0
      IF (LITHLEGTOT .GT. 0  .AND.  
     1    HILITHLEG .GE. 7.0 ) CALL LITHLEGEND
c  777 XTOPIM = xsize - 0.1              ! Fig1.1
c      ysize = -1.75 + (ysize-1.0)/2.0   ! Fig1.1
c  777 XTOPIM = xsize - 5.1               ! Fig11.14
c      ysize = -9.75 + (ysize-1.0)/2.0   ! Fig11.14
      CALL HORSCALE
C
C          DISPLAY TITLE
C
C
      CALL DTITLE
C
C          CLOSE PLOTTING FILE.
C
      CALL GMPFIN
      CALL SCHOLD
      CALL XINITT
      GO TO 11
      END
      SUBROUTINE RPTRAC(XSIZE,YSIZE)
C
C                   REPORT FOR OPTION 'LP', 'LM', 'AD', AND 'TD'.
C
C***********************************************************************
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /PRINTC/ FYLEPR
             CHARACTER*40 FYLEPR
      COMMON /COFIPR/ COFIPR
             CHARACTER*40 COFIPR
      COMMON /SPEFIL/ SPEFIL
             CHARACTER*40 SPEFIL
      COMMON /FYLPLO/ FYLPLO
             CHARACTER*40 FYLPLO
      COMMON /FYLTRA/ FILTRA
             CHARACTER*40 FILTRA
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /FYLDAT/ NDATUM
             CHARACTER*40 NDATUM
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /FFAULT/ FFAULT
             CHARACTER*40 FFAULT
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /ROTATE/ ROT
             CHARACTER*1 ROT    
      COMMON /ELOD/  ELOD
             CHARACTER*1 ELOD
C
      CALL ANMODE
      IF ( MENU .EQ. 'PERS' ) WRITE(QTEKOT,2000) COFIPR,SPEFIL
      IF ( MENU .EQ. 'TRAC' ) WRITE(QTEKOT,2001) COFIPR,SPEFIL,FILTRA
      IF ( MENU .EQ. 'ADIP' ) WRITE(QTEKOT,2005) COFIPR,SPEFIL
      IF ( MENU .EQ. 'TDIP' ) WRITE(QTEKOT,2006) COFIPR,SPEFIL
      IF ( DATUMF .EQ. 2 ) WRITE(QTEKOT,2002) NDATUM
      IF ( IFAULT .EQ. 1 ) WRITE(QTEKOT,2004) FFAULT
      IF (ROT .EQ. 'L') THEN
         WRITE(QTEKOT,2003) FYLEPR,FYLPLO,XSIZE,YSIZE
       ELSE
         WRITE(QTEKOT,2003) FYLEPR,FYLPLO,YSIZE,XSIZE
      END IF
      IF (ELOD .EQ. 'E') then
         WRITE(QTEKOT,2008)
        ELSE
         WRITE(QTEKOT,2009)
      ENDIF
      CALL RETKEY
      RETURN
 2000 FORMAT(///20X,'PRINTING AND PLOTTING OF PERSISTENT CORRELATIONS'/
     1         20X,'************************************************'///
     2           8X,'SOURCE FILE                   ',A40/
     2           8X,'PLOTTING SPECIFICATION FILE   ',A40)
 2001 FORMAT(///25X,'PRINTING AND PLOTTING OF MARKERS TRACED ACROSS'/
     1          25X,'**********************************************'///
     2           8X,'SOURCE FILE                   ',A40/
     2           8X,'PLOTTING SPECIFICATION FILE   ',A40/
     3           8X,'MARKER FILE                   ',A40)
 2002 FORMAT(    8X,'DATUM FILE                    ',A40)
 2003 FORMAT(    8X,'PRINTING FILE                 ',A40/
     1           8X,'PLOTTING FILE                 ',A40/
     2           8X,'PLOT LENGTH ALONG PAPER ROLL',F6.1,' INCHES'/
     3           8X,'PLOT WIDTH ACROSS PAPER ROLL',F6.1,' INCHES')
 2004 FORMAT(    8X,'FAULT FILE                    ',A40)
 2005 FORMAT(///25X,'PLOTTING OF APPARENT DIP DIAGRAMS'/
     1         25X,'**********************************'///
     2           8X,'SOURCE FILE                   ',A40/
     2           8X,'PLOTTING SPECIFICATION FILE   ',A40)
 2006 FORMAT(///25X,'PLOTTING OF A TRUE DIP DIAGRAM'/
     1         25X,'*******************************'///
     2           8X,'SOURCE FILE                   ',A40/
     2           8X,'PLOTTING SPECIFICATION FILE   ',A40)
 2008 FORMAT(    8X,'PLOT VERTICAL SCALE IS ELEVATION'//)
 2009 FORMAT(    8X,'PLOT VERTICAL SCALE IS DEPTH'//)
      END
      SUBROUTINE REFAUL(LINE,IERFAU,*)
C
C         CHECKS FAULT FILE AND READS IN FAULT PARAMETERS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 CHI
      CHARACTER*4 HEFA
      CHARACTER*4 BOMU
      CHARACTER*10 Z1, Z2
      CHARACTER*58 TXTMES
      INTEGER*4 TITLEN
      LOGICAL M1FLAG, JUMPFLAG
C
      COMMON /USCAL/  BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/  ICOLOR(6)
      COMMON /FFAULT/ FFAULT
             CHARACTER*40 FFAULT
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
      COMMON /PENFAU/ PENFAU
             INTEGER*4 PENFAU(MAX_NO_FAULTS)
      COMMON /AZIMFA/  AZIMFA(MAX_NO_FAULTS)
      COMMON /CODINC/ DINC
C
C           CHECK FILE TYPE.
C
      IERFAU = 0 
      CALL CHKOTY(88,FFAULT,0,51,1,LINE+2,IERFAU)
      IF ( IERFAU .NE. 0 ) RETURN 1
C
      READ (88,9000,REC=1) HEFA,IDOG,NFAULT,NUMREC
C
C           MAKE SURE THERE IS AT LEAST ONE FAULT PLANE RECORD.
C
      IF ( NFAULT .LE. 0 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** FILE ' // FFAULT(1:TITLEN(FFAULT)) // ' IS EMPTY.')
         LINE = LINE + 1
         CALL SCHOLD
         IERFAU = 1
         RETURN 1
       END IF
C
C            CHECK THAT THE DEPTHS GO FROM SWALLOWEST
C            TO DEPEEST FOR EVERY TABLE.
C
      K = 2
      DO 150 I = 1,NFAULT
      READ(88,9001,REC=K) NTAB
      K = K + 1
      IF ( NTAB .GT. 1 ) THEN
         READ(88,9007,REC=K) PZU
         K = K + 1
         DO 100 II = 2,NTAB
         READ(88,9007,REC=K) ZU
         K = K + 1
         IF ( ZU .LE. PZU ) THEN
            WRITE(Z1,'(F10.2)') ZU
            WRITE(Z2,'(F10.2)') PZU
            WRITE(CHI,'(I2)') I
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+2,
     1       '***** DEPTHS NOT IN ASCENDING ORDER-' //Z1 //' AFTER '
     2      // Z2 // ' ' // BOMU(BOM) )
            CALL GTEXTS(11,LINE+3,
     1             ' IN FAULT TABLE NO. '//CHI//'.')  
            IERFAU = 1
            LINE = LINE + 2  
         END IF
         PZU = ZU
  100    CONTINUE
C
C            CHECK IF THERE IS AT LEAST ONE RECORD PER TABLE.
C
       ELSE IF ( NTAB .EQ. 1 ) THEN
          K = K + 1
       ELSE IF ( NTAB .LE. 0 ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(15,LINE+2,
     1   '***** FILE ' // FFAULT(1:TITLEN(FFAULT)) //
     2   ' DOES NOT HAVE A MISSING SECTION TABLE.')
         LINE = LINE + 1
         IERFAU = 1
      END IF
  150 CONTINUE
C
C            READ IN TABLES.
C
      M1FLAG = .TRUE.
      K = 2
      DO 250 I = 1,NFAULT
      READ(88,9003,REC=K) NWF(I),ZFAULT(I), AZIMFA(I),
     1                    DIPF(I),PENFAU(I), NRTAB(I)
      IF (IDOG .EQ. 2) DIPF(I) = 57.29578*ATAN(DIPF(I))
      IF(AZIMFA(I) .LT. 0.0) AZIMFA(I) = 360.0 + AZIMFA(I)
      K = K + 1
      DO 200 II = 1,NRTAB(I)
      READ(88,9007,REC=K) TZU(I,II), SECM(I,II), 
     1                   SMICCINC(I,II), ZREF(I,II)
      K = K + 1
      IF ( SMICCINC(I,II) .LE. -1.0  .AND. M1FLAG) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(15,LINE+2,
     1   '***** GROWTH RATES IN FAULT TABLES MUST BE LARGER THAN -1.0')
         M1FLAG = .FALSE.
         LINE = LINE + 1
         IERFAU = 1
      END IF
  200 CONTINUE
  250 CONTINUE
C
      JUMPFLAG = .TRUE. 
      DO 350 I = 1,NFAULT
      DO 300 II = 1,NRTAB(I)
      IF( NRTAB(I) .EQ. 1  .OR.  II .EQ. NRTAB(I)) GO TO 300
      UIBI = SECM(I,II) + SMICCINC(I,II)*(TZU(I,II+1) - ZREF(I,II))
      UIP1AIP1 = SECM(I,II+1) + 
     1           SMICCINC(I,II+1)*(TZU(I,II+1) - ZREF(I,II+1))
      DELTA = ABS(UIBI - UIP1AIP1)
      IF ( DELTA .GT. DINC) THEN
         JUMPFLAG = .FALSE. 
         CALL TXTCLR(ICOLOR(6))
         WRITE (TXTMES,9008) I
         CALL GTEXTS(5,LINE+2,
     1   '***** WARNING:  JUMP IN FAULT TABLES.  '//TXTMES)
C     2         'FOR EXAMPLE, IN TABLE , MISSING')
         WRITE (TXTMES,9009) II,TZU(I,II+1),II+1,TZU(I,II+1)
         CALL GTEXTS(21,LINE+3,TXTMES)
         CALL GTEXTS(21,LINE+4,
     1   'CHECK RATES OF INCREASE AND DEPTH BASES.')
         LINE = LINE + 4
         CALL SCHOLD
         GO TO 400
      END IF
  300 CONTINUE
  350 CONTINUE
  400 IF ( IERFAU .NE. 0 ) THEN
         IF (JUMPFLAG) CALL SCHOLD
         RETURN 1
      END IF
      CLOSE(88,STATUS='KEEP')
C
      RETURN
 9000 FORMAT (A4,31X,3I5)
 9001 FORMAT (40X,I5)
 9003 FORMAT (2X,I3,3F10.2,2I5,4X,1A1)
 9007 FORMAT(2F10.2, 10X, F10.4, F10.2)
 9008 FORMAT ('FOR EXAMPLE, IN TABLE ',I2,', MISSING')
 9009 FORMAT ('SECTION U(',I2,',',F9.2,') IS DIFFERENT FROM ',
     1        'U(',I2,',',F9.2,').')
      END
      SUBROUTINE FAULIN(LINE,*)
C
C         COMPUTES INTERSECTION OF WELLS AND FAULTS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      INTEGER*4 CTT
C
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
C
      DO 100 I = 1,NFAULT
      II = I
      CALL FINDTR(LINE,NWF(II),CTT,*850)
      FINTZ(I,CTT) = ZFAULT(II)
      IF ( CTT .GT. 1 ) CALL FINTL(II,CTT)
      IF ( CTT .LE. NPAIRS ) CALL FINTR(II,CTT)
  100 CONTINUE
      RETURN
  850 RETURN 1
      END
      SUBROUTINE FINTL(I,J)
C
C         COMPUTES INTERSECTION OF WELLS AND FAULTS TO THE
C         LEFT OF THE INTERSECTED WELL IN THE FAULT FILE.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
C
      DO 100 K = J-1,1,-1
      KK = K
      FINTZ(I,KK) = FINTZ(I,KK+1) - FTDIP(KK,I)*HDISTC(KK)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE FINTR(I,J)
C
C         COMPUTES INTERSECTION OF WELLS AND FAULTS TO THE
C         RIGHT OF THE INTERSECTED WELL IN THE FAULT FILE.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
C
      DO 100 K = J+1,NPAIRS+1
      KK = K
      FINTZ(I,KK) = FINTZ(I,KK-1) + FTDIP(KK-1,I)*HDISTC(KK-1)
  100 CONTINUE
      RETURN
      END
         SUBROUTINE PLTFAU(TOPZR,BOTZR,TOPZM,BOTZM,YSP1,NPS)
C
C                    DRAWS FAULTS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /FINTMA/ FINTZ(MAX_NO_FAULTS,21)
      COMMON /PENFAU/ PENFAU
             INTEGER*4 PENFAU(MAX_NO_FAULTS)
      COMMON /GFTABLE/ NRTAB, SECM, TZU, SMICCINC, ZREF
             INTEGER*4 NRTAB(MAX_NO_FAULTS)
             REAL*4 SECM(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 TZU(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 SMICCINC(MAX_NO_FAULTS,MAX_REC_TAB)
             REAL*4 ZREF(MAX_NO_FAULTS,MAX_REC_TAB)
      COMMON /TZUL/ TZUL(MAX_NO_FAULTS)
C        LOCATION OF TOP OF WELLS, INCHES, WHICH ARE THE KELLY
C        BUSHINGS IN CASE THE DISPLAY STARTS ABOVE THE LAND SURFACE.
      COMMON /KBINCH/ XLEFT,YDOWN, XRIGHT, YUP
C
      include 'corrdb.inc'
C
      HWDIST= HDISTC(NPS)
      IF (AELG .EQ. 1) THEN
         YLEFTF=0.05+YSP1+(2.0*TKWD)+DSWH
        ELSE
         YLEFTF = YLEFT
        END IF
      YRIGHF=YLEFTF+(HWDIST/HSCALE)
      DO 260 L = 1,NFAULT
      CALL GMPLCR(PENFAU(L))
      Z1 = FINTZ(L,NPS)
      Z2 = FINTZ(L,NPS+1)
      IF(Z1 .LE. TOPZR  .AND.  Z2 .LE. TOPZM) GO TO 260
      IF(Z1 .GE. BOTZR  .AND.  Z2 .GE. BOTZM) GO TO 260
      IF(Z1 .LE. TZU(L,1)  .AND.  Z2. LE. TZU(L,1)) GO TO 260
      XZ1=XTOP+((Z1-TOPZR)/VSCALE)
      YZ1=YLEFTF
      XZ2=XTOP+((Z2-TOPZM)/VSCALE)
      YZ2=YRIGHF
C
C         DRAW THE WHOLE FAULT TRACE.
C
      IF(Z1 .GE. TZU(L,1)  .AND.  Z2. GE. TZU(L,1)) THEN
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,HWDIST,YLEFTF,
     1            -999, 9999.,XZ1,YZ1,XZ2,YZ2)
C
C         DRAW ONLY THAT PORTION OF THE FAULT TRACE THAT
C         IS BELOW THE STARTING DEPTH GIVEN BY "TZU(L,1)."
C
       ELSE
C          A.  INTERSECTION OF FAULT AT SURFACE, EVEN IF IT
C              IS ONLY A THOERETICAL EXTENSION TOWARD THE SURFACE
C                 FAULT TRACE.
         CALL LINPAR(XZ1,YZ1,XZ2,YZ2,AF,BF)
C                 LAND SURFACE TRACE.
         CALL LINPAR(XLEFT,YDOWN, XRIGHT, YUP,AS,BS)
C                 INTERSECTION OF FAULT AND LAND SURFACE.
         DENOM = AF - AS
         XXSF = (BS - BF)/DENOM
         YXSF = (AF*BS - AS*BF)/DENOM
C          B.  LOCATION OF BEGINNING OF FAULT
         IF (XZ1 .LE. XZ2) THEN
            XBF=XTOP+((TZU(L,1)-TOPZR)/VSCALE)
            IF (TZU(L,1) .GE. Z1  .AND.  TZU(L,1) .LE. Z2 ) THEN
               YBF = YZ1 + (HWDIST*(XBF - XZ1))/(HSCALE*(XZ2-XZ1))
             ELSE
               XBF = -1.0E20
            END IF
          ELSE
            XBF=XTOP+((TZU(L,1)-TOPZM)/VSCALE)
            IF (TZU(L,1) .GE. Z2  .AND.  TZU(L,1) .LE. Z1 ) THEN
C               YBF = YZ1 + (HWDIST*(XBF - XZ2))/(HSCALE*(XZ1-XZ2))
               YBF = YZ2 - (HWDIST*(XBF - XZ2))/(HSCALE*(XZ1-XZ2)) ! BGR
             ELSE
               XBF = -1.0E20
            END IF
         END IF
C          KEEP THE DEEPEST OF (A) AND (B)
         IF (XBF .GT. XXSF) THEN
            XXSF = XBF
            YXSF = YBF
         END IF
         write(91,"(2x,'XXSF,YXSF: ',2F10.3)") XXSF,YXSF
C                 INTERSECTION OF FAULT AND TOP OF DISPLAY.
         XXDF = XTOP
         YXDF = AF*XTOP + BF
C           SHALLOW END OF FAULT IS DEEPEST CROSSING
         IF (XXSF .GE. XXDF) THEN
            XX = XXSF
            YX = YXSF
          ELSE
            XX = XXDF
            YX = YXDF
         END IF
C           SHALLOW END OF FAULT DEPENDS ON DIPPING
         IF ( XZ1 .LT. XZ2 ) THEN
            XZ1 = XX
            YZ1 = YX
          ELSE
            XZ2 = XX
            YZ2 = YX
         END IF
         FRDIST = HWDIST*((YZ2 - YZ1)/(YRIGHF - YLEFTF))
         CALL LINIBX(TOPZR,BOTZR,TOPZM,BOTZM,FRDIST,YZ1,
     1            -999, 9999.,XZ1,YZ1,XZ2,YZ2)
      END IF
  260 CONTINUE
      RETURN
      END
C***********************************************************************
C
C              PRINT WARNINGS ON EXCESS SIZE PLOTS.
C
C***********************************************************************
C
      SUBROUTINE TOOBIG(LINE,*)
C
      LOGICAL FLAGL, FLAGW
      CHARACTER*6 LBUF
C
      COMMON /WTHLEG/ WTHLEG
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /ROTATE/ ROT
             CHARACTER*1 ROT
C
      FLAGL = .FALSE.
      FLAGW = .FALSE.
      IF ( ROT .EQ. 'W') THEN
         ALONGR = YSIZE + 0.5 + WTHLEG + 0.5
         ACROSR = XSIZE
       ELSE
         ALONGR = XSIZE
         ACROSR = YSIZE + 0.5 + WTHLEG + 0.5
      END IF
      IF (ALONGR .GT. 306.0) FLAGL = .TRUE.
      IF (ACROSR .GT. 42.0) FLAGW = .TRUE.
      IF ( FLAGL ) THEN
         CALL TXTCLR(ICOLOR(6))
         WRITE(LBUF,"(F6.1)") ALONGR
         CALL GTEXTS(3,LINE+2,'***** PLOT TOO LONG.  THE PLOT IS '//
     1        LBUF//' INCHES ALONG THE PAPER LENGTH.')
         CALL GTEXTS(3,LINE+3,
     2        '      THE MAXIMUM ALLOWABLE WIDTH IS 306 INCHES.')
      LINE = LINE + 2
      END IF
      IF ( FLAGW ) THEN
         CALL TXTCLR(ICOLOR(6))
         WRITE(LBUF,"(F6.1)") ACROSR
         CALL GTEXTS(3,LINE+2,'***** PLOT TOO WIDE.  THE PLOT IS '//
     1        LBUF//' INCHES ACROSS THE PAPER WIDTH.')
         CALL GTEXTS(3,LINE+3,
     1        '      THE MAXIMUM ALLOWABLE WIDTH IS 42 INCHES.')
       END IF
      LINE = LINE + 2
      IF ( FLAGL   .OR. FLAGW) THEN
         CALL SCHOLD
C         RETURN 1
      END IF
      RETURN
      END
C*********************************************************************
C
C                 PREPARES A TABLE WITH ALL THE EQUIVALENCE
C                 IMPLICIT IN THE CORRELATION FILE INFORMATION.
C
C*********************************************************************
C
      SUBROUTINE TEQLIN
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /TEQCOR/ TEQCOR(LOG_LENGTH,40)
      COMMON /WCCOEP/ WCCOEP
             REAL*4 WCCOEP(LOG_LENGTH,20)
      COMMON /IPERCO/ IPERCO
             INTEGER*4 IPERCO(20)
C
      COMMON /NCO/    NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
      COMMON /SLENTH/ SEALEN
             REAL*4 SEALEN(LOG_LENGTH,20)
      COMMON /WCCOEF/ WCCOEX
             REAL*4 WCCOEX(LOG_LENGTH,20)
C
      include 'corrdb.inc'
C
      DO 101 NPS=1,NPAIRS
      J2=2*NPS
      J1=J2-1
C
C          READ IN CORRELATION FILE HEADING.
C
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
      NZ = NCORRL(NPS)
      IPERCO(NPS)=0
      IF (NZ .LT. 1) GO TO 101
C      CALL REDCPR(Z1,Z2,XCFLAG,CORLEN,SEARLE,SKIP,CUTOFF,WCC)
      Z1=COMAT(1,NPS)
      Z2=COMAT(1,NPS+20)
      CORLEN=COLENG(1,NPS)
      WCC   =WCCOEX(1,NPS)
      DO 111 I=1,NZ
      IF ( I .LT. NZ ) THEN
C        CALL REDCPR(Z1P,Z2P,XCFLAG,CORLEP,SEARLP,SKIPP,CUTOFP,WCCP)
        I1=I+1
        Z1P=COMAT(I1,NPS)
        Z2P=COMAT(I1,NPS+20)
        CORLEP=COLENG(I1,NPS)
        WCCP  =WCCOEX(I1,NPS)
        IF ( (CORLEN + CORLEP) .GT. 0.0 ) THEN
           ZHALFR = (Z1*CORLEP + Z1P*CORLEN) / (CORLEN + CORLEP)
         ELSE
           ZHALFR = 0.5*(Z1 + Z1P)
         END IF
       END IF
C
C        LINES OF EQUIVALENCE IMPLICIT IN THE CORRELATED INTERVAL.
C
      ZLEFT = Z1 - 0.5*CORLEN
      ZRIGHT = Z2 - 0.5*CORLEN
      NEQLIN = 1 + CORLEN/DINC
C       DO NOT KEEP ADDDING ABOVE THE PREVIOUS LINE OF EQUIVALENCE.
      IF ( I .GT. 1  .AND.  ZLEFT .LE. Z1B ) THEN
         ZNEW = Z1B + DINC
         NEQLIN = NEQLIN - (ZNEW - ZLEFT)/DINC
         ZLEFT = ZNEW
         ZRIGHT = ZLEFT + (Z2 - Z1)
      END IF
C        TRY ALL POSSIBLE EQUIVALENCE LINES IN THE INTERVAL.
      DO 105 J = 1,NEQLIN
C       DO NOT KEEP ADDDING BELOW THE CENTER OF THE NEXT INTERVAL.
      IF ( I .LT. NZ  .AND.  ZLEFT .GE. ZHALFR) GO TO 107
C       SAVE LINE OF EQUIVALENCE IN TABLE.
      IPERCO(NPS) = IPERCO(NPS) + 1
      II = IPERCO(NPS)
      TEQCOR(II,J1) = ZLEFT
      TEQCOR(II,J2) = ZRIGHT
      WCCOEP(II,NPS) = WCC
C        COMPUTE DEPTH FOR EXTREMES OF NEXT EQUIVALENCE LINE.
      ZLEFT = ZLEFT + DINC
      ZRIGHT = ZRIGHT + DINC
  105 CONTINUE
  107 Z1B = TEQCOR(II,J1)
      Z1    =Z1P
      Z2    =Z2P
      CORLEN=CORLEP
      WCC   =WCCP
  111 CONTINUE
  101 CONTINUE
      RETURN
      END
C
C*********************************************************************
C
C          DISPLAY PROPORTION OF SHALE IN A CROSS-SECTION.
C
C*********************************************************************
C
      SUBROUTINE LITHOS(J1STIM,NUWELL)
C
      INCLUDE 'log.inc'
C
C
      CHARACTER*2 OPTION
      INTEGER DEPSEQ
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
             INTEGER*4 LOG1,LOG2,LOG3,LOG4
      COMMON /DIGS/ DIGS1,DIGS2
             REAL*4 DIGS1,DIGS2
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /DIGZ12/  DIGZS1,DIGZS2
      COMMON /CODINC/ DINC
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /YSTART/ YSTART
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /WTHLEG/ WTHLEG
      COMMON /DCI/ DCI
             CHARACTER*1 DCI
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /LISHAL/ NSHAL3,NSHAL4
              REAL*4 NSHAL3(LOG_LENGTH), NSHAL4(LOG_LENGTH)
      COMMON /IFSC/ IFSC
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
      COMMON /RBOTZ/ RBOTZ
C            NAME OF FILE WITH ANNOTATION IN THE STRATIGRAPHIC COLUMN.
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
      COMMON /XTOPIM/ XTOPIM
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /TITLELITH/ TITLELITH
             CHARACTER*30 TITLELITH
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
      include 'corrdb.inc'
C
      MENU='LITH'
      NISECT=0
      FLASTR = .FALSE.
   11 DO 12 I = 1, NLITH
   12 LITHFLAG(I) = 0
C
C          DATA ENTRY.
C
      CALL READAT(J1STIM,OPTION,LINE,6,NISECT)
      IF (OPTION .EQ. 'RE') RETURN
      IF (OPTION .NE. 'GO') GO TO 11
      J1STIM = 1
      IF ( IFAULT .EQ. 1 ) CALL FAULIN(LINE,*11)
      DCI = 'A'
C
C          CORRELATION BOX BOUNDARIES.
C
      CALL BXBOUN(YSTART)
C
C         INITIALIZE PLOTTING FILE.
C
      YSP2=YSTART
      XSIZE=0.5+XBOT
      IF (AELG .EQ. 0) THEN
          NW = 2
         ELSE
          NW = 1 + NPAIRS
         ENDIF
      IF (IFSC .EQ. 1) THEN
         WLEG = 0.2 + WIDTHSCL
       ELSE  IF(IFSC .EQ. 2) THEN
         WLEG = 0.2 + WIDTHSCR
       ELSE  IF(IFSC .EQ. 3) THEN
         WLEG = 0.4 + WIDTHSCL + WIDTHSCR
       ELSE
         WLEG = 0.0
      END IF
      IF (LITHF .EQ. 1  ) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 2) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 1) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 3) THEN
         WLEG = WLEG + 2.0
         IF (IFSC .EQ. 1  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
         IF (IFSC .EQ. 0) WLEG = WLEG + 0.4
      END IF
      YSIZE=(YSTART+NW*(0.1+(2.0*TKWD)+DSWH)+(SHDIST/HSCALE)) - 0.05
     1                          + WLEG
      CALL TOOBIG(LINE,*11)
      CALL RPSECT(XSIZE,YSIZE+1.5+WTHLEG)
      IF (PLTSEL .EQ. 'V') THEN
         CALL MNMODE
         CALL BUSY(0,15,2,1)
        ENDIF
      CALL GMPINI(XSIZE,YSIZE+1.0+WTHLEG)
C
C          PREPARE TABLE OF EQUIVALENCE LINES.
C
      CALL TEQLIN
C
C          PLOT WELL PAIR.
C
      DO 101 NPS=1,NPAIRS
      JJ=NPS
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
C
C          DIGITIZED LOG FILE READING
C
      CALL RWELLH
      IF (NPS .NE. 1) GO TO 222
C
C          STRATIGRAPHIC COLUMN
C
      IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) 
     1        CALL STRACO(STRACOFL, 1, YSP2)
C
  222 HDIST = HDISTC(JJ)
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      IF (NPS .EQ. 1) THEN
         CALL REALOG(LOG1,IL1,RLOG1,CLG1MN,CLG1MX)
         CALL REALOG(LOG3,IL3,RLOG3,SLG3MN,SLG3MX)
        ELSE
         DO 102 I=1,IL1
         RLOG1(I)=RLOG2(I)
         RLOG3(I)=RLOG4(I)
  102    CONTINUE
        ENDIF
      CALL REALOG(LOG2,IL2,RLOG2,CLG2MN,CLG2MX)
      CALL REALOG(LOG4,IL4,RLOG4,SLG4MN,SLG4MX)
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
      CALL TOPBOT(JJ+1,TOPZM,BOTZM)
      CALL TOPBOT(JJ,  TOPZR,BOTZR)
      YSP1=YSP2
C
C          LITHOLOGY
C
      IF (JJ .EQ. 1  .AND.  (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)) 
     1   CALL LITHANNOT(LFILEL, 1, YSP1,RLOG3,IL3,DIGS1,
     2                  TOPZR,BOTZR,YSP2)
      YSP1=YSP2
C
C          PERCENT SHALE.
C
      MNIL13=MIN0(IL1,IL3)
      MNIL24=MIN0(IL2,IL4)
      ICS=DEPSEQ(TOPZR,DIGS1,DINC)
      ICE=DEPSEQ(BOTZR,DIGS1,DINC)
      IS=DEPSEQ(TOPZM,DIGS2,DINC)
      IE=DEPSEQ(BOTZM,DIGS2,DINC)
      CALL NSHALE(RLOG3,MNIL13,RLOG4,MNIL24,1,IL3,
     1            1,IL4,NSHAL3,NSHAL4)
c      fine up to here
C
C...  LOAD CORRELATION INTERPRETATION
C
      IF (CPNUMB(NPS) .LT. 1) GO TO 669
      FLASTR = .TRUE.
      CALL RCPHDR(CPNUMB(NPS))
      NZ=NNNNCP
      NNCOR=NZ
C
C          PLOT THE CORRELATIONS.
C
      CALL PLTCOR(RLOG1,IL1,RLOG2,IL2,RLOG3,IL3,RLOG4,IL4,DIGS1,DIGS2,
     1            TOPZR,BOTZR,TOPZM,BOTZM,YSP1,JJ,NPAIRS)
c     it is wrong here
C
C          PRINT CORRELATION FILE
C
      CALL PRYNT(JJ,NP,NZ)
      IF (PLTSEL .EQ. 'V') CALL BUSY((100*JJ)/NPAIRS,15,2,1)
C
C          DRAW THE WELL LOGS.
C
  669 IF ((AELG .GT. 0 ) .OR. (JJ .EQ. 1)) THEN
         CALL PPTSPE(ID1,NAME1,RLOG3,IL3,RLOG1,IL1,DIGS1,
     1            TOPZR,BOTZR,YSP1,PSYMB1,JJ,NPAIRS,'R')
        END IF
      IF ( AELG .EQ. 0 ) THEN
         IF ( JJ .NE. NPAIRS) GO TO 660
         YSP2=0.05+YLEFT+(HDIST/HSCALE)
        ELSE
         YSP2=0.1+YSP1+(2.0*TKWD)+DSWH+(HDIST/HSCALE)
        END IF
      CALL PPTSPE(ID2,NAME2,RLOG4,IL4,RLOG2,IL2,DIGS2,
     1            TOPZM,BOTZM,YSP2,PSYMB2,JJ,NPAIRS,'M')
C
C          PLOT FAULTS.
C
  660 IF ( IFAULT .EQ. 1 )
     1   CALL PLTFAU(TOPZR, RBOTZ, TOPZM, RBOTZ, YSP1, JJ)
      IF (AELG .EQ. 0) YLEFT=YRIGHT
      IF ( AELG .EQ. 0  .AND. JJ .NE. NPAIRS)
     1      CALL WELLDY(YRIGHT,ID2,NAME2,PSYMB2,JJ,'M')
  101 CONTINUE
C
C          STRATIGRAPHIC COLUMN TO THE RIGHT OF THE CROSS-SECTION.    
C
      IF (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  THEN 
         IF (IFSC .EQ. 0  .OR.  IFSC .EQ. 1 ) THEN
            YSP1=YSIZE - 1.0
          ELSE
            YSP1=YSIZE - WIDTHSCR - 1.0
         END IF
         CALL LITHANNOT(LFILER, NPAIRS+1, YSP1,RLOG4,IL4,DIGS2,
     1                  TOPZM,BOTZM,YSP2)
      END IF
      IF (IFSC .EQ. 2  .OR.  IFSC .EQ. 3) THEN
         YSTART = YSIZE - WIDTHSCR
         CALL STRACO(STRACOFR, NPAIRS+1, YSP2)
      END IF
C
C          DISPLAY LEGENDS
C
C      TITLELITH = 'TRANSIT TIME'
      TITLELITH = 'PROPORTION OF SHALE'
      CALL LEGEND
      CALL INDEXM(NUWELL)
C      XTOPIM = xsize + 1.4 ! Fig11.15
C      ysize = -4.0 + (ysize-1.0)/2.0   ! Fig11.15
      LITHLEGTOT = 0  !Following 6 lines commented out for Fig 11.15
      DO 700 I = 1, NLITH
  700 LITHLEGTOT = LITHLEGTOT + LITHFLAG(I)
      HILITHLEG = XTOPIM - 1.1 - 0.9*(LITHLEGTOT+1)/2.0
      IF (LITHLEGTOT .GT. 0  .AND.  
     1    HILITHLEG .GE. 7.0 ) CALL LITHLEGEND
      CALL HORSCALE
C                           !Undo change for scale in pptspe.for
C          DISPLAY TITLE
C
      CALL DTITLE
C
C          CLOSE PLOTTING FILE.
C
      CALL GMPFIN
      CALL SCHOLD
      CALL XINITT
      GO TO 11
      END

C*********************************************************************
C
C                     PLOT TRUE DIP DIAGRAMS
C                     **********************
C
C*********************************************************************
C
      SUBROUTINE TDIDXX(J1STIM,NUWELL)
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /DIGS/  DIGS1,DIGS2
      COMMON /DIGZ12/  DIGZS1,DIGZS2
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CODINC/ DINC
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /WSYMBL/ SYMBL1,SYMBL2
             INTEGER*4 SYMBL1(20),SYMBL2(20)
      COMMON /WIDENT/ IDENT1,IDENT2
             INTEGER*4 IDENT1(20),IDENT2(20)
      COMMON /WNAMES/ WNAME1,WNAME2
             CHARACTER*20 WNAME1(20),WNAME2(20)
      COMMON /RLEVEL/ RELEV1,RELEV2
             REAL*4 RELEV1(20),RELEV2(20)
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /YSTART/ YSTART
      COMMON /WTHLEG/ WTHLEG
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      COMMON /LABELL/ LDSHAR,LDCORR,LDSHAM,LDCORM
             CHARACTER*4 LDCORM(20),LDCORR(20)
             CHARACTER*4 LDSHAM(20),LDSHAR(20)
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /IFSC/ IFSC
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
      COMMON /XTOPIM/ XTOPIM
      COMMON /TITLETDIP/ TITLETDIP
             CHARACTER*16 TITLETDIP
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
C
      MENU='TDIP'
      NISECT=0
      FLASTR = .TRUE.
   11 DO 12 I = 1, NLITH
   12 LITHFLAG(I) = 0
C
C          DATA ENTRY.
C
      CALL READAT(J1STIM,OPTION,LINE,5,NISECT)
      IF (OPTION .EQ. 'RE') RETURN
      IF (OPTION .NE. 'GO') GO TO 11
      J1STIM = 1
C
C          CALCULATION OF TRUE DIPS.
C
      CALL TRACE2(2)
      CALL TRUDIP(2, DPMIN, DPMAX, DELTDE)
      SUMTDG = DPMAX - DPMIN
C
C          CORRELATION BOX BOUNDARIES.
C
      CALL BXBOUN(YSTART)
C
C         CALCULATE SIZE OF PLOT.
C
      YSP2=YSTART
      XSIZE=0.5+XBOT
      NW = NPAIRS - 1
      WLEG = 0.0
      IF (LITHF .EQ. 1  ) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0) WLEG = WLEG + 0.2
      END IF
      YSIZE=(YSTART+NW*(0.1+(2.0*TKWD)+DSWH)+(SUMTDG/HSCALE)) - 0.05 +
     1                   IFSC*(WIDTHSCL + 0.2) + WLEG
      CALL TOOBIG(LINE,*11)
C
C          INITIALIZE PLOTTING DEVICE
C
      CALL RPTRAC(XSIZE,YSIZE+1.5+WTHLEG)
      IF (PLTSEL .EQ. 'V') THEN
         CALL MNMODE
         CALL BUSY(0,15,2,1)
      ENDIF
      CALL GMPINI(XSIZE,YSIZE+0.5+WTHLEG)
C
C          DIGITIZED LOG FILE READING
C
      DO 1600 NPS=2,2
      JJ=NPS
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
      CALL RWELLH
C
C          STRATIGRAPHIC COLUMN
C
      IF (IFSC .EQ. 1 ) CALL STRACO(STRACOFL, 1, YSP2)
C
      HDIST = XYTODC * SQRT((WLXLOC(ID1)-WLXLOC(ID2))**2+
     1                       (WLYLOC(ID1)-WLYLOC(ID2))**2)
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      IF (NPS .GE. 1) THEN
c      IF (NPS .EQ. 1) THEN
         CALL REALOG(LOG1,IL1,RLOG1,CLG1MN,CLG1MX)
         CALL REALOG(LOG3,IL3,RLOG3,SLG3MN,SLG3MX)
        ELSE
         DO 102 I=1,IL1
         RLOG1(I)=RLOG2(I)
         RLOG3(I)=RLOG4(I)
  102    CONTINUE
        ENDIF
      CALL REALOG(LOG2,IL2,RLOG2,CLG2MN,CLG2MX)
      CALL REALOG(LOG4,IL4,RLOG4,SLG4MN,SLG4MX)
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
C
C          DRAW THE WELL LOGS.
C
      IDSHAR = LDSHAR(JJ)
      IDCORR = LDCORR(JJ)
      IDSHAM = LDSHAM(JJ)
      IDCORM = LDCORM(JJ)
      DIGS1=DIGZS1-RELEV1(JJ)
      DIGS2=DIGZS2-RELEV2(JJ)
      CALL TOPBOT(JJ,TOPZR,BOTZR)
      YSP1=YSP2
      IF (LITHF .EQ. 1) CALL LITHANNOT(LFILEL, 1, YSP1,
     2                  RLOG3,IL3,DIGS1,TOPZR,BOTZR,YSP2)
      YSP1=YSP2
      CALL PPTSPE(IDENT1(JJ),WNAME1(JJ),RLOG3,IL3,RLOG1,IL1,DIGS1,
     1            TOPZR,BOTZR,YSP1,SYMBL1(JJ),JJ,NPAIRS,'R')
      CALL PLTDIP(TOPZR,BOTZR,YSP1, YSP2, NPS, DPMIN, 
     1               DPMAX, DELTDE)
 1600 CONTINUE
C
C          DISPLAY LEGEND
C
      TITLETDIP = 'TRUE DIP DIAGRAM'
      CALL LEGEND
      CALL INDEXM(NUWELL)
      LITHLEGTOT = 0
      DO 700 I = 1, NLITH
  700 LITHLEGTOT = LITHLEGTOT + LITHFLAG(I)
      HILITHLEG = XTOPIM - 1.1 - 0.9*(LITHLEGTOT+1)/2.0
      IF (LITHLEGTOT .GT. 0  .AND.  
     1    HILITHLEG .GE. 7.0 ) CALL LITHLEGEND
C
C          DISPLAY TITLE
C
      CALL DTITLE
C
C          CLOSE PLOTTING FILE.
C
      CALL GMPFIN
      CALL SCHOLD
      CALL XINITT
      GO TO 11
      END

C*********************************************************************
C
C                  CALCULATION OF TRUE DIPS.
C
C*********************************************************************
C
      SUBROUTINE TRUDIP(II, DIPMIN, DIPMAX, DELTAD)
C
C
C          TRUE DIPS
C
      CALL TDIPAP(II, DIPMIN, DIPMAX, DELTAD)
      RETURN
      END
C
C*********************************************************************
C
C          DISPLAY A CROSS-SECTION WITH LOG
C          POROSITY CORRECTED FOR SHALE EFFECT.
C
C*********************************************************************
C
      SUBROUTINE LPCFSE(J1STIM,NUWELL)
C
      INCLUDE 'log.inc'
C
C
      CHARACTER*2 OPTION
      INTEGER DEPSEQ
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
             INTEGER*4 LOG1,LOG2,LOG3,LOG4
      COMMON /DIGS/ DIGS1,DIGS2
             REAL*4 DIGS1,DIGS2
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /DIGZ12/  DIGZS1,DIGZS2
      COMMON /CODINC/ DINC
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /YSTART/ YSTART
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /WTHLEG/ WTHLEG
      COMMON /DCI/ DCI
             CHARACTER*1 DCI
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /LISHAL/ NSHAL3,NSHAL4
              REAL*4 NSHAL3(LOG_LENGTH), NSHAL4(LOG_LENGTH)
      COMMON /IFSC/ IFSC
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
      COMMON /RBOTZ/ RBOTZ
C            NAME OF FILE WITH ANNOTATION IN THE STRATIGRAPHIC COLUMN.
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
      COMMON /XTOPIM/ XTOPIM
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /TITLEPORO/ TITLEPORO
             CHARACTER*40 TITLEPORO
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
      include 'corrdb.inc'
C
      MENU='PORO'
      NISECT=0
      FLASTR = .FALSE.
      DO 12 I = 1, NLITH
   12 LITHFLAG(I) = 0
C
C          DATA ENTRY.
C
   11 CALL READAT(J1STIM,OPTION,LINE,7,NISECT)
      IF (OPTION .EQ. 'RE') RETURN
      IF (OPTION .NE. 'GO') GO TO 11
      J1STIM = 1
      IF ( IFAULT .EQ. 1 ) CALL FAULIN(LINE,*11)
      DCI = 'A'
C
C          CORRELATION BOX BOUNDARIES.
C
      CALL BXBOUN(YSTART)
C
C         INITIALIZE PLOTTING FILE.
C
      YSP2=YSTART
      XSIZE=0.5+XBOT
      IF (AELG .EQ. 0) THEN
          NW = 2
         ELSE
          NW = 1 + NPAIRS
         ENDIF
      IF (IFSC .EQ. 1) THEN
         WLEG = 0.2 + WIDTHSCL
       ELSE  IF(IFSC .EQ. 2) THEN
         WLEG = 0.2 + WIDTHSCR
       ELSE  IF(IFSC .EQ. 3) THEN
         WLEG = 0.4 + WIDTHSCL + WIDTHSCR
       ELSE
         WLEG = 0.0
      END IF
      IF (LITHF .EQ. 1  ) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 2) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 1) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 3) THEN
         WLEG = WLEG + 2.0
         IF (IFSC .EQ. 1  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
         IF (IFSC .EQ. 0) WLEG = WLEG + 0.4
      END IF
      YSIZE=(YSTART+NW*(0.1+(2.0*TKWD)+DSWH)+(SHDIST/HSCALE)) - 0.05
     1                          + WLEG
      CALL TOOBIG(LINE,*11)
      CALL RPSECT(XSIZE,YSIZE+1.5+WTHLEG)
      IF (PLTSEL .EQ. 'V') THEN
         CALL MNMODE
         CALL BUSY(0,15,2,1)
        ENDIF
      CALL GMPINI(XSIZE,YSIZE+1.0+WTHLEG)
C
C          PREPARE TABLE OF EQUIVALENCE LINES.
C
      CALL TEQLIN
C
C          PLOT WELL PAIR.
C
      DO 101 NPS=1,NPAIRS
      JJ=NPS
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
C
C          DIGITIZED LOG FILE READING
C
      CALL RWELLH
      IF (NPS .NE. 1) GO TO 222
C
C          STRATIGRAPHIC COLUMN
C
      IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) 
     1        CALL STRACO(STRACOFL, 1, YSP2)
C
  222 HDIST = HDISTC(JJ)
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      IF (NPS .EQ. 1) THEN
         CALL REALOG(LOG1,IL1,RLOG1,CLG1MN,CLG1MX)
         CALL REALOG(LOG3,IL3,RLOG3,SLG3MN,SLG3MX)
        ELSE
         DO 102 I=1,IL1
         RLOG1(I)=RLOG2(I)
         RLOG3(I)=RLOG4(I)
  102    CONTINUE
        ENDIF
      CALL REALOG(LOG2,IL2,RLOG2,CLG2MN,CLG2MX)
      CALL REALOG(LOG4,IL4,RLOG4,SLG4MN,SLG4MX)
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
      CALL TOPBOT(JJ+1,TOPZM,BOTZM)
      CALL TOPBOT(JJ,  TOPZR,BOTZR)
      YSP1=YSP2
      IF (JJ .EQ. 1  .AND.  (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)) 
     1   CALL LITHANNOT(LFILEL, 1, YSP1,RLOG3,IL3,DIGS1,
     2                  TOPZR,BOTZR,YSP2)
      YSP1=YSP2
C
C          PERCENT SHALE.
C
      MNIL13=MIN0(IL1,IL3)
      MNIL24=MIN0(IL2,IL4)
      ICS=DEPSEQ(TOPZR,DIGS1,DINC)
      ICE=DEPSEQ(BOTZR,DIGS1,DINC)
      IS=DEPSEQ(TOPZM,DIGS2,DINC)
      IE=DEPSEQ(BOTZM,DIGS2,DINC)
      CALL NSHALE(RLOG3,MNIL13,RLOG4,MNIL24,1,IL3,
     1            1,IL4,NSHAL3,NSHAL4)
C
C...  LOAD CORRELATION INTERPRETATION
C
      IF (CPNUMB(NPS) .LT. 1) GO TO 669
      FLASTR = .TRUE.
      CALL RCPHDR(CPNUMB(NPS))
      NZ=NNNNCP
      NNCOR=NZ
C
C          PLOT THE CORRELATIONS.
C
      CALL PLTCOR(RLOG1,IL1,RLOG2,IL2,RLOG3,IL3,RLOG4,IL4,DIGS1,DIGS2,
     1            TOPZR,BOTZR,TOPZM,BOTZM,YSP1,JJ,NPAIRS)
C
C          PRINT CORRELATION FILE
C
      CALL PRYNT(JJ,NP,NZ)
      IF (PLTSEL .EQ. 'V') CALL BUSY((100*JJ)/NPAIRS,15,2,1)
C
C          DRAW THE WELL LOGS.
C
  669 IF ((AELG .GT. 0 ) .OR. (JJ .EQ. 1)) THEN
         CALL PPTSPE(ID1,NAME1,RLOG3,IL3,RLOG1,IL1,DIGS1,
     1            TOPZR,BOTZR,YSP1,PSYMB1,JJ,NPAIRS,'R')
        END IF
      IF ( AELG .EQ. 0 ) THEN
         IF ( JJ .NE. NPAIRS) GO TO 660
         YSP2=0.05+YLEFT+(HDIST/HSCALE)
        ELSE
         YSP2=0.1+YSP1+(2.0*TKWD)+DSWH+(HDIST/HSCALE)
        END IF
      CALL PPTSPE(ID2,NAME2,RLOG4,IL4,RLOG2,IL2,DIGS2,
     1            TOPZM,BOTZM,YSP2,PSYMB2,JJ,NPAIRS,'M')
C
C          PLOT FAULTS.
C
  660 IF ( IFAULT .EQ. 1 )
     1   CALL PLTFAU(TOPZR, RBOTZ, TOPZM, RBOTZ, YSP1, JJ)
      IF (AELG .EQ. 0) YLEFT=YRIGHT
      IF ( AELG .EQ. 0  .AND. JJ .NE. NPAIRS)
     1      CALL WELLDY(YRIGHT,ID2,NAME2,PSYMB2,JJ,'M')
  101 CONTINUE
C
C          STRATIGRAPHIC COLUMN TO THE RIGHT OF THE CROSS-SECTION.    
C
      IF (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  THEN 
         IF (IFSC .EQ. 0  .OR.  IFSC .EQ. 1 ) THEN
            YSP1=YSIZE - 1.0
          ELSE
            YSP1=YSIZE - WIDTHSCR - 1.0
         END IF
         CALL LITHANNOT(LFILER, NPAIRS+1, YSP1,RLOG4,IL4,DIGS2,
     1                  TOPZM,BOTZM,YSP2)
      END IF
      IF (IFSC .EQ. 2  .OR.  IFSC .EQ. 3) THEN
         YSTART = YSIZE - WIDTHSCR
         CALL STRACO(STRACOFR, NPAIRS+1, YSP2)
      END IF
C
C          DISPLAY LEGENDS
C
      TITLEPORO = 'LOG POROSITY CORRECTED FOR SHALE EFFECT'
      CALL LEGEND           ! Commented out for Figure 11.17
      CALL INDEXM(NUWELL)   ! Commented out for Figure 11.17
C      XTOPIM = xsize + 1.4 ! Fig11.17
C      ysize = -4.0 + (ysize-1.0)/2.0   ! Fig11.17
      LITHLEGTOT = 0  !   Following lines commented out for Fig11.17
      DO 700 I = 1, NLITH
  700 LITHLEGTOT = LITHLEGTOT + LITHFLAG(I)
      HILITHLEG = XTOPIM - 1.1 - 0.9*(LITHLEGTOT+1)/2.0
      IF (LITHLEGTOT .GT. 0  .AND.  
     1    HILITHLEG .GE. 7.0 ) CALL LITHLEGEND
      CALL HORSCALE
C
C          DISPLAY TITLE
C
      CALL DTITLE
C
C          CLOSE PLOTTING FILE.
C
      CALL GMPFIN
      CALL SCHOLD
      CALL XINITT
      GO TO 11
      END
C
C*********************************************************************
C
C          DISPLAY A LITHOSTRATIGRAPHIC CROSS-SECTION.  THE PROGRAM
C          AUTOMATICALLY IDENTIFIS LEVELS WITH MORE THAN 50% SHALE.
C          EXTERNAL INFORMATION PROVIDED THROUGH A FILE IS USED TO
C          IDENTIFY THE LITHOLOGY FOR THE CLEAN FRACTIONS. 
C
C*********************************************************************
C
      SUBROUTINE LITH2(J1STIM,NUWELL)
C
      INCLUDE 'log.inc'
C
C
      CHARACTER*2 OPTION
      INTEGER DEPSEQ
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
             INTEGER*4 LOG1,LOG2,LOG3,LOG4
      COMMON /DIGS/ DIGS1,DIGS2
             REAL*4 DIGS1,DIGS2
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /DIGZ12/  DIGZS1,DIGZS2
      COMMON /CODINC/ DINC
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /YSTART/ YSTART
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /WTHLEG/ WTHLEG
      COMMON /DCI/ DCI
             CHARACTER*1 DCI
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /LISHAL/ NSHAL3,NSHAL4
              REAL*4 NSHAL3(LOG_LENGTH), NSHAL4(LOG_LENGTH)
      COMMON /IFSC/ IFSC
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
      COMMON /RBOTZ/ RBOTZ
C            NAME OF FILE WITH ANNOTATION IN THE STRATIGRAPHIC COLUMN.
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
      COMMON /XTOPIM/ XTOPIM
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /TITLELIT2/ TITLELIT2
             CHARACTER*9 TITLELIT2
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
      include 'corrdb.inc'
C
      MENU='LIT2'
      NISECT=0
      FLASTR = .FALSE.
   11 DO 12 I = 1, NLITH
   12 LITHFLAG(I) = 0
C
C          DATA ENTRY.
C
      CALL READAT(J1STIM,OPTION,LINE,8,NISECT)
      IF (OPTION .EQ. 'RE') RETURN
      IF (OPTION .NE. 'GO') GO TO 11
      J1STIM = 1
      IF ( IFAULT .EQ. 1 ) CALL FAULIN(LINE,*11)
      DCI = 'A'
C
C          READ IN LITHOLOGICAL BOUNDARIES.
C
      CALL REACOLITH(LINE,*11)
C
C          CORRELATION BOX BOUNDARIES.
C
      CALL BXBOUN(YSTART)
C
C         INITIALIZE PLOTTING FILE.
C
      YSP2=YSTART
      XSIZE=0.5+XBOT
      IF (AELG .EQ. 0) THEN
          NW = 2
         ELSE
          NW = 1 + NPAIRS
         ENDIF
      IF (IFSC .EQ. 1) THEN
         WLEG = 0.2 + WIDTHSCL
       ELSE  IF(IFSC .EQ. 2) THEN
         WLEG = 0.2 + WIDTHSCR
       ELSE  IF(IFSC .EQ. 3) THEN
         WLEG = 0.4 + WIDTHSCL + WIDTHSCR
       ELSE
         WLEG = 0.0
      END IF
      IF (LITHF .EQ. 1  ) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 2) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0  .OR. IFSC .EQ. 1) WLEG = WLEG + 0.2
       ELSE  IF(LITHF .EQ. 3) THEN
         WLEG = WLEG + 2.0
         IF (IFSC .EQ. 1  .OR. IFSC .EQ. 2) WLEG = WLEG + 0.2
         IF (IFSC .EQ. 0) WLEG = WLEG + 0.4
      END IF
      YSIZE=(YSTART+NW*(0.1+(2.0*TKWD)+DSWH)+(SHDIST/HSCALE)) - 0.05
     1                          + WLEG
      CALL TOOBIG(LINE,*11)
      CALL RPSECT(XSIZE,YSIZE+1.5+WTHLEG)
      IF (PLTSEL .EQ. 'V') THEN
         CALL MNMODE
         CALL BUSY(0,15,2,1)
        ENDIF
      CALL GMPINI(XSIZE,YSIZE+1.0+WTHLEG)
C
C          PREPARE TABLE OF EQUIVALENCE LINES.
C
      CALL TEQLIN
C
C          TRACE MARKERS.
C
      CALL TRACIN
C
C          PLOT WELL PAIRS.
C
      DO 101 NPS=1,NPAIRS
      JJ=NPS
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
C
C          DIGITIZED LOG FILE READING
C
      CALL RWELLH
      IF (NPS .NE. 1) GO TO 222
C
C          STRATIGRAPHIC COLUMN
C
      IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) 
     1        CALL STRACO(STRACOFL, 1, YSP2)
C
  222 HDIST = HDISTC(JJ)
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      IF (NPS .EQ. 1) THEN
         CALL REALOG(LOG1,IL1,RLOG1,CLG1MN,CLG1MX)
         CALL REALOG(LOG3,IL3,RLOG3,SLG3MN,SLG3MX)
        ELSE
         DO 102 I=1,IL1
         RLOG1(I)=RLOG2(I)
         RLOG3(I)=RLOG4(I)
  102    CONTINUE
        ENDIF
      CALL REALOG(LOG2,IL2,RLOG2,CLG2MN,CLG2MX)
      CALL REALOG(LOG4,IL4,RLOG4,SLG4MN,SLG4MX)
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
      CALL TOPBOT(JJ+1,TOPZM,BOTZM)
      CALL TOPBOT(JJ,  TOPZR,BOTZR)
      YSP1=YSP2
      IF (JJ .EQ. 1  .AND.  (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)) 
     1   CALL LITHANNOT(LFILEL, 1, YSP1,RLOG3,IL3,DIGS1,
     2                  TOPZR,BOTZR,YSP2)
      YSP1=YSP2
C
C          PERCENT SHALE.
C
      MNIL13=MIN0(IL1,IL3)
      MNIL24=MIN0(IL2,IL4)
      ICS=DEPSEQ(TOPZR,DIGS1,DINC)
      ICE=DEPSEQ(BOTZR,DIGS1,DINC)
      IS=DEPSEQ(TOPZM,DIGS2,DINC)
      IE=DEPSEQ(BOTZM,DIGS2,DINC)
      CALL NSHALE(RLOG3,MNIL13,RLOG4,MNIL24,1,IL3,
     1            1,IL4,NSHAL3,NSHAL4)
C
C...  LOAD CORRELATION INTERPRETATION
C
      IF (CPNUMB(NPS) .LT. 1) GO TO 669
      FLASTR = .TRUE.
      CALL RCPHDR(CPNUMB(NPS))
      NZ=NNNNCP
      NNCOR=NZ
C
C          PLOT THE CORRELATIONS.
C
      CALL PLTCOR(RLOG1,IL1,RLOG2,IL2,RLOG3,IL3,RLOG4,IL4,DIGS1,DIGS2,
     1            TOPZR,BOTZR,TOPZM,BOTZM,YSP1,JJ,NPAIRS)
C
      IF (PLTSEL .EQ. 'V') CALL BUSY((100*JJ)/NPAIRS,15,2,1)
C
C          DRAW THE WELL LOGS.
C
  669 IF ((AELG .GT. 0 ) .OR. (JJ .EQ. 1)) THEN
         CALL PPTSPE(ID1,NAME1,RLOG3,IL3,RLOG1,IL1,DIGS1,
     1            TOPZR,BOTZR,YSP1,PSYMB1,JJ,NPAIRS,'R')
        END IF
      IF ( AELG .EQ. 0 ) THEN
         IF ( JJ .NE. NPAIRS) GO TO 660
         YSP2=0.05+YLEFT+(HDIST/HSCALE)
        ELSE
         YSP2=0.1+YSP1+(2.0*TKWD)+DSWH+(HDIST/HSCALE)
        END IF
      CALL PPTSPE(ID2,NAME2,RLOG4,IL4,RLOG2,IL2,DIGS2,
     1            TOPZM,BOTZM,YSP2,PSYMB2,JJ,NPAIRS,'M')
C
C          PLOT FAULTS.
C
  660 IF ( IFAULT .EQ. 1 )
     1   CALL PLTFAU(TOPZR, RBOTZ, TOPZM, RBOTZ, YSP1, JJ)
      IF (AELG .EQ. 0) YLEFT=YRIGHT
      IF ( AELG .EQ. 0  .AND. JJ .NE. NPAIRS)
     1      CALL WELLDY(YRIGHT,ID2,NAME2,PSYMB2,JJ,'M')
  101 CONTINUE
C
C          STRATIGRAPHIC COLUMN TO THE RIGHT OF THE CROSS-SECTION.    
C
      IF (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  THEN 
         IF (IFSC .EQ. 0  .OR.  IFSC .EQ. 1 ) THEN
            YSP1=YSIZE - 1.0
          ELSE
            YSP1=YSIZE - WIDTHSCR - 1.0
         END IF
         CALL LITHANNOT(LFILER, NPAIRS+1, YSP1,RLOG4,IL4,DIGS2,
     1                  TOPZM,BOTZM,YSP2)
      END IF
      IF (IFSC .EQ. 2  .OR.  IFSC .EQ. 3) THEN
         YSTART = YSIZE - WIDTHSCR
         CALL STRACO(STRACOFR, NPAIRS+1, YSP2)
      END IF
C
C          PRINT FILE WITH TRACING OF BOUNDARIES
C
      CALL PRITRA
C
C          DISPLAY LEGENDS
C
      TITLELIT2 = 'LITHOLOGY'
      
C      TITLELIT2 = '  '      ! Publication.  Comment out the next two.
      CALL LEGEND
      CALL INDEXM(NUWELL)
C      XTOPIM = xsize - 7.0 ! Publication
C      ysize = ysize - 1.7   ! Publication
C      XTOPIM = xsize - 11.0 ! Publication
C      ysize = ysize + 1.1   ! Publication
      LITHLEGTOT = 0
      DO 700 I = 1, NLITH
  700 LITHLEGTOT = LITHLEGTOT + LITHFLAG(I)
      HILITHLEG = XTOPIM - 1.1 - 0.9*(LITHLEGTOT+1)/2.0
      IF (LITHLEGTOT .GT. 0  .AND.  
     1    HILITHLEG .GE. 7.0 ) CALL LITHLEGEND
      CALL HORSCALE
C
C          DISPLAY TITLE
C
      CALL DTITLE
C
C          CLOSE PLOTTING FILE.
C
      CALL GMPFIN
      CALL SCHOLD
      CALL XINITT
      GO TO 11
      END
