/* @(#) xi.c	ra/kl	1.0	6/89
 * 
 */
/*       DEFINITION OF CORRELATOR WINDOW USING BLACK BACKGROUND    */
/*       ITS NOT USED DIRECTLY IN THE MAKEFILE.                    */
/*       COPY INTO xi.c IN THE MAKEFILE FOR COMPILATION            
*/
#include <stdio.h>
#include "xi.h"


/* all the global X-Windows stuff    */
static Display	*display;   /* infos about server and its screens */
static Window	window = (Window) 0;
static int	screen;
static int	wPosX = 0, wPosY = 0;
static int	wWidth = 10, wHeight = 10, wPosSizeSet = FALSE;
static char     wTitle[] = "Correlator v 5.2, Nov. 2002\0";
static GC       gc;
static int      colorNo = 0;
static int      colorBlack = 0;
static Colormap cmap;
static int      colors[MAXCOLORS];
static XFontStruct  *font1224,*fontgraf;
static int     rband = False;
static XPoint   xyr[2];

void xwinit_()
{
   char *getenv();
   char *server;

   if (!(server=getenv("DISPLAY"))) {
        fprintf(stderr,"WARNING -- environment var \"DISPLAY\" not set\n");
        fprintf(stderr,"  Setting it to \"unix:0\".\n");
        if (!putenv("DISPLAY=unix:0")) {
              fprintf(stderr,"\nERROR -- unable to set \"DISPLAY\" var\n");
              exit(1);
        }
        server = getenv("DISPLAY");
   }


/*****  try to connect client to an X server, that means open a display */
   if (!(display = XOpenDisplay(server)))
   {  /***** if conection not possible */
       fprintf (stderr,
	   " cannot connect to the X-server %s\n", XDisplayName(server));
       exit (1);
   }
   screen = DefaultScreen(display);

/* 9X15 10X20 12X24 terminal   */
/* 6x10 6x12 6x13 7x13         */
/*  use xlsfonts to list available fonts  */
   //font1224 = XLoadQueryFont(display, "12X24");
   //font612 = XLoadQueryFont(display, "6x12");
   font1224 = XLoadQueryFont(display, "9x15");
   if (font1224 == NULL) {
        printf("xwinit - no 12X24 font\n");
        font1224 = XLoadQueryFont(display, "terminal14");
        if (font1224 == NULL) printf("xwinit - no terminal14 font\n");
      }
   fontgraf = XLoadQueryFont(display, "6x12");
}

void xwend_()
{
        XFreeFont(display,font1224);
        XFreeFont(display,fontgraf);
	XCloseDisplay(display);
}



void xwstrt_(wide,high)
int *wide, *high;
{
    unsigned long		attrMask;
    XSetWindowAttributes	wAttributes;
    XEvent			dummyEvent;
    XSizeHints			wSizeHints;
    XGCValues			theseGCValues;


/* If we already have a window, erase previous contents and return */
	if (window) {
		XClearWindow(display,window);
	} else {
/***** Else set up window parameters. define the events on which to react  */
	        cmap = DefaultColormap(display,screen);
                getcolor();
       		wAttributes.border_pixel     = WhitePixel(display,screen);
       		wAttributes.background_pixel = BlackPixel(display ,screen);
       		wAttributes.colormap = cmap ;

/* We don't process X events other than exposure 
		wAttributes.event_mask = EnterWindowMask | ExposureMask; 
*/
		wAttributes.event_mask = ExposureMask    | KeyPressMask |
                                         ButtonPressMask | ButtonReleaseMask |
                                         PointerMotionMask ; 
		attrMask = CWBackPixel | CWBorderPixel | CWColormap
						       | CWEventMask;

/*****  create the window  */
		window = XCreateWindow(display, RootWindow(display,screen),
				  wPosX, wPosY, wWidth, wHeight,
                                  BORDERWIDTH, CopyFromParent,
				  InputOutput, DefaultVisual(display, screen),
				  attrMask, &wAttributes);
		XSetWindowBackground (display, window,
			      BlackPixel(display ,screen));

/*****  Give size hints */ 
		wSizeHints.flags = (USPosition | USSize);
		wSizeHints.x = 0;
		wSizeHints.y = 0;
		wSizeHints.height = *high;
		wSizeHints.width = *wide;
		
	
		XSetStandardProperties (display, window, wTitle, 
				wTitle, None,0,0, &wSizeHints);


/*****  create the graphic context  */
		theseGCValues.line_style = LineSolid;
		theseGCValues.graphics_exposures = TRUE;
		theseGCValues.foreground = BlackPixel(display,screen);
		theseGCValues.background = WhitePixel(display,screen);

		gc = XCreateGC (display, window,
		      GCLineStyle|GCGraphicsExposures|GCForeground|GCBackground,
		      &theseGCValues);

/*****  map the window to the display and make it visible  */
		XMapWindow (display, window);
		while (  XNextEvent (display,&dummyEvent)  )
		   if (dummyEvent.type == Expose) break;
	}

    XSetInputFocus(display,window,RevertToParent,CurrentTime);

}

void swinvs_(ivis)
int *ivis;
{
  XEvent  dummyEvent;
   
  if (*ivis == 0)
     {
       XMapWindow (display, window);
       while (  XNextEvent (display,&dummyEvent)  )
	  if (dummyEvent.type == Expose) break;

       XSetInputFocus(display,window,RevertToParent,CurrentTime);
     }
  if (*ivis != 0)
     {
       XUnmapWindow(display,window);
     }
  XFlush(display);
}

void setfnt_(isize)
int *isize;
{

/*****  set font to gc   */
     if (*isize == 2 && font1224 != 0) 
         {
          XSetFont( display, gc, font1224->fid);
         }
     if (*isize == 1 && fontgraf != 0) 
         {
          XSetFont( display, gc, fontgraf->fid);
         }
}

void xwstop_()
{
	XFlush(display);
}

void xwtext_(ix,iy,string,l)
     int *ix,*iy;
     char *string;
     int *l;
{
   if (rband) XSetFunction(display, gc, GXcopy);
   XDrawString(display, window, gc, *ix, *iy, string, *l);
   if (rband) XSetFunction(display, gc, GXxor);
}

void xbellx_()
{
    XBell(display,100);
    XFlush(display);
}

void rdkey_(cc)
char *cc;
{
  int count;
  char buffer[40];
  KeySym keysym;
  XComposeStatus compose;
  XEvent kevent;
  int k;
  char ck;
  
  XFlush(display);
  while(1) {
  XNextEvent(display,&kevent);
  switch(kevent.type){
      case KeyPress:
        count = XLookupString( (XKeyEvent *)&kevent,buffer,40,&keysym,&compose);
        if (keysym == XK_BackSpace) keysym = 8;
        if (keysym == XK_Delete   ) keysym = 8;
        if (keysym == XK_Left     ) keysym = 8;
        if (keysym == XK_Return   ) keysym = 10;
        k = keysym;
        ck = k;
        *cc = ck;
        return;
      default:
        break;
      }
   } 
}

void sginsp_(ix,iy)
int *ix,*iy;
{
  xyr[0].x = *ix / 4;
  xyr[0].y = (3072-*iy)/4;
  xyr[1] = xyr[0];
  XDrawLines(display, window, gc, xyr, 2, CoordModeOrigin);
  XFlush(display);
 }

void sginrb_(irbmod)
int *irbmod;
{
/*  fprintf(stderr,"*** sginrb - irbmod = %d %d\n",*irbmod,rband); */
  if (*irbmod == 0) 
   {
     XSetFunction(display, gc, GXcopy);
     if (rband) XUngrabServer(display);
     rband = False;
   }  /* end *irbmod == 0  */

  if (*irbmod != 0) 
   {
     XSetFunction(display, gc, GXxor);
     if (!rband) XGrabServer(display);
     rband = True;
   }  /* end *irbmod == 2  */
  XFlush(display);
     
}   /* end sginrb */
	
void gmouse_(x,y,button)
int *x,*y;
int *button;
{

  XEvent bevent, report;
  int ixx,iyy,ibb;
  Window root, child;
  int m_x,m_y;
  int win_x,win_y;
  unsigned int mask;
 
  if (rband) {
     xyr[1].x = xyr[0].x;
     xyr[1].y = xyr[0].y;
     XDrawLines(display, window, gc, xyr, 2, CoordModeOrigin);
     XFlush(display);
    }
  XFlush(display);
  while(1) {
    XNextEvent(display,&bevent);
    switch(bevent.type){
      case ButtonPress:
        if (rband) {
           XDrawLines(display, window, gc, xyr, 2, CoordModeOrigin);
           XFlush(display);
          }
        ixx = bevent.xbutton.x;
        iyy = bevent.xbutton.y;
        ibb = bevent.xbutton.button;
        *x = ixx;
        *y = iyy;
        *button = ibb;
        return;
      case MotionNotify:
        if (rband)
          {
            XDrawLines(display, window, gc, xyr, 2, CoordModeOrigin);
            xyr[1].x = bevent.xbutton.x;
            xyr[1].y = bevent.xbutton.y;
            XDrawLines(display, window, gc, xyr, 2, CoordModeOrigin);
            XFlush(display);
          }
        break;
	
    } /* end of switch(bevent.type)  */
  }    /* end of while(1)   */
}         /* end of gmouse     */
  
void xwline_(xy, n)
	XPoint *xy;	/* Array of polyline vertices */
	int *n;		/* Number of vertices */
{
	XDrawLines(display, window, gc, xy, *n, CoordModeOrigin);	
}

void xlinew_(x1,y1,x2,y2)
	int *x1,*y1,*x2,*y2;
{
	XDrawLine(display, window, gc, *x1, *y1, *x2, *y2);	
}

void xwpoly_(xy, n, color)
	XPoint *xy;	/* Array of polygon vertices */
	int *n;		/* Number of vertices */
	int *color;	/* Color number */
{
	int pcolor;
#ifndef NDEBUG
/*      fprintf(stderr,"Using color %d\n",*color); */
#endif
	if ( (pcolor = ValidColor(*color)) != (*color) ) {
		fprintf(stderr,"Invalid color number %d ... set to %d\n",
		*color, pcolor);
	}
	XSetForeground(display,gc, colors [pcolor]);
	XFillPolygon(display, window,gc, xy, *n, Nonconvex, CoordModeOrigin);
	XSetForeground(display,gc, colors [colorNo]);
}


void xwnpen_(color)
int *color;
{


/*	if ( (colorNo = ValidColor(*color)) != (*color - 1 ) ) {
		fprintf(stderr,"Invalid color number %d ... set to %d\n",
		*color, colorNo+1);
	}  */
        colorNo = *color;
	XSetForeground(display,gc, colors [colorNo]);
}

void xfillr_(xl,yb,w,h,icc)
int *xl,*yb;
int *w,*h;
int *icc;
{
     if (rband) XSetFunction(display, gc, GXcopy);
     XSetForeground(display,gc, colors[*icc]);
     XFillRectangle(display,window,gc,*xl,*yb,*w,*h);
     XSetForeground(display,gc, colors [colorNo]);
     if (rband) XSetFunction(display, gc, GXxor);
}



/* getcolor() function after ADRIAN NYE (1988): Xlib Programming Manual.- pp.
   186-187 */
void getcolor ()
{
	int i;
	static char *name[] = {
                "black",  
                "slate blue", 
                "sky blue",                                                     
                "green",  
                "yellow",      
                "orange",                                                       
                "medium violet red",
                "cyan", 
                "red", 
                "medium turquoise",                                             
                "medium aquamarine",                                            
                "spring green",                           
                "lime green",                                                   
                "forest green",                                          
                "medium spring green",                                          
                "aquamarine",                                                   
                "green yellow",                                                 
                "goldenrod",                                               
                "tan",                                                          
                "medium violet red",                                    
                "white",
                "navy blue",                                                   
                "blue"

};
	XColor exact_def;
	
	for (i=0; i<MAXCOLORS; i++) {
   /* return the RGB values of the named colors */
		if (!XParseColor (display, cmap, name[i], &exact_def)){
		   printf("xi XParse-error %d\n",i);
                   XParseColor (display, cmap, "white", &exact_def);
/*		   exit (1); */
 		}
   /* return the nearest available color */
		if (!XAllocColor (display, cmap, &exact_def)) {
		   printf("xi XAlloc-error\n");
		   exit (1);
 		}
   /* store the color in the colormap 
		if (!XStoreColor (display, cmap, &exact_def)){
		   printf("xi XStore-error\n");
		   exit (1);
 		}
*/
		colors [i] = exact_def.pixel;
	}
}

int ValidColor(color)
int color;
/* Make sure color is in valid color range */
{
	return BETWEEN(0,color,MAXCOLORS);
}

